Rice.require 'extable'
Rice.require 'exstring'

local string = string
local table = table

module 'CDBTableItem'

function escape(str)
  return str:gsub('[:;\\]', {[':'] = '\\c', [';'] = '\\r', ['\\'] = '\\\\'})
end

function unescape(str)
  return str:gsub('\\[cr\\]', {['\\c'] = ':', ['\\r'] = ';', ['\\\\'] = '\\'})
end

function encode_row(row)
  return table.concat(table.map(row, function(k, v) return escape(v) end), ':') .. ';'
end

function decode_row(str)
  return table.map(str:gsub(';', ':'):split(':'), function(k, v) return unescape(v) end)
end

function encode_table(tbl)
  return table.concat(table.map(tbl, function(k, v) return encode_row(v) end))
end

function decode_table(str)
  return table.map(str:split(';'), function(k ,v) return decode_row(v .. ';') end)
end

return true
