Rice.require 'Rice.ExtensionInfo'

class 'ExtensionLoader'

function ExtensionLoader:__init(file_path, func_name)
  self.file_path = file_path and file_path:gsub('^/', '') or '' 
  self.func_name = func_name or ''
  self.extension_names = Rice.ExtensionInfo.names() or {}
end

function ExtensionLoader:extensions()
  return coroutine.wrap( function()
    for i, name in ipairs(self.extension_names) do
      if(Rice.require('extension.' .. name .. '.' .. self.file_path)) then
        local func = _G[name] and _G[name][self.func_name] or nil
        if(type(func) == 'function') then
          coroutine.yield(name, func)
        end
      end
    end
    return nil
  end )
end


return true

