Rice.require 'Native'
Rice.require 'Rice.CapsDB'
Rice.require 'Rice.PrintTicket'
Rice.require 'Rice.PaperDB'
Rice.require 'Rice.Devmode'
Rice.require 'TableConverter'
Rice.require 'printticket_core'
Rice.require 'devmode_to_printticket_table'

function convert_all_pt_tables( item_table , option_info, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value )
	local result_all_tables = {}
	local count = 1

	for k in pairs( dev2pt_table ) do
		if( nil ~= item_table[k] ) then
			if( ( 'phf_print' ~= k and 'outputcompresseddataexceptpjl' ~= k )									or
				( 'phf_print' == k and 'on' == headerfootersupport_value )										or
				( 'outputcompresseddataexceptpjl' == k and 'on' == enable_outputcompresseddataexceptpjl_value ) ) then
				local tbl = convert_ptpc_table( item_table, dev2pt_table[k] ,option_info)
				if( nil ~= tbl ) then
					result_all_tables[count] = tbl
					count = count + 1
				end
			end
		end
	end

	return result_all_tables
end

function change_pt_minikeyword_prefix( pt ) 
	local mini_prefix = 'ns0000:'
	local mini_prefix1 = 'ns0001:'
	local feat_tbl = pt.enum_features()
	
	for w in pairs(feat_tbl) do
		local result_feat = 0
		local opt_tbl = pt.enum_options( feat_tbl[w] )
		local temp_feat = feat_tbl[w]
		if( nil ~= string.find( feat_tbl[w], mini_prefix ) ) then
			for v in pairs(feat_tbl) do
				if( string.gsub( temp_feat, mini_prefix, mini_prefix1, 1 )  == feat_tbl[v] ) then
					result_feat = 1
					break;
				end
			end
		end
		
		if( result_feat == 0 ) then
			for v in pairs(opt_tbl) do
				if( nil ~= string.find( opt_tbl[v], mini_prefix ) ) then
					pt.set_attribute(	"/psf:PrintTicket/psf:Feature/psf:Option[@name='" .. opt_tbl[v] .. "']",
									'name',
									string.gsub( opt_tbl[v], mini_prefix, "ns0001:", 1 ),
									nil )
				end
			end
			if( nil ~= string.find( feat_tbl[w], mini_prefix ) ) then
				pt.set_attribute(	"/psf:PrintTicket/psf:Feature[@name='" .. feat_tbl[w] .. "']",
								'name',
								string.gsub( feat_tbl[w], mini_prefix, "ns0001:", 1 ),
								nil )
			end
		end
	end

	local paraminit_tbl = pt.enum_parameterinit()
		
	for w in pairs(paraminit_tbl) do
		local result_paraminit = 0
		local temp_paraminit = paraminit_tbl[w]
		if( nil ~= string.find( paraminit_tbl[w], mini_prefix ) ) then
			for v in pairs(paraminit_tbl) do
				if( string.gsub( temp_paraminit, mini_prefix, mini_prefix1, 1 )  == paraminit_tbl[v] ) then
					result_paraminit = 1
					break;
				end
			end
		end
		
		if( result_paraminit == 0 ) then
			if( nil ~= string.find( paraminit_tbl[w], mini_prefix ) ) then
				pt.set_attribute(	"/psf:PrintTicket/psf:ParameterInit[@name='" .. paraminit_tbl[w] .. "']",
								'name',
								string.gsub( paraminit_tbl[w], mini_prefix, "ns0001:", 1 ),
								nil )
			end
		end
	end
end

function act_devmode_to_printticket( architecture_type )
	local result = 'false'
	local cdb = Rice.CapsDB
	local pt = Rice.PrintTicket
	local paper_db = Rice.PaperDB

	if pt and cdb and paper_db then
		local option_info = create_option_info(cdb, paper_db)

		if( "monolithic" ~= architecture_type and 
			pt.get_prefix(xmlns_table.ns0001) == 'ns0000' ) then
			local ns_temp = xmlns_table.ns0000 
			xmlns_table.ns0000 = xmlns_table.ns0001 
			xmlns_table.ns0001 = ns_temp
		end
		
		set_namespace(pt)

		if( "monolithic" == architecture_type ) then
			pt.set_element(	"/",
							"psf:PrintTicket",
							xmlns_table.psf )
			set_root_attribute(pt,printticket_xpath)
		else
			pt.set_attribute(	printticket_xpath,
								'xmlns:ns0000',
								xmlns_table.ns0001,
								xmlns_table.psf )
			pt.set_attribute(	printticket_xpath,
								'xmlns:ns0001',
								xmlns_table.ns0000,
								xmlns_table.psf )

		end

		change_pt_minikeyword_prefix( pt )

		for i, v in pairs(dev2pt_table) do
			if( 'nil'	~= type( v['tag'] ) ) then
				pt.delete_node("/psf:PrintTicket/" .. v['tag'] .. "[@name='" .. v['attribute']['value'] .. "']")
			else
				for j, w in ipairs(v) do
					pt.delete_node("/psf:PrintTicket/" .. w['tag'] .. "[@name='" .. w['attribute']['value'] .. "']")
				end
			end
		end

		local all_item_tbl = get_all_items(cdb)

		local collate_val = '0'
		local devmode = Rice.Devmode
		if devmode then
			collate_val = devmode.get('dmCollate')
		end
		all_item_tbl['dmCollate'] = collate_val
		
		local headerfootersupport_value = cdb.get('headerfootersupport')
		local enable_outputcompresseddataexceptpjl_value = cdb.get('enable_outputcompresseddataexceptpjl')
		local converted_all_pt_tables = convert_all_pt_tables(all_item_tbl, option_info, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value)

		generate_printtickets(pt,converted_all_pt_tables)

		result = 'true'
	end

	return result
end
