Rice.require 'Native'
Rice.require 'Rice.CapsDB'
Rice.require 'Rice.PaperDB'
Rice.require 'Rice.PrintCapabilities'
Rice.require 'TableConverter'
Rice.require 'printticket_core'
Rice.require 'get_printcapabilities_table'


function add_pscustommedia_to_converted_table( pc_table, item_tbl )
	
	local array_num = 0
	
	for i,v in pairs( pc_table ) do
		if( nil ~= v and
			nil ~= v[1] and
			nil ~= v[1]['attribute'] and
			nil ~= v[1]['attribute']['value'] and
			'psk:PageMediaSize' == v[1]['attribute']['value']) then
				array_num = i
				break
		
		end
	end
	
	if( 0 ~= array_num							and
		nil ~= pc_table[array_num][1]['children']	) then
			
			table.insert(	pc_table[array_num][1]['children'],
							{
								tag			= 	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	'psk:PSCustomMediaSize'
								},
								children = {
									{
										tag			= 	'psf:ScoredProperty',
										attribute	=
										{
											key		=	'name',
											value	=	'psk:PSWidth'
										},
										children = {
											tag			=	'psf:ParameterRef',
											attribute	=
											{
												key		=	'name',
												value	=	'psk:PageMediaSizePSWidth'
											}
										}
									},
									{
										tag			= 	'psf:ScoredProperty',
										attribute	=
										{
											key		=	'name',
											value	=	'psk:PSHeight'
										},
										children = {
											tag			=	'psf:ParameterRef',
											attribute	=
											{
												key		=	'name',
												value	=	'psk:PageMediaSizePSHeight'
											}
										}
									},
									{
										tag			= 	'psf:ScoredProperty',
										attribute	=
										{
											key		=	'name',
											value	=	'psk:PSWidthOffset'
										},
										children = {
											tag			=	'psf:ParameterRef',
											attribute	=
											{
												key		=	'name',
												value	=	'psk:PageMediaSizePSWidthOffset'
											}
										}
									},
									{
										tag			= 	'psf:ScoredProperty',
										attribute	=
										{
											key		=	'name',
											value	=	'psk:PSHeightOffset'
										},
										children = {
											tag			=	'psf:ParameterRef',
											attribute	=
											{
												key		=	'name',
												value	=	'psk:PageMediaSizePSHeightOffset'
											}
										}
									},
									{
										tag			= 	'psf:ScoredProperty',
										attribute	=
										{
											key		=	'name',
											value	=	'psk:PSOrientation'
										},
										children = {
											tag			=	'psf:ParameterRef',
											attribute	=
											{
												key		=	'name',
												value	=	'psk:PageMediaSizePSOrientation'
											}
										}
									},
									{
										tag			= 	'psf:Property',
										attribute	=
										{
											key		=	'name',
											value	=	'psk:DisplayName'
										},
										children = {
											tag			=	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:string'
											},
											text = 'PostScript custompapersize'
										}
									}
								}
							}
						)
	end
	
	local default_val = tonumber(item_tbl['custompapersize_width_mm']['default'])
	if(nil ~= default_val)then
		item_tbl['custompapersize_width_mm']['default'] = tostring(default_val)
	else
		item_tbl['custompapersize_width_mm']['default'] = '0'
	end
	
	local max_val = tonumber(item_tbl['custompapersize_width_mm']['max'])
	if(nil ~= max_val)then
		item_tbl['custompapersize_width_mm']['max'] = tostring(max_val)
	else
		item_tbl['custompapersize_width_mm']['max'] = '0'
	end
	
	local min_val = tonumber(item_tbl['custompapersize_width_mm']['min'])
	if(nil ~= min_val)then
		item_tbl['custompapersize_width_mm']['min'] = tostring(min_val)
	else
		item_tbl['custompapersize_width_mm']['min'] = '0'
	end
	
	local default_val = tonumber(item_tbl['custompapersize_length_mm']['default'])
	if(nil ~= default_val)then
		item_tbl['custompapersize_length_mm']['default'] = tostring(default_val)
	else
		item_tbl['custompapersize_length_mm']['default'] = '0'
	end
	
	local max_val = tonumber(item_tbl['custompapersize_length_mm']['max'])
	if(nil ~= max_val)then
		item_tbl['custompapersize_length_mm']['max'] = tostring(max_val)
	else
		item_tbl['custompapersize_length_mm']['max'] = '0'
	end
	
	local min_val = tonumber(item_tbl['custompapersize_length_mm']['min'])
	if(nil ~= min_val)then
		item_tbl['custompapersize_length_mm']['min'] = tostring(min_val)
	else
		item_tbl['custompapersize_length_mm']['min'] = '0'
	end
	
	table.insert(	pc_table,
					{
						{
							tag		=	'psf:ParameterDef',
							attribute	=
							{
								key		=	'name',
								value	=	'psk:PageMediaSizePSWidth'
							},
							children	= 
							{
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:DataType'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:QName'
										},
										text	=	'xsd:integer'
									}
								},
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:UnitType'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:string'
										},
										text	=	'microns'
									}
								},
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:Multiple'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:integer'
										},
										text	=	'1'
									}
								},
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:MaxValue'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:integer'
										},
										text	=	item_tbl['custompapersize_width_mm']['max']
									}
									
								},
								
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:MinValue'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:integer'
										},
										text	=	item_tbl['custompapersize_width_mm']['min']
									}
								},
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:DefaultValue'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:integer'
										},
										text	=	item_tbl['custompapersize_width_mm']['default']
													
									}
								},
								
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:Mandatory'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:QName'
										},
										text	=	'psk:Conditional'
									}
								}
							}
						},
						{
							tag		=	'psf:ParameterDef',
							attribute	=
							{
								key		=	'name',
								value	=	'psk:PageMediaSizePSHeight'
							},
							children	= 
							{
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:DataType'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:QName'
										},
										text	=	'xsd:integer'
									}
								},
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:UnitType'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:string'
										},
										text	=	'microns'
									}
								},
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:Multiple'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:integer'
										},
										text	=	'1'
									}
								},
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:MaxValue'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:integer'
										},
										text	=	item_tbl['custompapersize_length_mm']['max']
									}
									
								},
								
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:MinValue'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:integer'
										},
										text	=	item_tbl['custompapersize_length_mm']['min']
									}
								},
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:DefaultValue'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:integer'
										},
										text	=	item_tbl['custompapersize_length_mm']['default']
													
									}
								},
								
								{
									tag			=	'psf:Property',
									attribute	=
									{
										key 	=	'name',
										value	=	'psf:Mandatory'
									},
									children	=
									{
										tag 	=	'psf:Value',
										attribute	=
										{
											key 	=	'xsi:type',
											value	=	'xsd:QName'
										},
										text	=	'psk:Conditional'
									}
								}
							}
						}
					}
				)
	return true
end

function convert_all_pc_tables( item_table, option_info, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value )
	local result_all_tables = {}

	local function isMember( value )
		local hf_table = { 'phf_print', 'phf_font', 'phf_fontsize', 'phf_text_userdefined' }
		for i = 1 , #hf_table do
			if(hf_table[i] == value) then
				return true
			end
		end
		return false
	end

	for k, v in pairs( pc_table ) do
		if( item_table[k] )then
			if( ( ( not isMember( k ) ) and 'outputcompresseddataexceptpjl' ~= k )								or
				( isMember( k ) and 'on' == headerfootersupport_value )											or
				( 'outputcompresseddataexceptpjl' == k and 'on' == enable_outputcompresseddataexceptpjl_value ) ) then
				local tbl = convert_ptpc_table( item_table, v, option_info)
				if( tbl ) then
					result_all_tables[ #result_all_tables + 1 ] = tbl
				end
			end
		end
	end

	return result_all_tables
end

function get_all_items_detail( cdb )
	local item_list = nil
	local item_table = {}

	if( nil == cdb ) then
		return item_table
	end

	item_list = cdb.features()

	if( nil ~= item_list ) then
		for i, v in ipairs(item_list) do
			item = cdb.get_detail(v)
			if(nil ~= item) then
				if('string' == item['type']) then
					item_table[v] =
							{
								max = tostring(item['max']),
								min = tostring(item['min']),
								default = item['default'],
								current = item['current']
							}
				elseif('range' == item['type']) then
					item_table[v] =
							{
								max = tostring(item['max']),
								min = tostring(item['min']),
								default = item['default'],
								current = item['current']
							}
				elseif('pickone' == item['type']) then
					local options = {}
					index = 1

					if(nil ~= item['elements']) then
						for item_name, item_value in pairs(item['elements']) do
							if(item['current'] == item_name)then
								options['current'] = 
								{
									name = item_name,
									condition = item_value
								
								}
							elseif(item['default'] == item_name)then
								options['default'] = 
								{
									name = item_name,
									condition = item_value
								
								}
							else
								table.insert(options, 
									{
										name = item_name,
										condition = item_value
									}
								)
							end
						end
						item_table[v] = options
					end

				else
					item_table[v] = 
							{
								default = item['default'],
								current = item['current']
							}
				end
			end
		end
	end
	return item_table
end

function change_pc_minikeyword_prefix( pc )
	local mini_prefix = 'ns0000:'
	local feat_tbl = pc.enum_features()
	for w in pairs(feat_tbl) do
		local opt_tbl = pc.enum_options( feat_tbl[w] )
		for v in pairs(opt_tbl) do
			if( nil ~= string.find( opt_tbl[v], mini_prefix ) ) then
				pc.set_attribute(	"/psf:PrintCapabilities/psf:Feature/psf:Option[@name='" .. opt_tbl[v] .. "']",
								'name',
								string.gsub( opt_tbl[v], mini_prefix, "ns0001:", 1 ),
								nil )
			end
		end
		if( nil ~= string.find( feat_tbl[w], mini_prefix ) ) then
			
			pc.set_attribute(	"/psf:PrintCapabilities/psf:Feature[@name='" .. feat_tbl[w] .. "']",
							'name',
							string.gsub( feat_tbl[w], mini_prefix, "ns0001:", 1 ),
							nil )
		end
	end

	pc.set_attribute(	"/psf:PrintCapabilities/psf:ParameterDef[@name='" .. mini_prefix .. "PageDevmodeSnapshot']",
					'name',
					"ns0001:PageDevmodeSnapshot",
					nil )

end

function act_get_print_capabilities( architecture_type )

	local result = false
	local cdb = Rice.CapsDB
	local pc = Rice.PrintCapabilities

	if Rice.PrintTicket then
		act_printticket_to_devmode( architecture_type )
	end

	if( "monolithic" ~= architecture_type and 
		pc.get_prefix(xmlns_table.ns0001) == 'ns0000' ) then
		local ns_temp = xmlns_table.ns0000 
		xmlns_table.ns0000 = xmlns_table.ns0001 
		xmlns_table.ns0001 = ns_temp
	end

	set_namespace(pc)

	if( "monolithic" == architecture_type ) then
		
		pc.set_element(	"/",
						"psf:PrintCapabilities",
						xmlns_table.psf )

		set_root_attribute(pc,printcapabilities_xpath)
	else
		pc.set_attribute(	printcapabilities_xpath,
							'xmlns:ns0000',
							xmlns_table.ns0001,
							xmlns_table.psf )
		pc.set_attribute(	printcapabilities_xpath,
							'xmlns:ns0001',
							xmlns_table.ns0000,
							xmlns_table.psf )
	end

	change_pc_minikeyword_prefix( pc )

	local all_item_tbl = get_all_items_detail(cdb)

	for i, v in pairs(pc_table) do
		if( 'nil'	== type( v['tag'] ) ) then
			for j, w in ipairs(v) do
				if( 'table' == type(v[j]) ) then
					pc.delete_node("/psf:PrintCapabilities/" .. w['tag'] .. "[@name='" .. w['attribute']['value'] .. "']")
				elseif( 'function' == type(v[j]) ) then
					local tbl = v[j](all_item_tbl)
					if( nil == tbl ) then
						--
					else
						pc.delete_node("/psf:PrintCapabilities/" .. tbl['tag'] .. "[@name='" .. tbl['attribute']['value'] .. "']")
					end
				else
				end
			end
		else
			pc.delete_node("/psf:PrintCapabilities/" .. v['tag'] .. "[@name='" .. v['attribute']['value'] .. "']")
		end
	end

	pc.delete_node("/psf:PrintCapabilities/psf:ParameterDef[@name='psk:PageMediaSizePSWidth']")
	pc.delete_node("/psf:PrintCapabilities/psf:ParameterDef[@name='psk:PageMediaSizePSHeight']")

	local paper_db = Rice.PaperDB
	local option_info = create_option_info(cdb, paper_db)

	local headerfootersupport_value = cdb.get('headerfootersupport')
	local enable_outputcompresseddataexceptpjl_value = cdb.get('enable_outputcompresseddataexceptpjl')
	local converted_all_pc_tables = convert_all_pc_tables(all_item_tbl, option_info, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value)

	local converted_all_pc_tables_added_pscustom = add_pscustommedia_to_converted_table( converted_all_pc_tables, all_item_tbl ) 

	generate_printcapabilities(pc,  converted_all_pc_tables )

	return 'true'
end
