Rice.require 'Native'
Rice.require 'Rice.CapsDB'
Rice.require 'Rice.PrintTicket'
Rice.require 'Rice.Devmode'
Rice.require 'TableConverter'
Rice.require 'json'
Rice.require 'printticket_core'
Rice.require 'printticket_to_devmode_table'


function generate_target_xpath(pt,prefix_xpath, xpath_resouce_tbl)

	local current_xpath = prefix_xpath
	local xpath_result_table = {}

	if( nil ~= xpath_resouce_tbl['tag'] ) then
		current_xpath = current_xpath..'/'..solve_local_prefix(pt,xpath_resouce_tbl['tag'])
		if( nil ~= xpath_resouce_tbl['attribute'] 			and
			nil ~= xpath_resouce_tbl['attribute']['key'] 	and
			nil ~= xpath_resouce_tbl['attribute']['value'] 		) then
			if( 'string' == type(xpath_resouce_tbl['attribute']['value']) ) 		then
				current_xpath = current_xpath.."[@"..solve_local_prefix(pt,xpath_resouce_tbl['attribute']['key']).."='"..solve_local_prefix(pt,xpath_resouce_tbl['attribute']['value']).."']"
			elseif( 'boolean' == type(xpath_resouce_tbl['attribute']['value']) ) 	then
				xpath_result_table.xpath 			= current_xpath
				xpath_result_table.valuetype 		= 'attribute'
				xpath_result_table.attribute_name 	= xpath_resouce_tbl['attribute']['key']
			end
		end
		if( nil ~= xpath_resouce_tbl['text']				and
			'boolean' == type(xpath_resouce_tbl['text']) 	and
			true == xpath_resouce_tbl['text']				) then
				xpath_result_table.xpath 			= current_xpath
				xpath_result_table.valuetype 		= 'text'
		end
		if( nil ~= xpath_resouce_tbl['children'] ) then
			xpath_result_table = generate_target_xpath(pt,current_xpath,xpath_resouce_tbl['children'])
		end
	end

	return xpath_result_table
end

function generate_all_target_xpath(pt, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value)
	local converted_xpath_table = {}

	local function isMember( value )
		local hf_table = {	'ns0000:PageHeaderFooter',
							'HF_ns0000:FontName',
							'HF_ns0000:FontSize',
							'ns0000:HeaderFooterDate',
							'ns0000:HeaderFooterDatePosition',
							'ns0000:HeaderFooterDateFormat',
							'ns0000:HeaderFooterNumber',
							'ns0000:HeaderFooterNumberPosition',
							'ns0000:HeaderFooterNumberFormat',
							'ns0000:HeaderFooterText',
							'ns0000:HeaderFooterTextPosition',
							'ns0000:HeaderFooterTextFormat',
							'HF_ns0000:CustomText' }
		for i = 1 , #hf_table do
			if(hf_table[i] == value) then
				return true
			end
		end
		return false
	end

	for i in pairs(pt_xpath_table) do
		if( ( ( not isMember( i ) ) and 'ns0000:JobOutputCompressedDataExceptPJL' ~= i )								or
			( isMember( i ) and 'on' == headerfootersupport_value )														or
			( 'ns0000:JobOutputCompressedDataExceptPJL' == i and 'on' == enable_outputcompresseddataexceptpjl_value ) ) then
			tmp_converted_table = generate_target_xpath(pt,'/'..solve_local_prefix(pt, 'psf:PrintTicket'),pt_xpath_table[i])
			if( nil ~= tmp_converted_table and 'table' == type(tmp_converted_table) ) then
				converted_xpath_table[i] = tmp_converted_table
			end
		end
	end
	return converted_xpath_table
end

function extract_value( pt, xpath_table )

	local extracted_values = {}
	if( nil ~= pt and nil ~= xpath_table ) then
		for i in pairs(xpath_table) do
			local extracted_value = nil

			if( nil ~= xpath_table[i]['xpath'] and nil ~= xpath_table[i]['valuetype'] and pt.is_exist_text( xpath_table[i]['xpath'] ) ) then
				if( 'attribute' == xpath_table[i]['valuetype'] and nil ~= xpath_table[i]['attribute_name']) then
					local tmp_attributes = pt.get_attribute(xpath_table[i]['xpath'],xpath_table[i]['attribute_name'])
					
					if( nil ~= tmp_attributes 				and
						'table' == type(tmp_attributes) 	and
						1 == table.maxn(tmp_attributes) 	and
						'string' == type(tmp_attributes[1])		) then
						extracted_value	= tmp_attributes[1]

					end
				elseif( 'text' == xpath_table[i]['valuetype'] ) then

					local tmp_text = pt.get_text(xpath_table[i]['xpath'])
					if( nil ~= tmp_text and 'string' == type(tmp_text) ) then
						extracted_value = tmp_text
					end
				end
			end

			if( nil ~= extracted_value ) then
				extracted_values[i] = extracted_value
			end
		end
	end
	return extracted_values
end


function convert_item_values(extracted_values)
	local item_value_table = nil

	local converter 		= TableConverter(pt2dev_table)
	local item_value_table 	= converter:run(extracted_values)

	return item_value_table
end

function table_to_jsonmap( item_value_table )

	local jstring = nil
	local jsonmodule = Json
	jstring = jsonmodule.Encode(item_value_table)
	return jstring
end

-- Convert actual prefix of values contained in extracted_values to local prefix
-- (ex)pskxxx, rpskxxx, xsixxx----->>>> psk, rpsk, xsi
function modify_prefix(pt, xpath_table, extracted_values)

	for i in pairs(extracted_values) do
		if (nil ~= string.find(xpath_table[i].xpath, '.+/'..solve_local_prefix(pt,'psf:Option')..'$')
			or
			nil ~= string.find(xpath_table[i].xpath, '.+/'..solve_local_prefix(pt, 'psf:Value')..'%[@'..solve_local_prefix(pt, 'xsi:type')..'=\''..solve_local_prefix(pt, 'xsd:QName')..'\'%]$') ) then

			extracted_values[i] = solve_actual_prefix(pt, extracted_values[i])

		end
	end

end

function reflect_duplex_value(converted_table, cdb)
	local item_value_table = converted_table

	if ((nil ~= item_value_table['dmDuplex']) or (nil ~= item_value_table['duplex'])) then
		local result = 'off'
	
		local version = get_duplex_version(cdb)
		-- phase2 or later validation --
		if ('duplexversion2' == version) then
			-- If there is no duplex table, generate it --
			if(nil == item_value_table['duplex'])then
				item_value_table['duplex'] = cdb.get('duplex')
			end
	
			result = item_value_table['duplex']

			if (nil ~= item_value_table['dmDuplex']) then
				if ( '2' == item_value_table['dmDuplex'] ) then
					if ( ('longedgerightortop' == item_value_table['duplex']) or ('shortedgetoporright' == item_value_table['duplex']) ) then
						result = 'longedgerightortop'
					else
						result = 'longedgeleftortop'
					end
				elseif ( '3' == item_value_table['dmDuplex'] ) then
					if ( ('longedgerightortop' == item_value_table['duplex']) or ('shortedgetoporright' == item_value_table['duplex']) ) then
						result = 'shortedgetoporright'
					else
						result = 'shortedgetoporleft'
					end
				else
					result = 'off'
				end
			end
		-- phase1 validation --
		else
			local orientation_val = nil
			local layout_val = nil
			
			-- Orientaiton
			if(nil ~= item_value_table['orientation'])then
				orientation_val = item_value_table['orientation']
			else
				orientation_val = cdb.get('orientation')
			end
			
			-- Layout
			if(nil ~= item_value_table['layout'])then
				layout_val = item_value_table['layout']
			else
				layout_val = cdb.get('layout')
			end

			-- If there is no duplex table, generate it --
			if(nil == item_value_table['duplex'])then
				item_value_table['duplex'] = cdb.get('duplex')
				result = item_value_table['duplex']
			else
				-- convert Table --
				local base_table = {
					['off']					= { ['portrait'] = 'off', 			['landscape'] = 'off' },
					['longedgeleftortop']	= { ['portrait'] = 'opentoleft', 	['landscape'] = 'opentotop' },
					['longedgerightortop']	= { ['portrait'] = 'opentoright', 	['landscape'] = 'opentotop' },
					['shortedgetoporleft']	= { ['portrait'] = 'opentotop', 	['landscape'] = 'opentoleft' },
					['shortedgetoporright']	= { ['portrait'] = 'opentotop', 	['landscape'] = 'opentoright' },
				}
	
				local conv_table = nil
				
				-- convert --
				conv_table = base_table[item_value_table['duplex']]
				
				if('landscape' == orientation_val)then
					if('2pagespersheet' == layout_val or '6pagespersheet' == layout_val)then
						result = conv_table['portrait']
					else
						result = conv_table['landscape']
					end
				else
					if('2pagespersheet' == layout_val or '6pagespersheet' == layout_val)then
						result = conv_table['landscape']
					else
						result = conv_table['portrait']
					end
				end
			end
			
			-- validate --
			if (nil ~= item_value_table['dmDuplex']) then
				local temp_value = nil
				if ( ('opentoleft' == result) or ('opentoright' == result) ) then
					temp_value = result
				else
					temp_value = 'opentoleft'
				end
				
				if ( '2' == item_value_table['dmDuplex'] ) then
					if( '2pagespersheet' == layout_val or '6pagespersheet' == layout_val )then
						if('portrait' == orientation_val)then
							result = 'opentotop'
						else
							result = temp_value
						end
					else
						if('portrait' == orientation_val)then
							result = temp_value
						else
							result = 'opentotop'
						end
					end
				elseif ( '3' == item_value_table['dmDuplex'] ) then
					if( '2pagespersheet' == layout_val or '6pagespersheet' == layout_val )then
						if('portrait' == orientation_val)then
							result = temp_value
						else
							result = 'opentotop'
						end
					else
						if('portrait' == orientation_val)then
							result = 'opentotop'
						else
							result = temp_value
						end
					end
				else
					result = 'off'
				end
			end
		end
		item_value_table['duplex'] = result
	end

	return item_value_table
end

function reflect_pscustomsize_value(converted_table, extracted_values, pt)

	local item_value_table = converted_table

	if(	nil ~= extracted_values['psk:PageMediaSize']	and
		'psk:PSCustomMediaSize' == extracted_values['psk:PageMediaSize'] ) then
		
		item_value_table['documentsize'] = 'custompapersize'

		local pswidth_val = pt.get_text("/psf:PrintTicket/psf:Feature[@name='psk:PageMediaSize']/psf:Option[@name='psk:PSCustomMediaSize']/psf:ScoredProperty[@name='psk:PSWidth']/psf:Value[@xsi:type='xsd:integer']")
		local psheight_val = pt.get_text("/psf:PrintTicket/psf:Feature[@name='psk:PageMediaSize']/psf:Option[@name='psk:PSCustomMediaSize']/psf:ScoredProperty[@name='psk:PSHeight']/psf:Value[@xsi:type='xsd:integer']")
		
		local pagemediasizepswidth_val =  pt.get_text("/psf:PrintTicket/psf:ParameterInit[@name='psk:PageMediaSizePSWidth']/psf:Value[@xsi:type='xsd:integer']")
		local pagemediasizepsheight_val = pt.get_text("/psf:PrintTicket/psf:ParameterInit[@name='psk:PageMediaSizePSHeight']/psf:Value[@xsi:type='xsd:integer']")
		
		if( nil ~= pswidth_val	and
			"" ~= pswidth_val		and
			'string' == type(pswidth_val) ) then
			
			local width = tonumber(pswidth_val)
			item_value_table['custompapersize_width_mm'] = tostring( ( width and ( width - (width % 100) ) or 0 ) / 100 ) 
		
		elseif (	nil ~= pagemediasizepswidth_val	and
					"" ~= pagemediasizepswidth_val	and 
					'string' == type(pagemediasizepswidth_val) ) then
					
			local width2 = tonumber(pagemediasizepswidth_val)
			item_value_table['custompapersize_width_mm'] = tostring( ( width2 and ( width2 - (width2 % 100) ) or 0 ) / 100 )
		
		end
		
		if( nil ~= psheight_val	and
			"" ~= psheight_val	and
			'string' == type(psheight_val) ) then
			
			local length = tonumber(psheight_val)
			item_value_table['custompapersize_length_mm'] = tostring( ( length and ( length - (length % 100) ) or 0 ) / 100 ) 
			
		elseif (	nil ~= pagemediasizepsheight_val	and
					"" ~= pagemediasizepsheight_val	and
					'string' == type(pagemediasizepsheight_val) ) then
			
			local length2 = tonumber(pagemediasizepsheight_val)
			item_value_table['custompapersize_length_mm'] =  tostring( ( length2 and ( length2 - (length2 % 100) ) or 0 ) / 100 ) 
		end
		
	end

	return item_value_table
end

local function reflect_customsize_to_pt( pt, cdb, extracted_values )
	
	if( nil ~= cdb.get('documentsize')					and
		'custompapersize' == cdb.get('documentsize')	and
		nil ~= extracted_values['psk:PageMediaSize']	and
		'psk:CustomMediaSize' == extracted_values['psk:PageMediaSize']	)then
		
		local width_val = nil
		local height_val = nil
		width_val = tonumber( cdb.get('custompapersize_width_mm') ) and tostring( tonumber( cdb.get('custompapersize_width_mm') ) * 100 ) or nil
		height_val = tonumber( cdb.get('custompapersize_length_mm') ) and tostring( tonumber( cdb.get('custompapersize_length_mm') ) * 100 ) or nil

		
		if( nil ~= width_val	and
			nil ~= height_val		)	then
			
			pt.delete_node("/psf:PrintTicket/psf:Feature[@name='psk:PageMediaSize']")
			pt.delete_node("/psf:PrintTicket/psf:ParameterInit[@name='psk:PageMediaSizePSWidth']")
			pt.delete_node("/psf:PrintTicket/psf:ParameterInit[@name='psk:PageMediaSizePSHeight']")
			pt.delete_node("/psf:PrintTicket/psf:ParameterInit[@name='psk:PageMediaSizePSWidthOffset']")
			pt.delete_node("/psf:PrintTicket/psf:ParameterInit[@name='psk:PageMediaSizePSHeightOffset']")
			pt.delete_node("/psf:PrintTicket/psf:ParameterInit[@name='psk:PageMediaSizePSOrientation']")
			
			local pscustommediasize_tbl =
			{
				{
					tag			=	'psf:Feature',
					attribute	=
					{
						key		=	'name',
						value	=	'psk:PageMediaSize'
					},
					children = {
						tag			= 	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	'psk:PSCustomMediaSize'
						},
						children = {
							{
								tag			= 	'psf:ScoredProperty',
								attribute	=
								{
									key		=	'name',
									value	=	'psk:PSWidth'
								},
								children = {
									tag			=	'psf:ParameterRef',
									attribute	=
									{
										key		=	'name',
										value	=	'psk:PageMediaSizePSWidth'
									}
								}
							},
							{
								tag			= 	'psf:ScoredProperty',
								attribute	=
								{
									key		=	'name',
									value	=	'psk:PSHeight'
								},
								children = {
									tag			=	'psf:ParameterRef',
									attribute	=
									{
										key		=	'name',
										value	=	'psk:PageMediaSizePSHeight'
									}
								}
							},
							{
								tag			= 	'psf:ScoredProperty',
								attribute	=
								{
									key		=	'name',
									value	=	'psk:PSWidthOffset'
								},
								children = {
									tag			=	'psf:ParameterRef',
									attribute	=
									{
										key		=	'name',
										value	=	'psk:PageMediaSizePSWidthOffset'
									}
								}
							},
							{
								tag			= 	'psf:ScoredProperty',
								attribute	=
								{
									key		=	'name',
									value	=	'psk:PSHeightOffset'
								},
								children = {
									tag			=	'psf:ParameterRef',
									attribute	=
									{
										key		=	'name',
										value	=	'psk:PageMediaSizePSHeightOffset'
									}
								}
							},
							{
								tag			= 	'psf:ScoredProperty',
								attribute	=
								{
									key		=	'name',
									value	=	'psk:PSOrientation'
								},
								children = {
									tag			=	'psf:ParameterRef',
									attribute	=
									{
										key		=	'name',
										value	=	'psk:PageMediaSizePSOrientation'
									}
								}
							}
						}
					}
				},
				{
					tag			=	'psf:ParameterInit',
					attribute	=
					{
						key		=	'name',
						value	=	'psk:PageMediaSizePSWidth'
					},
					children = {
						tag			=	'psf:Value',
						attribute	=
						{
							key		=	'xsi:type',
							value	=	'xsd:integer'
						},
						text = width_val
					}
				},
				{
					tag			=	'psf:ParameterInit',
					attribute	=
					{
						key		=	'name',
						value	=	'psk:PageMediaSizePSHeight'
					},
					children = {
						tag			=	'psf:Value',
						attribute	=
						{
							key		=	'xsi:type',
							value	=	'xsd:integer'
						},
						text = height_val
					}
				},
				{
					tag			=	'psf:ParameterInit',
					attribute	=
					{
						key		=	'name',
						value	=	'psk:PageMediaSizePSWidthOffset'
					},
					children = {
						tag			=	'psf:Value',
						attribute	=
						{
							key		=	'xsi:type',
							value	=	'xsd:integer'
						},
						text = '0'
					}
				},
				{
					tag			=	'psf:ParameterInit',
					attribute	=
					{
						key		=	'name',
						value	=	'psk:PageMediaSizePSHeightOffset'
					},
					children = {
						tag			=	'psf:Value',
						attribute	=
						{
							key		=	'xsi:type',
							value	=	'xsd:integer'
						},
						text = '0'
					}
				},
				{
					tag			=	'psf:ParameterInit',
					attribute	=
					{
						key		=	'name',
						value	=	'psk:PageMediaSizePSOrientation'
					},
					children = {
						tag			=	'psf:Value',
						attribute	=
						{
							key		=	'xsi:type',
							value	=	'xsd:integer'
						},
						text = '1'
					}
				},
			}
			
			generate_printtickets( pt, pscustommediasize_tbl)
		end
	end
end

function check_jobcode(pt, item_value_table)

	if(	nil == item_value_table['loginusername_type']			and
		nil == item_value_table['loginpassword']				and
		nil == item_value_table['loginusername']				and
		nil == item_value_table['userid_type']					and
		nil == item_value_table['userid']						and
		nil == item_value_table['documentserver_password']		and
		nil == item_value_table['password']						and
		nil == item_value_table['documentserver_filename']		and
		nil == item_value_table['filename']						and
		nil == item_value_table['username']						and
		nil == item_value_table['usercode']						and
		nil == item_value_table['documentserver_folderpassword']	 )then
		return false
	end

	pt.set_change_jobcode()

end

function act_printticket_to_devmode( architecture_type )


	local cdb = Rice.CapsDB
	local pt = Rice.PrintTicket
	
	if( false == set_namespace(pt) ) then return 'false' end

	pt.set_attribute(	printticket_xpath,
						'xmlns:ns0000',
						xmlns_table.ns0000,
						xmlns_table.psf )
						
	pt.set_attribute(	printticket_xpath,
						'xmlns:ns0001',
						xmlns_table.ns0001,
						xmlns_table.psf )

	local headerfootersupport_value = cdb.get('headerfootersupport')
	local enable_outputcompresseddataexceptpjl_value = cdb.get('enable_outputcompresseddataexceptpjl')
	local converted_xpath_table = generate_all_target_xpath(pt, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value)

	local extracted_values = extract_value(pt,converted_xpath_table)

	modify_prefix(pt, converted_xpath_table, extracted_values)

	local converted_table = convert_item_values(extracted_values)

	local reflected_pscustomsize_table = reflect_pscustomsize_value(converted_table, extracted_values, pt)

	local item_value_table = reflect_duplex_value(reflected_pscustomsize_table, cdb)

	local item_value_jsonstring = table_to_jsonmap(item_value_table)

	cdb.set_multi(item_value_jsonstring)

	check_jobcode(pt, item_value_table);

	reflect_customsize_to_pt( pt, cdb, extracted_values )

	pt.delete_node( "/psf:PrintTicket/psf:Feature[@name='psk:JobNUpAllDocumentsContiguously']" )
	pt.delete_node( "/psf:PrintTicket/psf:Feature[@name='psk:PageScaling']" )

	return 'true'

end
