dev2pt_table =
{
-- [01 Job]
	-- 01 Job Type
	jobtype	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobRicPrintJob'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local jobtype_table	=
				{
					['normalprint']			=	'ns0000:RicPrintNormal',
					['sampleprint']			=	'ns0000:RicPrintSample',
					['lockedprint']			=	'ns0000:RicPrintLocked',
					['holdprint']			=	'ns0000:RicPrintHold',
					['storedprint']			=	'ns0000:RicPrintStored',
					['storedprintshared']	=	'ns0000:RicPrintStoredShared',
					['storeandprint']		=	'ns0000:RicPrintStoreAndPrint',
					['storeandprintshared']	=	'ns0000:RicPrintStoreAndPrintShared',
					['documentserver']		=	'ns0000:RicDocumentServer',
					['saveoverlaydata']		=	'ns0000:RicSaveOverlayData',
					['storeoverlaydata']	=	'ns0000:RicStoreOverlayDataToPrinterStorage',
					['storefile']			=	'ns0000:RicStoreFile'
				}
			local jobtype_val = jobtype_table[tbl['jobtype']]
			if(nil == jobtype_val)then
				jobtype_val = 'ns0000:RicPrintNormal'
			end
			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key	=	'name',
						value	= jobtype_val
					}
				}
			)
			
			local option_table = {}
			-- Save overlay data File Path
			if('saveoverlaydata' == tbl['jobtype'] and nil ~= tbl['saveoverlaydata_filepath'])then
				table.insert(option_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:RicRPCSOverlayData'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['saveoverlaydata_filepath']
								}
							}
					}
				)
			end
			
			-- storeoverlaydata_number
			if('storeoverlaydata' == tbl['jobtype'] and nil ~= tbl['storeoverlaydata_number'])then
				table.insert(option_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:RicRPCSOverlayNumber'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tbl['storeoverlaydata_number']
								}
							}
					}
				)
			end
			-- storeoverlaydata_name
			if('storeoverlaydata' == tbl['jobtype'] and nil ~= tbl['storeoverlaydata_name'])then
				table.insert(option_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:RicRPCSOverlayName'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['storeoverlaydata_name']
								}
							}
					}
				)
			end
			
			-- documentserver_foldernumber
			if('documentserver' == tbl['jobtype'] and nil ~= tbl['documentserver_foldernumber'])then
				table.insert(option_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:RicFolderNumber'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tbl['documentserver_foldernumber']
								}
							}
					}
				)
			end
			
			if(0 ~= table.getn(option_table))then
				result_table[1]['children'] = option_table
			end

			-- Overlay Direction 
			if(nil ~= tbl['storeoverlaydata_direction'])then
				local storeoverlaydata_direction_table	=
					{
						['lef']		=	'ns0000:FitToFeedFromLongEdge',
						['sef']		=	'ns0000:FitToFeedFromShortEdge'
					}
				local storeoverlaydata_direction_val = storeoverlaydata_direction_table[tbl['storeoverlaydata_direction']]
				if(nil == storeoverlaydata_direction_val)then
					storeoverlaydata_direction_val = 'ns0000:FitToFeedFromLongEdge'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:ImageOverlayDirection'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	storeoverlaydata_direction_val
							}
						}
					}
				)
			end
			
			-- Scheduled Print
			if(nil ~= tbl['scheduledprint'])then
				local scheduledprint_table	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On'
					}
				local scheduledprint_val = scheduledprint_table[tbl['scheduledprint']]
				if(nil == scheduledprint_val)then
					scheduledprint_val = 'ns0000:Off'
				end
				
				local scheduledprint_result_table =
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:ScheduledPrint'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	scheduledprint_val
							}
						}
					}
				
				
				local scheduledprint_option_table = {}
				-- Scheduled Print Hour
				if('on' == tbl['scheduledprint'] and nil ~= tbl['scheduledprint_hour'])then
					table.insert(scheduledprint_option_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:Hour'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tbl['scheduledprint_hour']
									}
								}
						}
					)
				end
				
				-- Scheduled Print Minute
				if('on' == tbl['scheduledprint'] and nil ~= tbl['scheduledprint_minute'])then
					table.insert(scheduledprint_option_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:Minute'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tbl['scheduledprint_minute']
									}
								}
						}
					)
				end
				
				if(0 ~= table.getn(scheduledprint_option_table))then
					scheduledprint_result_table['children']['children'] = scheduledprint_option_table
				end
				
				table.insert(result_table, scheduledprint_result_table)
				
			end
			
			
			
			return result_table
		end

	},

-- [02 Finishing]
	-- 01 Duplex
	duplex	=
	{
		{
			tag			=	'psf:Feature',
			attribute	=
			{
				key 	=	'name',
				value 	=	'ns0000:JobDuplexAllDocumentsDirection'
			},
			children	=
			{
				tag 		=	'psf:Option',
				attribute	=
				{
					key 	=	'name',
					value 	=	function(tbl)
							local result = nil
							
							if ('off' == tbl['duplex']) then
								result = 'ns0000:Off'
							-- phase2 or later --
							elseif (('longedgeleftortop' == tbl['duplex']) or
									('longedgerightortop' == tbl['duplex']) or
									('shortedgetoporleft' == tbl['duplex']) or
									('shortedgetoporright' == tbl['duplex'])) then
								local t =
								{
									['longedgeleftortop']		=	'ns0000:LongEdgeLeftOrTop',
									['longedgerightortop']		=	'ns0000:LongEdgeRightOrTop',
									['shortedgetoporleft']		=	'ns0000:ShortEdgeTopOrLeft',
									['shortedgetoporright']		=	'ns0000:ShortEdgeTopOrRight'
								}
								return t[tbl['duplex']]
							-- phase1 --
							elseif (('opentoleft' == tbl['duplex']) or
									('opentoright' == tbl['duplex']) or
									('opentotop' == tbl['duplex'])) then
								local t	=
								{
									['opentoleft']	= { ['portrait'] 	= 'ns0000:LongEdgeLeftOrTop', ['landscape'] 	= 'ns0000:ShortEdgeTopOrLeft', },
									['opentoright']	= { ['portrait'] 	= 'ns0000:LongEdgeRightOrTop', ['landscape'] 	= 'ns0000:ShortEdgeTopOrRight', },
									['opentotop']	= { ['portrait'] 	= 'ns0000:ShortEdgeTopOrLeft', ['landscape'] 	= 'ns0000:LongEdgeLeftOrTop', }
								}
								
								local conv_table = t[tbl['duplex']]
								
								if('landscape' == tbl.orientation ) then
									if( '2pagespersheet' == tbl.layout or '6pagespersheet' == tbl.layout ) then
										result = conv_table['portrait']
									else
										result = conv_table['landscape']
									end
								else
									if( '2pagespersheet' == tbl.layout or '6pagespersheet' == tbl.layout ) then
										result = conv_table['landscape']
									else
										result = conv_table['portrait']
									end
								end
							else
								result = 'ns0000:Off'
							end
							return result
						end
				},
				children	=	function(tbl)
									if((nil ==  tbl['duplex_bindingmarginfront_mm'] and nil == tbl['duplex_bindingmarginback_mm'] )
										or 'off' == tbl['duplex'])then
										return nil
									end
									
									local scored_table = {}
									---FrontSideMargin--
									if(nil ~= tbl['duplex_bindingmarginfront_mm'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:DuplexFrontSideMargin'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tostring( tonumber(tbl['duplex_bindingmarginfront_mm']) * 100)
														}
													}
											}
										)
									end
									---BackSideMargin--
									if(nil ~= tbl['duplex_bindingmarginback_mm'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:DuplexBackSideMargin'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tostring( tonumber(tbl['duplex_bindingmarginback_mm']) * 100)
														}
													}
											}
										)
									end
									return scored_table
								end
			}
		},
		{
			tag			=	'psf:Feature',
			attribute	=
			{
				key 	=	'name',
				value 	=	'psk:JobDuplexAllDocumentsContiguously'
			},
			children	=
			{
				tag 		=	'psf:Option',
				attribute	=
				{
					key 	=	'name',
					value 	=
					{
						duplex	= function(value, tbl)
							local result = nil
							
							if ('off' == value) then
								result = 'psk:OneSided'
							-- phase2 or later --
							elseif (('longedgeleftortop' == value) or
									('longedgerightortop' == value) or
									('shortedgetoporleft' == value) or
									('shortedgetoporright' == value)) then
								local t =
								{
									['longedgeleftortop']		=	'psk:TwoSidedLongEdge',
									['longedgerightortop']		=	'psk:TwoSidedLongEdge',
									['shortedgetoporleft']		=	'psk:TwoSidedShortEdge',
									['shortedgetoporright']		=	'psk:TwoSidedShortEdge'
								}
								result = t[value]
							-- phase1 --
							elseif (('opentoleft' == value) or
									('opentoright' == value) or
									('opentotop' == value)) then
								local t	=
								{
									['opentoleft']	=
									{
										['unrotated_port'] 	= 'psk:TwoSidedLongEdge',
										['unrotated_land'] 	= 'psk:TwoSidedShortEdge',
										['rotated_port']	= 'psk:TwoSidedShortEdge',
										['rotated_land']   	= 'psk:TwoSidedLongEdge'
									},
									['opentoright']	=
									{
										['unrotated_port'] = 'psk:TwoSidedLongEdge',
										['unrotated_land'] = 'psk:TwoSidedShortEdge',
										['rotated_port']	 = 'psk:TwoSidedShortEdge',
										['rotated_land']   = 'psk:TwoSidedLongEdge'
									},
									['opentotop']	=
									{
										['unrotated_port'] = 'psk:TwoSidedShortEdge',
										['unrotated_land'] = 'psk:TwoSidedLongEdge',
										['rotated_port']	= 'psk:TwoSidedLongEdge',
										['rotated_land']   = 'psk:TwoSidedShortEdge'
									}
								}
								local duplex_pattern = function( tbl )
									if( 'landscape' == tbl.orientation ) then
										if( '2pagespersheet' == tbl.layout or '6pagespersheet' == tbl.layout ) then
											return 'rotated_land'
										else
											return 'rotated_port'
										end
									else
										if( '2pagespersheet' == tbl.layout or '6pagespersheet' == tbl.layout ) then
											return 'unrotated_land'
										else
											return 'unrotated_port'
										end
									end
								end
								local pattern_table = t[value]
								result = pattern_table[duplex_pattern(tbl)]
							else
								result = 'psk:OneSided'
							end
							return result
						end
					}
				}
			}
		},
	},

	-- 02 Enable Printer Stamp Setting
	enableprinterstampsetting	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrinterStamp'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					enableprinterstampsetting	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},

	-- 03 Collate
	collate	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:DocumentCollateDistribution'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					collate	=
					{
						['application']	=	'ns0000:ApplicationCollate',
						['printer']		=	'ns0000:PrinterCollate'
					},
					default	=	{ 'item', 'ns0000:PrinterCollate' }
				}
			}
		}
	},
	dmCollate	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:DocumentCollate'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					dmCollate	=
					{
						['0']	=	'psk:Uncollated',
						['1']	=	'psk:Collated'
					},
					default	=	{ 'item', 'psk:Uncollated' }
				}
			}
		}
	},
	-- 03-01 Job Offset
	joboffset	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobOffset'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					joboffset	=
					{
						['off']		=	'ns0000:Normal',
						['rotate']	=	'ns0000:Rotate',
						['shift']	=	'ns0000:Shift'
					},
					default	=	{ 'item', 'ns0000:Normal' }
				}
			}
		}
	},
	-- 04 Crop Marks
	cropmarks	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobCrops'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=	function(tbl)
					local result_val
					if('off' == tbl['cropmarks'])then
						result_val = 'ns0000:Off'
						
					elseif('on' == tbl['cropmarks'])then
						if(nil ~= tbl['cropmarks_firstpageonly'] and 'on' == tbl['cropmarks_firstpageonly'])then
							result_val = 'ns0000:FirstPageOnly'
						else
							result_val = 'ns0000:AllPages'
						end
					else
						--default
						result_val = 'ns0000:Off'
					end
					return result_val
				end
			},
			children	=	function(tbl)
				if(nil == tbl['cropmarks_length_mm'] or 'off' == tbl['cropmarks'])then
					return nil
				else
					return 	{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CropMarksLength'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tostring( tonumber(tbl['cropmarks_length_mm']) * 100)
								}
							}
						}
				end
			end
		}
	},
	-- 05 Punch
	punch	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:JobHolePunch'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					punch	=
					{
						['off']					=	'psk:None',
						['left']				=	'ns0000:Left',
						['top']					=	'ns0000:Top',
						['right']				=	'ns0000:Right',
						['1atlefttop']			=	'ns0000:LeftTop',
						['2atleft']				=	'ns0000:Left2',
						['2attop']				=	'ns0000:Top2',
						['2atright']			=	'ns0000:Right2',
						['3atleft']				=	'ns0000:Left3',
						['3attop']				=	'ns0000:Top3',
						['3atright']			=	'ns0000:Right3',
						['4atleft']				=	'ns0000:Left4',
						['4attop']				=	'ns0000:Top4',
						['4atright']			=	'ns0000:Right4',
						['multiatleftortop']	=	'ns0000:LeftOrTopMulti',
						['multiatrightortop']	=	'ns0000:RightOrTopMulti',
						['multiatleft']			=	'ns0000:LeftMulti',
						['multiattop']			=	'ns0000:TopMulti',
						['multiatright']		=	'ns0000:RightMulti',
						['doubleatleftortop']	=	'ns0000:LeftOrTopDouble',
						['doubleatrightortop']	=	'ns0000:RightOrTopDouble'
					},
					default	=	{ 'item', 'psk:None' }
				}
			}
		}
	},
	-- 06 Staple
	staple	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:JobStapleAllDocuments'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					staple	=
					{
						['off']						=	'psk:None',
						['topleftslant']			=	'ns0000:TopLeftSlant',
						['toprightslant']			=	'ns0000:TopRightSlant',
						['topleft']					=	'psk:StapleTopLeft',
						['topright']				=	'psk:StapleTopRight',
						['2attop']					=	'psk:StapleDualTop',
						['2atleft']					=	'psk:StapleDualLeft',
						['2atright']				=	'psk:StapleDualRight',
						['2atcenter']				=	'psk:SaddleStitch',
						['topleftslantstapleless']	=	'ns0000:TopLeftSlantStapleless',
						['toprightslantstapleless']	=	'ns0000:TopRightSlantStapleless'
					},
					default	=	{ 'item', 'psk:None' }
				}
			}
		}
	},
	-- 07 Output Tray
	outputtray	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:JobOutputBin'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					outputtray	=
					{
						['printerdefault']			=	'ns0000:PrinterDefault',
						['standardtray']			=	'ns0000:Standard',
						['copytray']				=	'ns0000:Copy',
						['internalshifttray']		=	'ns0000:InternalShift',
						['shifttray']				=	'ns0000:Shift',
						['internaltray']			=	'ns0000:Internal',
						['internaltray2']			=	'ns0000:Internal2',
						['finisheruppertray']		=	'ns0000:FinisherUpper',
						['finishershifttray']		=	'ns0000:FinisherShift',
						['finishershifttray1']		=	'ns0000:FinisherShift1',
						['finishershifttray2']		=	'ns0000:FinisherShift2',
						['finishershifttraysecond']	=	'ns0000:FinisherShiftSecond',
						['bookletprocessortray']	=	'ns0000:BookletProcessorTray',
						['bookletprocessortray2']	=	'ns0000:BookletProcessorTray2',
						['finisherbooklettray']		=	'ns0000:FinisherBooklet',
						['trimmertray']				=	'ns0000:TrimmerTray',
						['lefttray']				=	'ns0000:LeftTray',
						['lefttray1']				=	'ns0000:LeftTray1',
						['lefttray2']				=	'ns0000:LeftTray2',
						['righttray']				=	'ns0000:RightTray',
						['mailboxprooftray']		=	'ns0000:MailboxProofTray',
						['mailboxtray1']			=	'ns0000:MailBoxBin1',
						['mailboxtray2']			=	'ns0000:MailBoxBin2',
						['mailboxtray3']			=	'ns0000:MailBoxBin3',
						['mailboxtray4']			=	'ns0000:MailBoxBin4',
						['mailboxtray5']			=	'ns0000:MailBoxBin5',
						['mailboxtray6']			=	'ns0000:MailBoxBin6',
						['mailboxtray7']			=	'ns0000:MailBoxBin7',
						['mailboxtray8']			=	'ns0000:MailBoxBin8',
						['mailboxtray9']			=	'ns0000:MailBoxBin9',
						['onesheetoutputtray']		=	'ns0000:OneSheetOutputTray',
						['loadingtray']				=	'ns0000:LoadingTray',
						['ringstacker']				=	'ns0000:RingStacker',
						['stackerprooftray']		=	'ns0000:StackerProof',
						['stackerprooftray2']		=	'ns0000:StackerProofTray2',
						['largestackertray']		=	'ns0000:LargeStacker',
						['largestackertray2']		=	'ns0000:LargeStacker2',
						['longstackertray']			=	'ns0000:LongStackerTray',
						['longstackertray2']		=	'ns0000:LongStackerTray2',
						['foldprooftray']			=	'ns0000:FoldProof',
						['upperpaperexit']			=	'ns0000:UpperPaper',
						['frontpaperexit']			=	'ns0000:FrontPaper',
						['lowerpaperexit']			=	'ns0000:LowerPaper',
						['rearpaperexit']			=	'ns0000:RearPaper',
						['peripheralsifbox']		=	'ns0000:PeripheralsIfBox',
						['twinloopbindtray']		=	'ns0000:TwinLoopBindTray'
					},
					default	=	{ 'item', 'ns0000:PrinterDefault' }
				}
			}
		}
	},
	-- 08 Copies
	copies	=
	{
		tag			=	'psf:ParameterInit',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:JobCopiesAllDocuments'
		},
		children	=
		{
			tag			=	'psf:Value',
			attribute	=
			{
				key		=	'xsi:type',
				value	=	'xsd:integer'
			},
			text	=	function(tbl)
							return tostring(tbl.copies)
						end
		}
	},
	-- 09 Insert Separation Sheet
	insertseparationsheet	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:DocumentSeparatorSheet'
		},
		children	=	function(tbl)

			local result_table = {}
			
			local separationsheet_tbl	=
				{
					['off']	=	'psk:None',
					['on']	=	'psk:StartSheet'
				}
			local separationsheet_val = separationsheet_tbl[tbl['insertseparationsheet']]
			if(nil == separationsheet_val)then
				separationsheet_val = 'psk:None'
			end
			
			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key		=	'name',
						value	=	separationsheet_val
					}
				}
			)
			
			local scored_table = {}
			-- Font
			if('on' == tbl['insertseparationsheet'] and nil ~= tbl['insertseparationsheet_percopies'])then
				table.insert(scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
						{
							key		=	'name',
							value	=	'ns0000:Copies'
						},
						children	=	
						{
							tag			= 	'psf:Value',
							attribute	=
							{
								key		=	'xsi:type',
								value	=	'xsd:integer'
							},
							text	=	tostring(tbl.insertseparationsheet_percopies)
						}
					}
				)
			end
			
			if(0 ~= table.getn(scored_table))then
				result_table[1]['children'] = scored_table
			end

			if(nil ~= tbl['insertseparationsheet_inputtray'])then
				local tray_table	=
					{
						['tray1']				=	'ns0000:Tray1',
						['tray1roll']			=	'ns0000:Tray1_Roll',
						['tray2']				=	'ns0000:Tray2',
						['tray2roll']			=	'ns0000:Tray2_Roll',
						['tray3']				=	'ns0000:Tray3',
						['tray3lct']			=	'ns0000:Tray3_LCT',
						['tray3roll']			=	'ns0000:Tray3_Roll',
						['tray4']				=	'ns0000:Tray4',
						['tray4roll']			=	'ns0000:Tray4_Roll',
						['tray5']				=	'ns0000:Tray5',
						['tray6']				=	'ns0000:Tray6',
						['tray7']				=	'ns0000:Tray7',
						['tray8']				=	'ns0000:Tray8',
						['tray9']				=	'ns0000:Tray9',
						['tray10']				=	'ns0000:Tray10',
						['tray11']				=	'ns0000:Tray11',
						['traya']				=	'ns0000:TrayA',
						['bypasstray']			=	'ns0000:BypassTray',
						['frontbypasstray']		=	'ns0000:FrontBypassTray',
						['largecapacitytray']	=	'ns0000:LCT',
						['interposer']			=	'ns0000:Inserter',
						['interposeruppertray']	=	'ns0000:InserterUpper',
						['interposerlowertray']	=	'ns0000:InserterLower',
						['largecapacityinterposer1']	=	'ns0000:LargeCapacityInserter1',
						['largecapacityinterposer2']	=	'ns0000:LargeCapacityInserter2',
						['paperfeedtray']		=	'ns0000:PaperFeedTray',
					}
				local tray_val
				tray_val = tray_table[tbl['insertseparationsheet_inputtray']]
				if(nil == tray_val)then
					tray_val = 'ns0000:Tray1'
				end
				
				table.insert(result_table, {
					tag			= 	'psf:Feature',
					attribute	=
					{
						key		=	'name',
						value	=	'ns0000:SeparationSheetTray'
					},
					children	=	
					{
						tag			=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	tray_val
						},
					}
				})
			end
			
			return result_table

		end
	},
	-- 10 Reverse Order
	reverseorder	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:JobPageOrder'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					reverseorder	=
					{
						['off']	=	'psk:Standard',
						['on']	=	'psk:Reverse'
					},
					default	=	{ 'item', 'psk:Standard' }
				}
			}
		}
	},
	-- 11 Ring Binding
	ringbinding	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobRingBind'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					ringbinding	=
					{
						['off']					=	'ns0000:Off',
						['leftortop']			=	'ns0000:LeftOrTopPunchAndRingBooklet',
						['rightortop']			=	'ns0000:RightOrTopPunchAndRingBooklet',
						['leftortoppunchonly']	=	'ns0000:LeftOrTopPunchOnly',
						['rightortoppunchonly']	=	'ns0000:RightOrTopPunchOnly',
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 12 Fold
	fold	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobFold'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					fold	=
					{
						['off']								=	'ns0000:Off',
						['rightzfold']						=	'ns0000:RightZFold',
						['leftzfold']						=	'ns0000:LeftZFold',
						['bottomzfold']						=	'ns0000:BottomZFold',
						['insidefold']						=	'ns0000:InsideFold',
						['outsidefold']						=	'ns0000:OutsideFold',
						['superimposedfoldinside']			=	'ns0000:SuperimposedFoldInside',
						['superimposedfoldoutside']			=	'ns0000:SuperimposedFoldOutside',
						['insidehalffold']					=	'ns0000:InsideHalfFold',
						['outsidehalffold']					=	'ns0000:OutsideHalfFold',
						['rightortopinsidespiralfold']		=	'ns0000:RightOrTopInsideSpiralFold',
						['leftorbottominsidespiralfold']	=	'ns0000:LeftOrBottomInsideSpiralFold',
						['rightortopoutsidespiralfold']		=	'ns0000:RightOrTopOutsideSpiralFold',
						['leftorbottomoutsidespiralfold']	=	'ns0000:LeftOrBottomOutsideSpiralFold',
						['outsidezigzagfold']				=	'ns0000:OutsideZigzagFold',
						['insidezigzagfold']				=	'ns0000:InsideZigzagFold',
						['rightortopinsidedoublefold']		=	'ns0000:RightOrTopInsideDoubleFold',
						['leftorbottominsidedoublefold']	=	'ns0000:LeftOrBottomInsideDoubleFold',
						['rightortopoutsidedoublefold']		=	'ns0000:RightOrTopOutsideDoubleFold',
						['leftorbottomoutsidedoublefold']	=	'ns0000:LeftOrBottomOutsideDoubleFold',
						['insidedoublegatefold']			=	'ns0000:InsideDoubleGateFold',
						['outsidedoublegatefold']			=	'ns0000:OutsideDoubleGateFold',
						['standardfold']					=	'ns0000:StandardFold',
						['narrowstandardfold']				=	'ns0000:NarrowStandardFold',
						['marginfold']						=	'ns0000:MarginFold',
						['fanfold140mm']					=	'ns0000:FanFold140mm',
						['fanfold170mm']					=	'ns0000:FanFold170mm',
						['fanfold210mm']					=	'ns0000:FanFold210mm',
						['fanfold297mm']					=	'ns0000:FanFold297mm',
						['fanfold8.5inch']					=	'ns0000:FanFold8.5inch',
						['fanfold9inch']					=	'ns0000:FanFold9inch',
						['fanfold11inch']					=	'ns0000:FanFold11inch',
						['fanfold12inch']					=	'ns0000:FanFold12inch',
						['fanfoldwithmargin']				=	'ns0000:FanFoldWithMargin',
						['specialfanfold1']					=	'ns0000:SpecialFanFold1',
						['specialfanfold2']					=	'ns0000:SpecialFanFold2',
						['specialfold1']					=	'ns0000:SpecialFold1',
						['specialfold2']					=	'ns0000:SpecialFold2',
						['programfold1']					=	'ns0000:ProgramFold1',
						['programfold2']					=	'ns0000:ProgramFold2',
						['programfold3']					=	'ns0000:ProgramFold3',
						['programfold4']					=	'ns0000:ProgramFold4'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 12-01 Multi-sheet fold
	multisheetfold	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobMultiSheetFold'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					multisheetfold	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 12-02 Fold Stamp
	foldstamp	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobFoldStamp'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					foldstamp	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 12-03 Fold Punch
	foldpunch	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobFoldPunch'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					foldpunch	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 12-04 Edge Fold
	edgefold	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobEdgeFold'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					edgefold	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 13 Trimming
	trimming	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	=	'ns0000:JobTrimming'
		},
		children	=
		{
			tag 		=	'psf:Option',
			attribute	=
			{
				key 	=	'name',
				value 	=
				{
					trimming	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			},
			children	=	function(tbl)
								if((nil ==  tbl['trimming_cutedge_mm'])
									or 'off' == tbl['trimming']
									or ('1' == tbl['disable_cutedge_option'])) then
									return nil
								end
								return	{
											tag			=	'psf:ScoredProperty',
											attribute	=
												{
													key		=	'name',
													value	=	'ns0000:TrimmingCutEdge'
												},
											children	=	{
														tag			= 	'psf:Value',
														attribute	=
															{
																key		=	'xsi:type',
																value	=	'xsd:integer'
															},
														text	=	tostring(tbl['trimming_cutedge_mm'] * 100)
												}
										}
							end
		}
	},
	-- 14 Face Up
	faceup	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobEjectFaceUp'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					faceup	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 15 Do not print blank pages
	donotprintblankpages	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobWhitePaperSuppress'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					donotprintblankpages	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:On' }
				}
			}
		}
	},
	-- 16 Shift Paper
	shiftpaper	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageShiftPaper'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					shiftpaper	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 17 Orientation Override
	orientationoverride	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:DocumentOrientationOvrerride'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					orientationoverride	=
					{
						['portrait']	=	'ns0000:Portrait',
						['landscape']	=	'ns0000:Landscape',
						['off']			=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 18 Perfect Binding
	perfectbinding	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	=	'ns0000:JobPerfectBind'
		},
		children	=	function(tbl)
				local result_table = {}
				
				-- Perfect Binding (Binding Directions)
				local perfectbind_val = 'ns0000:Off'
				
				if('off' == tbl['perfectbinding'])then
					perfectbind_val = 'ns0000:Off'
				elseif('on' == tbl['perfectbinding'] 
						and nil ~= tbl['perfectbinding_direction'] 
						and 'rightortop' == tbl['perfectbinding_direction'])then
					perfectbind_val = 'ns0000:RightOrTop'
				elseif('on' == tbl['perfectbinding'])then
					perfectbind_val = 'ns0000:LeftOrTop'
				else
					perfectbind_val = 'ns0000:Off'
				end
				
				local perfectbind_scored_table = nil
				if((nil ~= tbl['perfectbinding_imgpos_along_mm'] 
					or nil ~= tbl['perfectbinding_imgpos_across_mm'])
					and 'ns0000:Off' ~= perfectbind_val)then
					perfectbind_scored_table = {}
				end
				
				--Image Shift--
				if(nil ~= tbl['perfectbinding_imgpos_along_mm']
					and 'ns0000:Off' ~= perfectbind_val)then
					table.insert(perfectbind_scored_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:VerticalImageShift'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tostring( tonumber( tbl['perfectbinding_imgpos_along_mm'] ) * 100 )
									}
								}
						}
					)
				end
				
				if(nil ~= tbl['perfectbinding_imgpos_across_mm']
					and 'ns0000:Off' ~= perfectbind_val)then
					table.insert(perfectbind_scored_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:HorizontalImageShift'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tostring( tonumber( tbl['perfectbinding_imgpos_across_mm'] ) * 100 )
									}
								}
						}
					)
				end
				
				table.insert(result_table, {
					tag 		=	'psf:Option',
					attribute	=
					{
						key 	=	'name',
						value	=	perfectbind_val
					},
					children	=	perfectbind_scored_table
				})
				
				-- Binding Cut Type
				if(nil ~= tbl['perfectbinding_cuttype'])then
					local cuttype_element_table	=
						{
							['donotcut']						=	'ns0000:Off',
							['cutforeedgespecifyfinishingsize']	=	'ns0000:SingleCutFinishSize',
							['cutforeedge']						=	'ns0000:SingleCut',
							['cut3edgesspecifyfinishingsize']	=	'ns0000:TripleCutFinishSize',
							['cut3edges']						=	'ns0000:TripleCut',
						}
					
					local cuttype_val = cuttype_element_table[tbl['perfectbinding_cuttype']]
					if(nil == cuttype_val)then
						cuttype_val = 'ns0000:Off'
					end
					
					local cuttype_child_table = nil
					if('ns0000:Off' ~= cuttype_val)then
						cuttype_child_table = {}
					end
					--Cut Position Fine Adjustment--
					if(nil ~= tbl['perfectbinding_cutpos_along_mm']
						and 'cut3edgesspecifyfinishingsize' == tbl['perfectbinding_cuttype'])then
						table.insert(cuttype_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:CutAdjustmentShift'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_cutpos_along_mm'] ) * 100 )
										}
									}
							}
						)
					end
				
					--Cut Head Edge--
					if(nil ~= tbl['perfectbinding_cutpos_head_mm']
						and 'cut3edges' == tbl['perfectbinding_cuttype'])then
						table.insert(cuttype_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:TopCutLength'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_cutpos_head_mm'] ) * 100 )
										}
									}
							}
						)
					end
				
					--Cut Tail Edge--
					if(nil ~= tbl['perfectbinding_cutpos_tail_mm']
						and 'cut3edges' == tbl['perfectbinding_cuttype'])then
						table.insert(cuttype_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:BottomCutLength'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_cutpos_tail_mm'] ) * 100 )
										}
									}
							}
						)
					end
					
					--Cut Fore Edge--
					if(nil ~= tbl['perfectbinding_cutpos_fore_mm']
						and ('cut3edges' == tbl['perfectbinding_cuttype']
							or 'cutforeedge' == tbl['perfectbinding_cuttype']))then
						table.insert(cuttype_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:SideEdgeCutLength'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_cutpos_fore_mm'] ) * 100 )
										}
									}
							}
						)
					end
					
					--Length Finish Size--
					if(nil ~= tbl['perfectbinding_cutpos_length_mm']
						and 'cutforeedgespecifyfinishingsize' == tbl['perfectbinding_cuttype'])then
						table.insert(cuttype_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:PageWidthCutLength'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_cutpos_length_mm'] ) * 100 )
										}
									}
							}
						)
					end
					table.insert(result_table,
						{
							tag			=	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:PerfectBindTrimMode'
							},
							children	=
							{
								tag 		=	'psf:Option',
								attribute	=
								{
									key 	=	'name',
									value	=	cuttype_val
								},
								children	=	cuttype_child_table
							}
						}
					)
				end
					
				-- Specify Cut Size
				if(nil ~= tbl['perfectbinding_cutpos_finishing_size'])then
					local cutsize_element_table	=
						{
							['12x18']				=	'ns0000:_12X18',
							['11x17']				=	'ns0000:NorthAmerica11x17',
							['legal']				=	'ns0000:NorthAmericaLegal',
							['letter']				=	'ns0000:NorthAmericaLetter',
							['executive']			=	'ns0000:NorthAmericaExecutive',
							['5.5x8.5']				=	'ns0000:NorthAmericaStatement',
							['a0']					=	'ns0000:ISOA0',
							['a1']					=	'ns0000:ISOA1',
							['a2']					=	'ns0000:ISOA2',
							['a3']					=	'ns0000:ISOA3',
							['a4']					=	'ns0000:ISOA4',
							['a5']					=	'ns0000:ISOA5',
							['a6']					=	'ns0000:ISOA6',
							['b1']					=	'ns0000:JISB1',
							['b2']					=	'ns0000:JISB2',
							['b3']					=	'ns0000:JISB3',
							['b4jis']				=	'ns0000:JISB4',
							['b5jis']				=	'ns0000:JISB5',
							['b6']					=	'ns0000:JISB6',
							['b7']					=	'ns0000:JISB7',
							['8x13']				=	'ns0000:_8X13',
							['8.25x13']				=	'ns0000:_8_25X13',
							['8.5x13']				=	'ns0000:FOLIO',
							['8.5x13.4']			=	'ns0000:_8_5X13_4',
							['com10env']			=	'ns0000:NorthAmericaNumber10Envelope',
							['monarchenv']			=	'ns0000:NorthAmericaMonarchEnvelope',
							['dlenv']				=	'ns0000:ISODLEnvelope',
							['c6env']				=	'ns0000:ISOC6Envelope',
							['c5env']				=	'ns0000:ISOC5Envelope',
							['chou3jenv']			=	'ns0000:JapanChou3Envelope',
							['chou4jenv']			=	'ns0000:JapanChou4Envelope',
							['you4jenv']			=	'ns0000:JapanYou4Envelope',
							['youchou3jenv']		=	'ns0000:JapanYou4EnvelopeRotated',
							['kaku1jenv']			=	'ns0000:JapanKaku1Envelope',
							['kaku2jenv']			=	'ns0000:JapanKaku2Envelope',
							['bd']					=	'ns0000:BD',
							['lineslider1']			=	'ns0000:LineSlider1',
							['lineslider2']			=	'ns0000:LineSlider2',
							['glt']					=	'ns0000:_8X10_5',
							['10x14']				=	'ns0000:NorthAmerica10x14',
							['10x15']				=	'ns0000:_10X15',
							['11x15']				=	'ns0000:_11X15',
							['15x20']				=	'ns0000:_15X20',
							['8k']					=	'ns0000:_8kai',
							['16k']					=	'ns0000:_16kai',
							['postcard']			=	'ns0000:JapanHagakiPostcard',
							['doublepostcard']		=	'ns0000:JapanDoubleHagakiPostcardRotated',
							['doublepostcardrotated']		=	'ns0000:JapanDoubleHagakiPostcard',
							['governmentlg']		=	'ns0000:_8_25X14',
							['engquatro']			=	'ns0000:NorthAmerica8x10',
							['sra3']				=	'ns0000:_320X450',
							['sra4']				=	'ns0000:_225X320',
							['11x14']				=	'ns0000:_11X14',
							['13x19.2']				=	'ns0000:_13X19_2',
							['13x19']				=	'ns0000:_13X19',
							['12.6x19.2']			=	'ns0000:_12_6X19_2',
							['12.6x18.5']			=	'ns0000:_12_6X18_5',
							['13x18']				=	'ns0000:_13X18',
							['226x310mm']			=	'ns0000:_226X310',
							['310x432mm']			=	'ns0000:_310X432',
							['8.5x12']				=	'ns0000:NorthAmericaGermanStandardFanfold',
							['17x22']				=	'ns0000:Ansic',
							['9x12']				=	'ns0000:_9X12',
							['18x24']				=	'ns0000:_18X24',
							['21x30']				=	'ns0000:_21X30',
							['22x34']				=	'ns0000:_22X34',
							['24x36']				=	'ns0000:_24X36',
							['30x42']				=	'ns0000:_30X42',
							['34x44']				=	'ns0000:_34X44',
							['36x48']				=	'ns0000:_36X48',
							['postcardstandard']	=	'ns0000:PostcardStandard',
							['kiku4']				=	'ns0000:Kiku4',
							['329x483mm']			=	'ns0000:_329X483',
							['8.5x13.5']			=	'ns0000:_8_5X13_5',
							['kaku3jenv']			=	'ns0000:JapanKaku3Envelope',
							['custompapersize']		=	'ns0000:CustomMediaSize',
							['custompapersize1']	=	'ns0000:CustomSize1',
							['custompapersize2']	=	'ns0000:CustomSize2',
							['custompapersize3']	=	'ns0000:CustomSize3',
							['custompapersize4']	=	'ns0000:CustomSize4',
							['custompapersize5']	=	'ns0000:CustomSize5',
							['custompapersize6']	=	'ns0000:CustomSize6',
							['custompapersize7']	=	'ns0000:CustomSize7',
							['custompapersize8']	=	'ns0000:CustomSize8',
							['custompapersize9']	=	'ns0000:CustomSize9',
							['custompapersize10']	=	'ns0000:CustomSize10',
							['custompapersize11']	=	'ns0000:CustomSize11',
							['custompapersize12']	=	'ns0000:CustomSize12',
							['custompapersize13']	=	'ns0000:CustomSize13',
							['custompapersize14']	=	'ns0000:CustomSize14',
							['custompapersize15']	=	'ns0000:CustomSize15',
							['custompapersize16']	=	'ns0000:CustomSize16',
							['custompapersize17']	=	'ns0000:CustomSize17',
							['custompapersize18']	=	'ns0000:CustomSize18',
							['custompapersize19']	=	'ns0000:CustomSize19',
							['custompapersize20']	=	'ns0000:CustomSize20',
							['custompapersize21']	=	'ns0000:CustomSize21',
							['custompapersize22']	=	'ns0000:CustomSize22',
							['custompapersize23']	=	'ns0000:CustomSize23',
							['custompapersize24']	=	'ns0000:CustomSize24',
							['custompapersize25']	=	'ns0000:CustomSize25',
							['custompapersize26']	=	'ns0000:CustomSize26',
							['custompapersize27']	=	'ns0000:CustomSize27',
							['custompapersize28']	=	'ns0000:CustomSize28',
							['custompapersize29']	=	'ns0000:CustomSize29',
							['custompapersize30']	=	'ns0000:CustomSize30',
							['custompapersize31']	=	'ns0000:CustomSize31',
							['custompapersize32']	=	'ns0000:CustomSize32',
							['custompapersize33']	=	'ns0000:CustomSize33',
							['custompapersize34']	=	'ns0000:CustomSize34',
							['custompapersize35']	=	'ns0000:CustomSize35',
							['custompapersize36']	=	'ns0000:CustomSize36',
							['custompapersize37']	=	'ns0000:CustomSize37',
							['custompapersize38']	=	'ns0000:CustomSize38',
							['custompapersize39']	=	'ns0000:CustomSize39',
							['custompapersize40']	=	'ns0000:CustomSize40',
							['custompapersize41']	=	'ns0000:CustomSize41',
							['custompapersize42']	=	'ns0000:CustomSize42',
							['custompapersize43']	=	'ns0000:CustomSize43',
							['custompapersize44']	=	'ns0000:CustomSize44',
							['custompapersize45']	=	'ns0000:CustomSize45',
							['custompapersize46']	=	'ns0000:CustomSize46',
							['custompapersize47']	=	'ns0000:CustomSize47',
							['custompapersize48']	=	'ns0000:CustomSize48',
							['custompapersize49']	=	'ns0000:CustomSize49',
							['custompapersize50']	=	'ns0000:CustomSize50',
							['custompapersize51']	=	'ns0000:CustomSize51',
							['custompapersize52']	=	'ns0000:CustomSize52',
							['custompapersize53']	=	'ns0000:CustomSize53',
							['custompapersize54']	=	'ns0000:CustomSize54',
							['custompapersize55']	=	'ns0000:CustomSize55',
							['custompapersize56']	=	'ns0000:CustomSize56',
							['custompapersize57']	=	'ns0000:CustomSize57',
							['custompapersize58']	=	'ns0000:CustomSize58',
							['custompapersize59']	=	'ns0000:CustomSize59',
							['custompapersize60']	=	'ns0000:CustomSize60',
							['custompapersize61']	=	'ns0000:CustomSize61',
							['custompapersize62']	=	'ns0000:CustomSize62',
							['custompapersize63']	=	'ns0000:CustomSize63',
							['custompapersize64']	=	'ns0000:CustomSize64',
							['custompapersize65']	=	'ns0000:CustomSize65',
							['custompapersize66']	=	'ns0000:CustomSize66',
							['custompapersize67']	=	'ns0000:CustomSize67',
							['custompapersize68']	=	'ns0000:CustomSize68',
							['custompapersize69']	=	'ns0000:CustomSize69',
							['custompapersize70']	=	'ns0000:CustomSize70',
							['custompapersize71']	=	'ns0000:CustomSize71',
							['custompapersize72']	=	'ns0000:CustomSize72',
							['custompapersize73']	=	'ns0000:CustomSize73',
							['custompapersize74']	=	'ns0000:CustomSize74',
							['custompapersize75']	=	'ns0000:CustomSize75',
							['custompapersize76']	=	'ns0000:CustomSize76',
							['custompapersize77']	=	'ns0000:CustomSize77',
							['custompapersize78']	=	'ns0000:CustomSize78',
							['custompapersize79']	=	'ns0000:CustomSize79',
							['custompapersize80']	=	'ns0000:CustomSize80',
							['custompapersize81']	=	'ns0000:CustomSize81',
							['custompapersize82']	=	'ns0000:CustomSize82',
							['custompapersize83']	=	'ns0000:CustomSize83',
							['custompapersize84']	=	'ns0000:CustomSize84',
							['custompapersize85']	=	'ns0000:CustomSize85',
							['custompapersize86']	=	'ns0000:CustomSize86',
							['custompapersize87']	=	'ns0000:CustomSize87',
							['custompapersize88']	=	'ns0000:CustomSize88',
							['custompapersize89']	=	'ns0000:CustomSize89',
							['custompapersize90']	=	'ns0000:CustomSize90',
							['custompapersize91']	=	'ns0000:CustomSize91',
							['custompapersize92']	=	'ns0000:CustomSize92',
							['custompapersize93']	=	'ns0000:CustomSize93',
							['custompapersize94']	=	'ns0000:CustomSize94',
							['custompapersize95']	=	'ns0000:CustomSize95',
							['custompapersize96']	=	'ns0000:CustomSize96',
							['custompapersize97']	=	'ns0000:CustomSize97',
							['custompapersize98']	=	'ns0000:CustomSize98',
							['custompapersize99']	=	'ns0000:CustomSize99',
							['custompapersize100']	=	'ns0000:CustomSize100'
						}
					
					local cutsize_val = cutsize_element_table[tbl['perfectbinding_cutpos_finishing_size']]
					if(nil == cutsize_val)then
						cutsize_val = 'ns0000:ISOA4'
					end
					
					local cutsize_child_table = nil
					if('ns0000:CustomMediaSize' == cutsize_val)then
						cutsize_child_table = {}
					end
					--Custom Cut Size--
					if(nil ~= tbl['perfectbinding_cutpos_customsize_width_mm']
						and 'ns0000:CustomMediaSize' == cutsize_val)then
						table.insert(cutsize_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:CutSizeWidth'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_cutpos_customsize_width_mm'] ) * 100 )
										}
									}
							}
						)
					end
					
					if(nil ~= tbl['perfectbinding_cutpos_customsize_length_mm']
						and 'ns0000:CustomMediaSize' == cutsize_val)then
						table.insert(cutsize_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:CutSizeHeight'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_cutpos_customsize_length_mm'] ) * 100 )
										}
									}
							}
						)
					end
					table.insert(result_table,
						{
							tag			=	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:PerfectBindCutAdjustmentByPaperSize'
							},
							children	=
							{
								tag 		=	'psf:Option',
								attribute	=
								{
									key 	=	'name',
									value	=	cutsize_val
								},
								children	=	cutsize_child_table
							}
						}
					)
				end
					
					
				-- Binding Cover Sheet Input Tray
				if(nil ~= tbl['perfectbinding_inputtray'])then
					local tray_element_table	=
						{
							['tray1']				=	'ns0000:Tray1',
							['tray1roll']			=	'ns0000:Tray1_Roll',
							['tray2']				=	'ns0000:Tray2',
							['tray2roll']			=	'ns0000:Tray2_Roll',
							['tray3']				=	'ns0000:Tray3',
							['tray3lct']			=	'ns0000:Tray3_LCT',
							['tray3roll']			=	'ns0000:Tray3_Roll',
							['tray4']				=	'ns0000:Tray4',
							['tray4roll']			=	'ns0000:Tray4_Roll',
							['tray5']				=	'ns0000:Tray5',
							['tray6']				=	'ns0000:Tray6',
							['tray7']				=	'ns0000:Tray7',
							['tray8']				=	'ns0000:Tray8',
							['tray9']				=	'ns0000:Tray9',
							['tray10']				=	'ns0000:Tray10',
							['tray11']				=	'ns0000:Tray11',
							['traya']				=	'ns0000:TrayA',
							['onesheetbypass']		=	'ns0000:OneSheetBypassTray',
							['bypasstray']			=	'ns0000:BypassTray',
							['frontbypasstray']		=	'ns0000:FrontBypassTray',
							['largecapacitytray']	=	'ns0000:LCT',
							['interposer']			=	'ns0000:Inserter',
							['interposeruppertray']	=	'ns0000:InserterUpper',
							['interposerlowertray']	=	'ns0000:InserterLower',
							['bindinginterposer1']	=	'ns0000:BindInserter',
							['bindinginterposer2']	=	'ns0000:BindInserter2',
							['paperfeedtray']		=	'ns0000:PaperFeedTray',
						}
					
					local tray_val = tray_element_table[tbl['perfectbinding_inputtray']]
					if(nil == tray_val)then
						tray_val = 'ns0000:Tray1'
					end
					
					table.insert(result_table,
						{
							tag			=	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:PerfectBindCoverTray'
							},
							children	=
							{
								tag 		=	'psf:Option',
								attribute	=
								{
									key 	=	'name',
									value	=	tray_val
								},
							}
						}
					)
				end
					
				-- Perfect Binding Cover Sheet Print
				if(nil ~= tbl['perfectbinding_coversheetprint'])then
						local coverprint_element_table	=
						{
							['off']					=	'ns0000:Off',
							['backcover']			=	'ns0000:BackCover',
							['frontcover']			=	'ns0000:FrontCover',
							['frontandbackcover']	=	'ns0000:FrontCoverAndBackCover',
						}
					
					local coverprint_val = coverprint_element_table[tbl['perfectbinding_coversheetprint']]
					if(nil == coverprint_val)then
						coverprint_val = 'ns0000:Off'
					end
					
					local coverprint_child_table = nil
					if('ns0000:Off' ~= coverprint_val)then
						coverprint_child_table = {}
					end
					--Cover Sheet Image Position--
					if(nil ~= tbl['perfectbinding_coversheet_imgpos_along_mm']
						and 'ns0000:Off' ~= coverprint_val)then
						table.insert(coverprint_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:ShiftAlong'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_coversheet_imgpos_along_mm'] ) * 100 )
										}
									}
							}
						)
					end
					
					if(nil ~= tbl['perfectbinding_coversheet_imgpos_across_mm']
						and 'ns0000:Off' ~= coverprint_val)then
						table.insert(coverprint_child_table,
							{
								tag			=	'psf:ScoredProperty',
								attribute	=
									{
										key		=	'name',
										value	=	'ns0000:ShiftAcross'
									},
								children	=	{
										{
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text	=	tostring( tonumber( tbl['perfectbinding_coversheet_imgpos_across_mm'] ) * 100 )
										}
									}
							}
						)
					end
					table.insert(result_table,
						{
							tag			=	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:PerfectBindCoverPrint'
							},
							children	=
							{
								tag 		=	'psf:Option',
								attribute	=
								{
									key 	=	'name',
									value	=	coverprint_val
								},
								children	=	coverprint_child_table
							}
						}
					)
				end
					
				return result_table
				end
	},
	-- 19 Sheet-dry print delay in duplex/booklet
	duplex_sheetdryprintdelay	=
	{
		tag			=	'psf:ParameterInit',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobDelayTimeForDuplex'
		},
		children	=
		{
			tag			=	'psf:Value',
			attribute	=
			{
				key		=	'xsi:type',
				value	=	'xsd:integer'
			},
			text	=	function(tbl)
							return tostring(tbl.duplex_sheetdryprintdelay)
						end
		}
	},
	-- 20 Generic Function
	genericfunction	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobGenericFunction'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					genericfunction	=
					{
						['off']					=	'ns0000:Off',
						['genericfunction1']	=	'ns0000:GenericFunction1',
						['genericfunction2']	=	'ns0000:GenericFunction2',
						['genericfunction3']	=	'ns0000:GenericFunction3',
						['genericfunction4']	=	'ns0000:GenericFunction4',
						['genericfunction5']	=	'ns0000:GenericFunction5',
						['genericfunction6']	=	'ns0000:GenericFunction6',
						['genericfunction7']	=	'ns0000:GenericFunction7',
						['genericfunction8']	=	'ns0000:GenericFunction8',
						['genericfunction9']	=	'ns0000:GenericFunction9'
					},
					default	= { 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 21 TwinLoop Binding
	twinloopbinding	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobTwinLoopBind'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					twinloopbinding	=
					{
						['off']					=	'ns0000:Off',
						['leftortop']			=	'ns0000:LeftOrTopPunchAndTwinLoopBooklet',
						['rightortop']			=	'ns0000:RightOrTopPunchAndTwinLoopBooklet'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 21 Square Fold
	squarefold	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobSquareFold'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					squarefold	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
-- [03 Paper Feed]
	-- 01-01 Standard Pages : Input Tray
	standardpages_inputtray	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:JobInputBin'
		},
		children	=	function(tbl)
				local result_table ={}
				local tray_table	=
					{
						['autotrayselect']		=	'ns0000:AUTO',
						['tray1']				=	'ns0000:Tray1',
						['tray1roll']			=	'ns0000:Tray1_Roll',
						['tray2']				=	'ns0000:Tray2',
						['tray2roll']			=	'ns0000:Tray2_Roll',
						['tray3']				=	'ns0000:Tray3',
						['tray3lct']			=	'ns0000:Tray3_LCT',
						['tray3roll']			=	'ns0000:Tray3_Roll',
						['tray4']				=	'ns0000:Tray4',
						['tray4roll']			=	'ns0000:Tray4_Roll',
						['tray5']				=	'ns0000:Tray5',
						['tray6']				=	'ns0000:Tray6',
						['tray7']				=	'ns0000:Tray7',
						['tray8']				=	'ns0000:Tray8',
						['tray9']				=	'ns0000:Tray9',
						['tray10']				=	'ns0000:Tray10',
						['tray11']				=	'ns0000:Tray11',
						['traya']				=	'ns0000:TrayA',
						['bypasstray']			=	'ns0000:BypassTray',
						['onesheetbypass']		=	'ns0000:OneSheetBypassTray',
						['frontbypasstray']		=	'ns0000:FrontBypassTray',
						['largecapacitytray']	=	'ns0000:LCT',
						['paperfeedtray']		=	'ns0000:PaperFeedTray',
					}
				local tray_val
				
				if(nil ~= tbl['slipsheet'] and 'on' == tbl['slipsheet'] and nil ~= tbl['transparency_inputtray'])then
					tray_val = tray_table[tbl['transparency_inputtray']]
				else
					tray_val = tray_table[tbl['standardpages_inputtray']]
				end
				
				if(nil == tray_val)then
					tray_val = 'ns0000:Tray1'
				end
				
				table.insert(result_table, {
						tag			=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	tray_val
						},
				})
				
				return result_table
			
			end
	},
	-- 01-02 Standard Pages : Media Type
	standardpages_mediatype	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:PageMediaType'
		},
		children	=	function(tbl)
				local result_table ={}
				local media_table	=
					{
						['plainandrecycled']		=	'ns0000:Standard_Recycled',
						['plain']					=	'psk:Plain',
						['plain2']					=	'ns0000:Plain2',
						['recycled']				=	'ns0000:Recycled',
						['inkjetplain']				=	'ns0000:InkjetPlain',
						['special']					=	'ns0000:Special',
						['special2']				=	'ns0000:Special2',
						['special3']				=	'ns0000:Special3',
						['special4']				=	'ns0000:Special4',
						['special5']				=	'ns0000:Special5',
						['special6']				=	'ns0000:Special6',
						['thick']					=	'ns0000:Thick',
						['middlethick']				=	'ns0000:MiddleThick',
						['thick2']					=	'ns0000:Thick2',
						['thick3']					=	'ns0000:Thick3',
						['thick4']					=	'ns0000:Thick4',
						['thin']					=	'ns0000:Thin',
						['transparency']			=	'psk:Transparency',
						['translucent']				=	'ns0000:Translucent',
						['color']					=	'ns0000:Color',
						['color1']					=	'ns0000:Color1',
						['color2']					=	'ns0000:Color2',
						['letterhead']				=	'ns0000:Letterhead',
						['preprinted']				=	'ns0000:Preprinted',
						['plainduplexbackside']		=	'ns0000:Plain_Duplex_Backside',
						['thickduplexbackside']		=	'ns0000:Thick_Duplex_Backside',
						['thick2duplexbackside']	=	'ns0000:Thick_Duplex_Backside2',
						['thick3duplexbackside']	=	'ns0000:Thick_Duplex_Backside3',
						['thick4duplexbackside']	=	'ns0000:Thick_Duplex_Backside4',
						['prepunched']				=	'ns0000:Prepunched',
						['labels']					=	'psk:Label',
						['bond']					=	'psk:Bond',
						['cardstock']				=	'psk:CardStock',
						['tabstock']				=	'psk:TabStockPreCut',
						['glossytabstock']			=	'ns0000:GlossyTabStock',
						['mattabstock']				=	'ns0000:MatTabStock',
						['moreglossytabstock']		=	'ns0000:MoreGlossyTabStock',
						['yellow']					=	'ns0000:Yellow',
						['green']					=	'ns0000:Green',
						['blue']					=	'ns0000:Blue',
						['purple']					=	'ns0000:Purple',
						['ivory']					=	'ns0000:Ivory',
						['orange']					=	'ns0000:Orange',
						['pink']					=	'ns0000:Pink',
						['red']						=	'ns0000:Red',
						['gray']					=	'ns0000:Gray',
						['glossy']					=	'psk:PhotographicGlossy',
						['semiglossy']				=	'ns0000:SemiGlossy',
						['glossycoated']			=	'ns0000:GlossyCoated',
						['matcoated']				=	'ns0000:MatCoated',
						['matfilm']					=	'ns0000:MatFilm',
						['thickmatcoated']			=	'ns0000:ThickMatCoated',
						['hgplain']					=	'ns0000:HGPlain',
						['envelope']				=	'psk:EnvelopePlain',
						['glossyenvelope']			=	'ns0000:GlossyEnvelope',
						['matenvelope']				=	'ns0000:MatEnvelope',
						['moreglossyenvelope']		=	'ns0000:MoreGlossyEnvelope',
						['postcard']				=	'ns0000:Jpost',
						['inkjetpostcard']			=	'ns0000:InkjetJpost',
						['coated']					=	'ns0000:Coated',
						['cadcoated']				=	'ns0000:CadCoated',
						['postcardduplexbackside']	=	'ns0000:Jpost_Duplex_Backside',
						['thickglossycoated']		=	'ns0000:ThickGlossyCoated',
						['waterproof']				=	'ns0000:WaterProof',
						['film']					=	'ns0000:Film',
						['thickglossy']				=	'ns0000:ThickGlossy',
						['black']					=	'ns0000:Black',
						['clearfile']				=	'ns0000:ClearFile',
						['magnet']					=	'ns0000:Magnet',
						['metallicpearl']			=	'ns0000:MetallicPearl',
						['synthetic']				=	'ns0000:Synthetic',
						['texture']					=	'ns0000:Texture',
						['auto']					=	'psk:AutoSelect',
						['ncr']						=	'ns0000:NCR',
						['none']					=	'ns0000:None',
						['+custom1']				=	'ns0000:Custom1',
						['+custom2']				=	'ns0000:Custom2',
						['+custom3']				=	'ns0000:Custom3',
						['+custom4']				=	'ns0000:Custom4',
						['+custom5']				=	'ns0000:Custom5',
						['+custom6']				=	'ns0000:Custom6',
						['+custom7']				=	'ns0000:Custom7',
						['+custom8']				=	'ns0000:Custom8',
						['+custom9']				=	'ns0000:Custom9',
						['+custom10']				=	'ns0000:Custom10',
						['+custom11']				=	'ns0000:Custom11',
						['+custom12']				=	'ns0000:Custom12',
						['+custom13']				=	'ns0000:Custom13',
						['+custom14']				=	'ns0000:Custom14',
						['+custom15']				=	'ns0000:Custom15',
						['+custom16']				=	'ns0000:Custom16',
						['+custom17']				=	'ns0000:Custom17',
						['+custom18']				=	'ns0000:Custom18',
						['+custom19']				=	'ns0000:Custom19',
						['+custom20']				=	'ns0000:Custom20',
						['+custom21']				=	'ns0000:Custom21',
						['+custom22']				=	'ns0000:Custom22',
						['+custom23']				=	'ns0000:Custom23',
						['+custom24']				=	'ns0000:Custom24',
						['+custom25']				=	'ns0000:Custom25',
						['+custom26']				=	'ns0000:Custom26',
						['+custom27']				=	'ns0000:Custom27',
						['+custom28']				=	'ns0000:Custom28',
						['+custom29']				=	'ns0000:Custom29',
						['+custom30']				=	'ns0000:Custom30',
						['+custom31']				=	'ns0000:Custom31',
						['+custom32']				=	'ns0000:Custom32',
						['+custom33']				=	'ns0000:Custom33',
						['+custom34']				=	'ns0000:Custom34',
						['+custom35']				=	'ns0000:Custom35',
						['+custom36']				=	'ns0000:Custom36',
						['+custom37']				=	'ns0000:Custom37',
						['+custom38']				=	'ns0000:Custom38',
						['+custom39']				=	'ns0000:Custom39',
						['+custom40']				=	'ns0000:Custom40',
						['+custom41']				=	'ns0000:Custom41',
						['+custom42']				=	'ns0000:Custom42',
						['+custom43']				=	'ns0000:Custom43',
						['+custom44']				=	'ns0000:Custom44',
						['+custom45']				=	'ns0000:Custom45',
						['+custom46']				=	'ns0000:Custom46',
						['+custom47']				=	'ns0000:Custom47',
						['+custom48']				=	'ns0000:Custom48',
						['+custom49']				=	'ns0000:Custom49',
						['+custom50']				=	'ns0000:Custom50',
						['+custom51']				=	'ns0000:Custom51',
						['+custom52']				=	'ns0000:Custom52',
						['+custom53']				=	'ns0000:Custom53',
						['+custom54']				=	'ns0000:Custom54',
						['+custom55']				=	'ns0000:Custom55',
						['+custom56']				=	'ns0000:Custom56',
						['+custom57']				=	'ns0000:Custom57',
						['+custom58']				=	'ns0000:Custom58',
						['+custom59']				=	'ns0000:Custom59',
						['+custom60']				=	'ns0000:Custom60',
						['+custom61']				=	'ns0000:Custom61',
						['+custom62']				=	'ns0000:Custom62',
						['+custom63']				=	'ns0000:Custom63',
						['+custom64']				=	'ns0000:Custom64',
						['+custom65']				=	'ns0000:Custom65',
						['+custom66']				=	'ns0000:Custom66',
						['+custom67']				=	'ns0000:Custom67',
						['+custom68']				=	'ns0000:Custom68',
						['+custom69']				=	'ns0000:Custom69',
						['+custom70']				=	'ns0000:Custom70',
						['+custom71']				=	'ns0000:Custom71',
						['+custom72']				=	'ns0000:Custom72',
						['+custom73']				=	'ns0000:Custom73',
						['+custom74']				=	'ns0000:Custom74',
						['+custom75']				=	'ns0000:Custom75',
						['+custom76']				=	'ns0000:Custom76',
						['+custom77']				=	'ns0000:Custom77',
						['+custom78']				=	'ns0000:Custom78',
						['+custom79']				=	'ns0000:Custom79',
						['+custom80']				=	'ns0000:Custom80',
						['+custom81']				=	'ns0000:Custom81',
						['+custom82']				=	'ns0000:Custom82',
						['+custom83']				=	'ns0000:Custom83',
						['+custom84']				=	'ns0000:Custom84',
						['+custom85']				=	'ns0000:Custom85',
						['+custom86']				=	'ns0000:Custom86',
						['+custom87']				=	'ns0000:Custom87',
						['+custom88']				=	'ns0000:Custom88',
						['+custom89']				=	'ns0000:Custom89',
						['+custom90']				=	'ns0000:Custom90',
						['+custom91']				=	'ns0000:Custom91',
						['+custom92']				=	'ns0000:Custom92',
						['+custom93']				=	'ns0000:Custom93',
						['+custom94']				=	'ns0000:Custom94',
						['+custom95']				=	'ns0000:Custom95',
						['+custom96']				=	'ns0000:Custom96',
						['+custom97']				=	'ns0000:Custom97',
						['+custom98']				=	'ns0000:Custom98',
						['+custom99']				=	'ns0000:Custom99',
						['+custom100']				=	'ns0000:Custom100',
						['+custom101']				=	'ns0000:Custom101',
						['+custom102']				=	'ns0000:Custom102',
						['+custom103']				=	'ns0000:Custom103',
						['+custom104']				=	'ns0000:Custom104',
						['+custom105']				=	'ns0000:Custom105',
						['+custom106']				=	'ns0000:Custom106',
						['+custom107']				=	'ns0000:Custom107',
						['+custom108']				=	'ns0000:Custom108',
						['+custom109']				=	'ns0000:Custom109',
						['+custom110']				=	'ns0000:Custom110',
						['+custom111']				=	'ns0000:Custom111',
						['+custom112']				=	'ns0000:Custom112',
						['+custom113']				=	'ns0000:Custom113',
						['+custom114']				=	'ns0000:Custom114',
						['+custom115']				=	'ns0000:Custom115',
						['+custom116']				=	'ns0000:Custom116',
						['+custom117']				=	'ns0000:Custom117',
						['+custom118']				=	'ns0000:Custom118',
						['+custom119']				=	'ns0000:Custom119',
						['+custom120']				=	'ns0000:Custom120',
						['+custom121']				=	'ns0000:Custom121',
						['+custom122']				=	'ns0000:Custom122',
						['+custom123']				=	'ns0000:Custom123',
						['+custom124']				=	'ns0000:Custom124',
						['+custom125']				=	'ns0000:Custom125',
						['+custom126']				=	'ns0000:Custom126',
						['+custom127']				=	'ns0000:Custom127',
						['+custom128']				=	'ns0000:Custom128',
						['+custom129']				=	'ns0000:Custom129',
						['+custom130']				=	'ns0000:Custom130',
						['+custom131']				=	'ns0000:Custom131',
						['+custom132']				=	'ns0000:Custom132',
						['+custom133']				=	'ns0000:Custom133',
						['+custom134']				=	'ns0000:Custom134',
						['+custom135']				=	'ns0000:Custom135',
						['+custom136']				=	'ns0000:Custom136',
						['+custom137']				=	'ns0000:Custom137',
						['+custom138']				=	'ns0000:Custom138',
						['+custom139']				=	'ns0000:Custom139',
						['+custom140']				=	'ns0000:Custom140',
						['+custom141']				=	'ns0000:Custom141',
						['+custom142']				=	'ns0000:Custom142',
						['+custom143']				=	'ns0000:Custom143',
						['+custom144']				=	'ns0000:Custom144',
						['+custom145']				=	'ns0000:Custom145',
						['+custom146']				=	'ns0000:Custom146',
						['+custom147']				=	'ns0000:Custom147',
						['+custom148']				=	'ns0000:Custom148',
						['+custom149']				=	'ns0000:Custom149',
						['+custom150']				=	'ns0000:Custom150',
						['+custom151']				=	'ns0000:Custom151',
						['+custom152']				=	'ns0000:Custom152',
						['+custom153']				=	'ns0000:Custom153',
						['+custom154']				=	'ns0000:Custom154',
						['+custom155']				=	'ns0000:Custom155',
						['+custom156']				=	'ns0000:Custom156',
						['+custom157']				=	'ns0000:Custom157',
						['+custom158']				=	'ns0000:Custom158',
						['+custom159']				=	'ns0000:Custom159',
						['+custom160']				=	'ns0000:Custom160',
						['+custom161']				=	'ns0000:Custom161',
						['+custom162']				=	'ns0000:Custom162',
						['+custom163']				=	'ns0000:Custom163',
						['+custom164']				=	'ns0000:Custom164',
						['+custom165']				=	'ns0000:Custom165',
						['+custom166']				=	'ns0000:Custom166',
						['+custom167']				=	'ns0000:Custom167',
						['+custom168']				=	'ns0000:Custom168',
						['+custom169']				=	'ns0000:Custom169',
						['+custom170']				=	'ns0000:Custom170',
						['+custom171']				=	'ns0000:Custom171',
						['+custom172']				=	'ns0000:Custom172',
						['+custom173']				=	'ns0000:Custom173',
						['+custom174']				=	'ns0000:Custom174',
						['+custom175']				=	'ns0000:Custom175',
						['+custom176']				=	'ns0000:Custom176',
						['+custom177']				=	'ns0000:Custom177',
						['+custom178']				=	'ns0000:Custom178',
						['+custom179']				=	'ns0000:Custom179',
						['+custom180']				=	'ns0000:Custom180',
						['+custom181']				=	'ns0000:Custom181',
						['+custom182']				=	'ns0000:Custom182',
						['+custom183']				=	'ns0000:Custom183',
						['+custom184']				=	'ns0000:Custom184',
						['+custom185']				=	'ns0000:Custom185',
						['+custom186']				=	'ns0000:Custom186',
						['+custom187']				=	'ns0000:Custom187',
						['+custom188']				=	'ns0000:Custom188',
						['+custom189']				=	'ns0000:Custom189',
						['+custom190']				=	'ns0000:Custom190',
						['+custom191']				=	'ns0000:Custom191',
						['+custom192']				=	'ns0000:Custom192',
						['+custom193']				=	'ns0000:Custom193',
						['+custom194']				=	'ns0000:Custom194',
						['+custom195']				=	'ns0000:Custom195',
						['+custom196']				=	'ns0000:Custom196',
						['+custom197']				=	'ns0000:Custom197',
						['+custom198']				=	'ns0000:Custom198',
						['+custom199']				=	'ns0000:Custom199',
						['+custom200']				=	'ns0000:Custom200',
					}
				local media_val
				
				if(nil ~= tbl['slipsheet'] and 'on' == tbl['slipsheet'] and nil ~= tbl['transparency_mediatype'])then
					media_val = media_table[tbl['transparency_mediatype']]
				else
					media_val = media_table[tbl['standardpages_mediatype']]
				end
				
				if(nil == media_val)then
					media_val = 'psk:Plain'
				end
				
				table.insert(result_table, {
						tag			=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	media_val
						},
				})
				
				return result_table
			
			end
	},
	-- 01-05 Tab Stock Printing
	standardpages_tabstockprinting	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobTabStockPrinting'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					standardpages_tabstockprinting	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 01-06 Shift Print Position for [Tab Stock] Printing
	standardpages_shiftprintposition	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobShftPositionForTabStock'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					standardpages_shiftprintposition	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 02 Front Cover
	frontcover	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobCoverFront'
		},
		children	=	function(tbl)
				local result_table ={}
				
				-- Front Cover
				local cover_val 
				if('off' == tbl['frontcover'])then
					cover_val = 'ns0000:NoCover'
					
				elseif('on' == tbl['frontcover'] and nil ~= tbl['frontcover_printmode'])then
					local cover_table	=
						{
							['leaveblank']	=	'ns0000:BlankCover',
							['oneside']		=	'ns0000:PrintSimplex',
							['bothsides']	=	'ns0000:PrintDuplex'
						}
					cover_val = cover_table[tbl['frontcover_printmode']]
				end
				
				if(nil == cover_val)then
					cover_val = 'ns0000:NoCover'
				end
				
				table.insert(result_table, {
					tag			=	'psf:Option',
					attribute	=
					{
						key		=	'name',
						value	=	cover_val
					},
				})
				
				if(nil ~= tbl['frontcover_inputtray'])then
						local tray_table	=
							{
								['tray1']				=	'ns0000:Tray1',
								['tray1roll']			=	'ns0000:Tray1_Roll',
								['tray2']				=	'ns0000:Tray2',
								['tray2roll']			=	'ns0000:Tray2_Roll',
								['tray3']				=	'ns0000:Tray3',
								['tray3lct']			=	'ns0000:Tray3_LCT',
								['tray3roll']			=	'ns0000:Tray3_Roll',
								['tray4']				=	'ns0000:Tray4',
								['tray4roll']			=	'ns0000:Tray4_Roll',
								['tray5']				=	'ns0000:Tray5',
								['tray6']				=	'ns0000:Tray6',
								['tray7']				=	'ns0000:Tray7',
								['tray8']				=	'ns0000:Tray8',
								['tray9']				=	'ns0000:Tray9',
								['tray10']				=	'ns0000:Tray10',
								['tray11']				=	'ns0000:Tray11',
								['traya']				=	'ns0000:TrayA',
								['bypasstray']			=	'ns0000:BypassTray',
								['frontbypasstray']		=	'ns0000:FrontBypassTray',
								['largecapacitytray']	=	'ns0000:LCT',
								['interposer']			=	'ns0000:Inserter',
								['interposeruppertray']	=	'ns0000:InserterUpper',
								['interposerlowertray']	=	'ns0000:InserterLower',
								['largecapacityinterposer1']	=	'ns0000:LargeCapacityInserter1',
								['largecapacityinterposer2']	=	'ns0000:LargeCapacityInserter2',
								['paperfeedtray']		=	'ns0000:PaperFeedTray',
							}
						local tray_val
						tray_val = tray_table[tbl['frontcover_inputtray']]
						if(nil == tray_val)then
							tray_val = 'ns0000:Tray1'
						end
						
						table.insert(result_table, {
							tag			= 	'psf:Feature',
							attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CoverFrontInputBin'
							},
							children	=	
								{
									tag			=	'psf:Option',
									attribute	=
									{
										key		=	'name',
										value	=	tray_val
									},
								}
						})
				end
				
				return result_table
			
			end
	},
	-- 03 Back Cover
	backcover	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobCoverBack'
		},
		children	=	function(tbl)
				local result_table ={}
				
				-- Front Cover
				local cover_val 
				if('off' == tbl['backcover'])then
					cover_val = 'ns0000:NoCover'
					
				elseif('on' == tbl['backcover'] and nil ~= tbl['backcover_printmode'])then
					local cover_table	=
						{
							['leaveblank']			=	'ns0000:BlankCover',
							['printonbackcover']	=	'ns0000:PrintInner',
							['printonouter']		=	'ns0000:PrintOuter'
						}
					cover_val = cover_table[tbl['backcover_printmode']]
				end
				
				if(nil == cover_val)then
					cover_val = 'ns0000:NoCover'
				end
				
				table.insert(result_table, {
					tag			=	'psf:Option',
					attribute	=
					{
						key		=	'name',
						value	=	cover_val
					},
				})
				
				if(nil ~= tbl['backcover_inputtray'])then
						local tray_table	=
							{
								['tray1']				=	'ns0000:Tray1',
								['tray1roll']			=	'ns0000:Tray1_Roll',
								['tray2']				=	'ns0000:Tray2',
								['tray2roll']			=	'ns0000:Tray2_Roll',
								['tray3']				=	'ns0000:Tray3',
								['tray3lct']			=	'ns0000:Tray3_LCT',
								['tray3roll']			=	'ns0000:Tray3_Roll',
								['tray4']				=	'ns0000:Tray4',
								['tray4roll']			=	'ns0000:Tray4_Roll',
								['tray5']				=	'ns0000:Tray5',
								['tray6']				=	'ns0000:Tray6',
								['tray7']				=	'ns0000:Tray7',
								['tray8']				=	'ns0000:Tray8',
								['tray9']				=	'ns0000:Tray9',
								['tray10']				=	'ns0000:Tray10',
								['tray11']				=	'ns0000:Tray11',
								['traya']				=	'ns0000:TrayA',
								['bypasstray']			=	'ns0000:BypassTray',
								['frontbypasstray']		=	'ns0000:FrontBypassTray',
								['largecapacitytray']	=	'ns0000:LCT',
								['interposer']			=	'ns0000:Inserter',
								['interposeruppertray']	=	'ns0000:InserterUpper',
								['interposerlowertray']	=	'ns0000:InserterLower',
								['largecapacityinterposer1']	=	'ns0000:LargeCapacityInserter1',
								['largecapacityinterposer2']	=	'ns0000:LargeCapacityInserter2',
								['paperfeedtray']		=	'ns0000:PaperFeedTray',
							}
						local tray_val
						tray_val = tray_table[tbl['backcover_inputtray']]
						if(nil == tray_val)then
							tray_val = 'ns0000:Tray1'
						end
						
						table.insert(result_table, {
							tag			= 	'psf:Feature',
							attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CoverBackInputBin'
							},
							children	=	
								{
									tag			=	'psf:Option',
									attribute	=
									{
										key		=	'name',
										value	=	tray_val
									},
								}
						})
				end
				
				return result_table
			
			end
	},
	-- 04 Slip Sheet
	slipsheet	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobSlipSheet'
		},
		children	=	function(tbl)
				local result_table ={}
				
				-- Slip Sheet
				local cover_val 
				local cover_table	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					}
				cover_val = cover_table[tbl['slipsheet']]
				
				if(nil == cover_val)then
					cover_val = 'ns0000:Off'
				end
				
				table.insert(result_table, {
					tag			=	'psf:Option',
					attribute	=
					{
						key		=	'name',
						value	=	cover_val
					},
				})
				
				if(nil ~= tbl['slipsheet_printmode'])then
						local mode_table	=
							{
								['leaveblank']			=	'ns0000:NotPrintOnSlipSheet',
								['printonslipsheet']	=	'ns0000:PrintOnSlipSheet',
							}
						local mode_val
						mode_val = mode_table[tbl['slipsheet_printmode']]
						if(nil == mode_val)then
							mode_val = 'ns0000:NotPrintOnSlipSheet'
						end
						
						table.insert(result_table, {
							tag			= 	'psf:Feature',
							attribute	=
							{
								key		=	'name',
								value	=	'ns0000:PrintOnSlipSheet'
							},
							children	=	
								{
									tag			=	'psf:Option',
									attribute	=
									{
										key		=	'name',
										value	=	mode_val
									},
								}
						})
				end
				if(nil ~= tbl['slipsheet_inputtray'])then
						local tray_table	=
							{
								['tray1']				=	'ns0000:Tray1',
								['tray1roll']			=	'ns0000:Tray1_Roll',
								['tray2']				=	'ns0000:Tray2',
								['tray2roll']			=	'ns0000:Tray2_Roll',
								['tray3']				=	'ns0000:Tray3',
								['tray3lct']			=	'ns0000:Tray3_LCT',
								['tray3roll']			=	'ns0000:Tray3_Roll',
								['tray4']				=	'ns0000:Tray4',
								['tray4roll']			=	'ns0000:Tray4_Roll',
								['tray5']				=	'ns0000:Tray5',
								['tray6']				=	'ns0000:Tray6',
								['tray7']				=	'ns0000:Tray7',
								['tray8']				=	'ns0000:Tray8',
								['tray9']				=	'ns0000:Tray9',
								['tray10']				=	'ns0000:Tray10',
								['tray11']				=	'ns0000:Tray11',
								['traya']				=	'ns0000:TrayA',
								['bypasstray']			=	'ns0000:BypassTray',
								['frontbypasstray']		=	'ns0000:FrontBypassTray',
								['largecapacitytray']	=	'ns0000:LCT',
								['interposer']			=	'ns0000:Inserter',
								['interposeruppertray']	=	'ns0000:InserterUpper',
								['interposerlowertray']	=	'ns0000:InserterLower',
								['largecapacityinterposer1']	=	'ns0000:LargeCapacityInserter1',
								['largecapacityinterposer2']	=	'ns0000:LargeCapacityInserter2',
								['paperfeedtray']		=	'ns0000:PaperFeedTray',
							}
						local tray_val
						tray_val = tray_table[tbl['slipsheet_inputtray']]
						if(nil == tray_val)then
							tray_val = 'ns0000:Tray1'
						end
						
						table.insert(result_table, {
							tag			= 	'psf:Feature',
							attribute	=
							{
								key		=	'name',
								value	=	'ns0000:SlipSheetInputBin'
							},
							children	=	
								{
									tag			=	'psf:Option',
									attribute	=
									{
										key		=	'name',
										value	=	tray_val
									},
								}
						})
				end
				
				return result_table
			
			end
	},
	-- 05 Chapter Pages
	chapterpages	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobChapterPrint'
		},
		children	=
		{
			tag 		=	'psf:Option',
			attribute	=
			{
				key 	=	'name',
				value	=
				{
					chapterpages	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					}
				}
			},
			children	=
			{
				tag 	=	function(tbl)
						if( 'on' == tbl['chapterpages'] and nil ~= tbl['chapterpages_setting']) then
							return 'psf:ScoredProperty'
						else
							return nil
						end
					end,
				attribute	=
				{
					key 	=	'name',
					value	=	'ns0000:ChapterSettings'
				},
				children	=
				{
					tag 		=	'psf:Value',
					attribute	=
					{
						key 	=	'xsi:type',
						value	=	'xsd:string'
					},
					text	=	function(tbl)
								
								local chaptersetting = tbl['chapterpages_setting']
								
								if chaptersetting then
									local printmode_convert_table	=
									{
										['leaveblank']		=	'LeaveBlank',
										['oneside']			=	'OneSide',
										['bothsides']		=	'BothSide',
										['leadchapterpage']	=	'LeadChapterPage',
										['multipages']		=	'MultiPages',
									}
									
									local tray_convert_table	=
									{
										['tray1']				=	'Tray1',
										['tray1roll']			=	'Tray1_Roll',
										['tray2']				=	'Tray2',
										['tray2roll']			=	'Tray2_Roll',
										['tray3']				=	'Tray3',
										['tray3lct']			=	'Tray3_LCT',
										['tray3roll']			=	'Tray3_Roll',
										['tray4']				=	'Tray4',
										['tray4roll']			=	'Tray4_Roll',
										['tray5']				=	'Tray5',
										['tray6']				=	'Tray6',
										['tray7']				=	'Tray7',
										['tray8']				=	'Tray8',
										['tray9']				=	'Tray9',
										['tray10']				=	'Tray10',
										['tray11']				=	'Tray11',
										['traya']				=	'TrayA',
										['bypasstray']			=	'BypassTray',
										['frontbypasstray']		=	'FrontBypassTray',
										['largecapacitytray']	=	'LCT',
										['interposer']			=	'Inserter',
										['interposeruppertray']	=	'InserterUpper',
										['interposerlowertray']	=	'InserterLower',
										['largecapacityinterposer1']	=	'LargeCapacityInserter1',
										['largecapacityinterposer2']	=	'LargeCapacityInserter2',
									}
									
									for i, v in pairs(printmode_convert_table) do
										chaptersetting = string.gsub(chaptersetting, ':'..i..':', ':'..v..':')
									end
									
									for i, v in pairs(tray_convert_table) do
										chaptersetting = string.gsub(chaptersetting, ':'..i..';', ':'..v..';')
									end
								end

								return chaptersetting
							end
				}
			}
		}
	},
	-- 06 Bypass Tray's Media Type Common for Functional Paper
	functionalpaper_bypasstray_mediatype	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobFunctionalPaperMediaType'
		},
		children	=	function(tbl)
				local result_table ={}
				local media_table	=
					{
						['plainandrecycled']		=	'ns0000:Standard_Recycled',
						['plain']					=	'ns0000:Plain',
						['plain2']					=	'ns0000:Plain2',
						['recycled']				=	'ns0000:Recycled',
						['inkjetplain']				=	'ns0000:InkjetPlain',
						['special']					=	'ns0000:Special',
						['special2']				=	'ns0000:Special2',
						['special3']				=	'ns0000:Special3',
						['special4']				=	'ns0000:Special4',
						['special5']				=	'ns0000:Special5',
						['special6']				=	'ns0000:Special6',
						['thick']					=	'ns0000:Thick',
						['middlethick']				=	'ns0000:MiddleThick',
						['thick2']					=	'ns0000:Thick2',
						['thick3']					=	'ns0000:Thick3',
						['thick4']					=	'ns0000:Thick4',
						['thin']					=	'ns0000:Thin',
						['transparency']			=	'ns0000:Transparency',
						['translucent']				=	'ns0000:Translucent',
						['color']					=	'ns0000:Color',
						['color1']					=	'ns0000:Color1',
						['color2']					=	'ns0000:Color2',
						['letterhead']				=	'ns0000:Letterhead',
						['preprinted']				=	'ns0000:Preprinted',
						['plainduplexbackside']		=	'ns0000:Plain_Duplex_Backside',
						['thickduplexbackside']		=	'ns0000:Thick_Duplex_Backside',
						['thick2duplexbackside']	=	'ns0000:Thick_Duplex_Backside2',
						['thick3duplexbackside']	=	'ns0000:Thick_Duplex_Backside3',
						['thick4duplexbackside']	=	'ns0000:Thick_Duplex_Backside4',
						['prepunched']				=	'ns0000:Prepunched',
						['labels']					=	'ns0000:Label',
						['bond']					=	'ns0000:Bond',
						['cardstock']				=	'ns0000:CardStock',
						['tabstock']				=	'ns0000:TabStockPreCut',
						['glossytabstock']			=	'ns0000:GlossyTabStock',
						['mattabstock']				=	'ns0000:MatTabStock',
						['moreglossytabstock']		=	'ns0000:MoreGlossyTabStock',
						['yellow']					=	'ns0000:Yellow',
						['green']					=	'ns0000:Green',
						['blue']					=	'ns0000:Blue',
						['purple']					=	'ns0000:Purple',
						['ivory']					=	'ns0000:Ivory',
						['orange']					=	'ns0000:Orange',
						['pink']					=	'ns0000:Pink',
						['red']						=	'ns0000:Red',
						['gray']					=	'ns0000:Gray',
						['glossy']					=	'ns0000:PhotographicGlossy',
						['semiglossy']				=	'ns0000:SemiGlossy',
						['glossycoated']			=	'ns0000:GlossyCoated',
						['matcoated']				=	'ns0000:MatCoated',
						['matfilm']					=	'ns0000:MatFilm',
						['thickmatcoated']			=	'ns0000:ThickMatCoated',
						['hgplain']					=	'ns0000:HGPlain',
						['envelope']				=	'ns0000:EnvelopePlain',
						['glossyenvelope']			=	'ns0000:GlossyEnvelope',
						['matenvelope']				=	'ns0000:MatEnvelope',
						['moreglossyenvelope']		=	'ns0000:MoreGlossyEnvelope',
						['postcard']				=	'ns0000:Jpost',
						['inkjetpostcard']			=	'ns0000:InkjetJpost',
						['coated']					=	'ns0000:Coated',
						['cadcoated']				=	'ns0000:CadCoated',
						['postcardduplexbackside']	=	'ns0000:Jpost_Duplex_Backside',
						['thickglossycoated']		=	'ns0000:ThickGlossyCoated',
						['waterproof']				=	'ns0000:WaterProof',
						['film']					=	'ns0000:Film',
						['thickglossy']				=	'ns0000:ThickGlossy',
						['black']					=	'ns0000:Black',
						['clearfile']				=	'ns0000:ClearFile',
						['magnet']					=	'ns0000:Magnet',
						['metallicpearl']			=	'ns0000:MetallicPearl',
						['synthetic']				=	'ns0000:Synthetic',
						['texture']					=	'ns0000:Texture',
						['ncr']						=	'ns0000:NCR',
						['auto']					=	'ns0000:AutoSelect',
						['none']					=	'ns0000:None',
						['+custom1']				=	'ns0000:Custom1',
						['+custom2']				=	'ns0000:Custom2',
						['+custom3']				=	'ns0000:Custom3',
						['+custom4']				=	'ns0000:Custom4',
						['+custom5']				=	'ns0000:Custom5',
						['+custom6']				=	'ns0000:Custom6',
						['+custom7']				=	'ns0000:Custom7',
						['+custom8']				=	'ns0000:Custom8',
						['+custom9']				=	'ns0000:Custom9',
						['+custom10']				=	'ns0000:Custom10',
						['+custom11']				=	'ns0000:Custom11',
						['+custom12']				=	'ns0000:Custom12',
						['+custom13']				=	'ns0000:Custom13',
						['+custom14']				=	'ns0000:Custom14',
						['+custom15']				=	'ns0000:Custom15',
						['+custom16']				=	'ns0000:Custom16',
						['+custom17']				=	'ns0000:Custom17',
						['+custom18']				=	'ns0000:Custom18',
						['+custom19']				=	'ns0000:Custom19',
						['+custom20']				=	'ns0000:Custom20',
						['+custom21']				=	'ns0000:Custom21',
						['+custom22']				=	'ns0000:Custom22',
						['+custom23']				=	'ns0000:Custom23',
						['+custom24']				=	'ns0000:Custom24',
						['+custom25']				=	'ns0000:Custom25',
						['+custom26']				=	'ns0000:Custom26',
						['+custom27']				=	'ns0000:Custom27',
						['+custom28']				=	'ns0000:Custom28',
						['+custom29']				=	'ns0000:Custom29',
						['+custom30']				=	'ns0000:Custom30',
						['+custom31']				=	'ns0000:Custom31',
						['+custom32']				=	'ns0000:Custom32',
						['+custom33']				=	'ns0000:Custom33',
						['+custom34']				=	'ns0000:Custom34',
						['+custom35']				=	'ns0000:Custom35',
						['+custom36']				=	'ns0000:Custom36',
						['+custom37']				=	'ns0000:Custom37',
						['+custom38']				=	'ns0000:Custom38',
						['+custom39']				=	'ns0000:Custom39',
						['+custom40']				=	'ns0000:Custom40',
						['+custom41']				=	'ns0000:Custom41',
						['+custom42']				=	'ns0000:Custom42',
						['+custom43']				=	'ns0000:Custom43',
						['+custom44']				=	'ns0000:Custom44',
						['+custom45']				=	'ns0000:Custom45',
						['+custom46']				=	'ns0000:Custom46',
						['+custom47']				=	'ns0000:Custom47',
						['+custom48']				=	'ns0000:Custom48',
						['+custom49']				=	'ns0000:Custom49',
						['+custom50']				=	'ns0000:Custom50',
						['+custom51']				=	'ns0000:Custom51',
						['+custom52']				=	'ns0000:Custom52',
						['+custom53']				=	'ns0000:Custom53',
						['+custom54']				=	'ns0000:Custom54',
						['+custom55']				=	'ns0000:Custom55',
						['+custom56']				=	'ns0000:Custom56',
						['+custom57']				=	'ns0000:Custom57',
						['+custom58']				=	'ns0000:Custom58',
						['+custom59']				=	'ns0000:Custom59',
						['+custom60']				=	'ns0000:Custom60',
						['+custom61']				=	'ns0000:Custom61',
						['+custom62']				=	'ns0000:Custom62',
						['+custom63']				=	'ns0000:Custom63',
						['+custom64']				=	'ns0000:Custom64',
						['+custom65']				=	'ns0000:Custom65',
						['+custom66']				=	'ns0000:Custom66',
						['+custom67']				=	'ns0000:Custom67',
						['+custom68']				=	'ns0000:Custom68',
						['+custom69']				=	'ns0000:Custom69',
						['+custom70']				=	'ns0000:Custom70',
						['+custom71']				=	'ns0000:Custom71',
						['+custom72']				=	'ns0000:Custom72',
						['+custom73']				=	'ns0000:Custom73',
						['+custom74']				=	'ns0000:Custom74',
						['+custom75']				=	'ns0000:Custom75',
						['+custom76']				=	'ns0000:Custom76',
						['+custom77']				=	'ns0000:Custom77',
						['+custom78']				=	'ns0000:Custom78',
						['+custom79']				=	'ns0000:Custom79',
						['+custom80']				=	'ns0000:Custom80',
						['+custom81']				=	'ns0000:Custom81',
						['+custom82']				=	'ns0000:Custom82',
						['+custom83']				=	'ns0000:Custom83',
						['+custom84']				=	'ns0000:Custom84',
						['+custom85']				=	'ns0000:Custom85',
						['+custom86']				=	'ns0000:Custom86',
						['+custom87']				=	'ns0000:Custom87',
						['+custom88']				=	'ns0000:Custom88',
						['+custom89']				=	'ns0000:Custom89',
						['+custom90']				=	'ns0000:Custom90',
						['+custom91']				=	'ns0000:Custom91',
						['+custom92']				=	'ns0000:Custom92',
						['+custom93']				=	'ns0000:Custom93',
						['+custom94']				=	'ns0000:Custom94',
						['+custom95']				=	'ns0000:Custom95',
						['+custom96']				=	'ns0000:Custom96',
						['+custom97']				=	'ns0000:Custom97',
						['+custom98']				=	'ns0000:Custom98',
						['+custom99']				=	'ns0000:Custom99',
						['+custom100']				=	'ns0000:Custom100',
						['+custom101']				=	'ns0000:Custom101',
						['+custom102']				=	'ns0000:Custom102',
						['+custom103']				=	'ns0000:Custom103',
						['+custom104']				=	'ns0000:Custom104',
						['+custom105']				=	'ns0000:Custom105',
						['+custom106']				=	'ns0000:Custom106',
						['+custom107']				=	'ns0000:Custom107',
						['+custom108']				=	'ns0000:Custom108',
						['+custom109']				=	'ns0000:Custom109',
						['+custom110']				=	'ns0000:Custom110',
						['+custom111']				=	'ns0000:Custom111',
						['+custom112']				=	'ns0000:Custom112',
						['+custom113']				=	'ns0000:Custom113',
						['+custom114']				=	'ns0000:Custom114',
						['+custom115']				=	'ns0000:Custom115',
						['+custom116']				=	'ns0000:Custom116',
						['+custom117']				=	'ns0000:Custom117',
						['+custom118']				=	'ns0000:Custom118',
						['+custom119']				=	'ns0000:Custom119',
						['+custom120']				=	'ns0000:Custom120',
						['+custom121']				=	'ns0000:Custom121',
						['+custom122']				=	'ns0000:Custom122',
						['+custom123']				=	'ns0000:Custom123',
						['+custom124']				=	'ns0000:Custom124',
						['+custom125']				=	'ns0000:Custom125',
						['+custom126']				=	'ns0000:Custom126',
						['+custom127']				=	'ns0000:Custom127',
						['+custom128']				=	'ns0000:Custom128',
						['+custom129']				=	'ns0000:Custom129',
						['+custom130']				=	'ns0000:Custom130',
						['+custom131']				=	'ns0000:Custom131',
						['+custom132']				=	'ns0000:Custom132',
						['+custom133']				=	'ns0000:Custom133',
						['+custom134']				=	'ns0000:Custom134',
						['+custom135']				=	'ns0000:Custom135',
						['+custom136']				=	'ns0000:Custom136',
						['+custom137']				=	'ns0000:Custom137',
						['+custom138']				=	'ns0000:Custom138',
						['+custom139']				=	'ns0000:Custom139',
						['+custom140']				=	'ns0000:Custom140',
						['+custom141']				=	'ns0000:Custom141',
						['+custom142']				=	'ns0000:Custom142',
						['+custom143']				=	'ns0000:Custom143',
						['+custom144']				=	'ns0000:Custom144',
						['+custom145']				=	'ns0000:Custom145',
						['+custom146']				=	'ns0000:Custom146',
						['+custom147']				=	'ns0000:Custom147',
						['+custom148']				=	'ns0000:Custom148',
						['+custom149']				=	'ns0000:Custom149',
						['+custom150']				=	'ns0000:Custom150',
						['+custom151']				=	'ns0000:Custom151',
						['+custom152']				=	'ns0000:Custom152',
						['+custom153']				=	'ns0000:Custom153',
						['+custom154']				=	'ns0000:Custom154',
						['+custom155']				=	'ns0000:Custom155',
						['+custom156']				=	'ns0000:Custom156',
						['+custom157']				=	'ns0000:Custom157',
						['+custom158']				=	'ns0000:Custom158',
						['+custom159']				=	'ns0000:Custom159',
						['+custom160']				=	'ns0000:Custom160',
						['+custom161']				=	'ns0000:Custom161',
						['+custom162']				=	'ns0000:Custom162',
						['+custom163']				=	'ns0000:Custom163',
						['+custom164']				=	'ns0000:Custom164',
						['+custom165']				=	'ns0000:Custom165',
						['+custom166']				=	'ns0000:Custom166',
						['+custom167']				=	'ns0000:Custom167',
						['+custom168']				=	'ns0000:Custom168',
						['+custom169']				=	'ns0000:Custom169',
						['+custom170']				=	'ns0000:Custom170',
						['+custom171']				=	'ns0000:Custom171',
						['+custom172']				=	'ns0000:Custom172',
						['+custom173']				=	'ns0000:Custom173',
						['+custom174']				=	'ns0000:Custom174',
						['+custom175']				=	'ns0000:Custom175',
						['+custom176']				=	'ns0000:Custom176',
						['+custom177']				=	'ns0000:Custom177',
						['+custom178']				=	'ns0000:Custom178',
						['+custom179']				=	'ns0000:Custom179',
						['+custom180']				=	'ns0000:Custom180',
						['+custom181']				=	'ns0000:Custom181',
						['+custom182']				=	'ns0000:Custom182',
						['+custom183']				=	'ns0000:Custom183',
						['+custom184']				=	'ns0000:Custom184',
						['+custom185']				=	'ns0000:Custom185',
						['+custom186']				=	'ns0000:Custom186',
						['+custom187']				=	'ns0000:Custom187',
						['+custom188']				=	'ns0000:Custom188',
						['+custom189']				=	'ns0000:Custom189',
						['+custom190']				=	'ns0000:Custom190',
						['+custom191']				=	'ns0000:Custom191',
						['+custom192']				=	'ns0000:Custom192',
						['+custom193']				=	'ns0000:Custom193',
						['+custom194']				=	'ns0000:Custom194',
						['+custom195']				=	'ns0000:Custom195',
						['+custom196']				=	'ns0000:Custom196',
						['+custom197']				=	'ns0000:Custom197',
						['+custom198']				=	'ns0000:Custom198',
						['+custom199']				=	'ns0000:Custom199',
						['+custom200']				=	'ns0000:Custom200',
					}
				
				local media_val
				media_val = media_table[tbl['functionalpaper_bypasstray_mediatype']]
				if(nil == media_val)then
					media_val = 'ns0000:Plain'
				end
				
				table.insert(result_table, {
						tag			=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	media_val
						},
				})
				
				return result_table
			
			end
	},
	-- 07-01 Force Paper Direction in Bypass Tray
	bypasstray_forcepaperdirection	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobBypassTrayForcePaperDirection'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=	function(tbl)
					local t =
					{
						['off']	=	{
							['lef']	=	'ns0000:Off',
							['sef']	=	'ns0000:Off'
						},
						['on']	=	{
							['lef']	=	'ns0000:FeedFromLongEdge',
							['sef']	=	'ns0000:FeedFromShortEdge'
						}
					}
					local a	= tbl['bypasstray_forcepaperdirection'] and tbl['bypasstray_forcepaperdirection'] or 'off'
					local b	= tbl['bypasstray_forcepaperdirection_feed'] and tbl['bypasstray_forcepaperdirection_feed'] or 'lef'

					return t[a] and ( t[a][b] and t[a][b] or 'ns0000:FeedFromLongEdge' ) or 'ns0000:Off'
				end
			}
		}
	},
	-- 11 Use Preprinted/Prepunched Paper
	usepreprintedprepunchedpaper	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobUsePrePrintedPrePunchedPaper'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					usepreprintedprepunchedpaper	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 12 Adjust paper feed timing
	quickpaperfeed	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobQuickPaperFeed'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					quickpaperfeed	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},

	bannerpageprint	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobBannerPage'
		},
		children	=	function(tbl)
				local result_table ={}
				
				local bannerpage_val 
				local bannerpage_table	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					}
				bannerpage_val = bannerpage_table[tbl['bannerpageprint']]
				
				if(nil == bannerpage_val)then
					bannerpage_val = 'ns0000:Off'
				end
				
				table.insert(result_table, {
					tag			=	'psf:Option',
					attribute	=
					{
						key		=	'name',
						value	=	bannerpage_val
					},
				})
				
				if(nil ~= tbl['bannerpageprint_inputtray'])then
						local tray_table	=
							{
								['autotrayselect']		=	'ns0000:AUTO',
								['tray1']				=	'ns0000:Tray1',
								['tray1roll']			=	'ns0000:Tray1_Roll',
								['tray2']				=	'ns0000:Tray2',
								['tray2roll']			=	'ns0000:Tray2_Roll',
								['tray3']				=	'ns0000:Tray3',
								['tray3lct']			=	'ns0000:Tray3_LCT',
								['tray3roll']			=	'ns0000:Tray3_Roll',
								['tray4']				=	'ns0000:Tray4',
								['tray4roll']			=	'ns0000:Tray4_Roll',
								['tray5']				=	'ns0000:Tray5',
								['tray6']				=	'ns0000:Tray6',
								['tray7']				=	'ns0000:Tray7',
								['tray8']				=	'ns0000:Tray8',
								['tray9']				=	'ns0000:Tray9',
								['tray10']				=	'ns0000:Tray10',
								['tray11']				=	'ns0000:Tray11',
								['traya']				=	'ns0000:TrayA',
								['bypasstray']			=	'ns0000:BypassTray',
								['frontbypasstray']		=	'ns0000:FrontBypassTray',
								['onesheetbypass']		=	'ns0000:OneSheetBypassTray',
								['largecapacitytray']	=	'ns0000:LCT',
								['paperfeedtray']		=	'ns0000:PaperFeedTray',
							}
						local tray_val
						tray_val = tray_table[tbl['bannerpageprint_inputtray']]
						if(nil == tray_val)then
							tray_val = 'ns0000:AUTO'
						end
						
						table.insert(result_table, {
							tag			= 	'psf:Feature',
							attribute	=
							{
								key		=	'name',
								value	=	'ns0000:BannerPageInputBin'
							},
							children	=	
								{
									tag			=	'psf:Option',
									attribute	=
									{
										key		=	'name',
										value	=	tray_val
									},
								}
						})
				end
				
				if(nil ~= tbl['bannerpageprint_mediatype'])then
						local mediatype_table	=
							{
								['plainandrecycled']		=	'ns0000:Standard_Recycled',
								['plain']					=	'ns0000:Plain',
								['plain2']					=	'ns0000:Plain2',
								['recycled']				=	'ns0000:Recycled',
								['inkjetplain']				=	'ns0000:InkjetPlain',
								['special']					=	'ns0000:Special',
								['special2']				=	'ns0000:Special2',
								['special3']				=	'ns0000:Special3',
								['special4']				=	'ns0000:Special4',
								['special5']				=	'ns0000:Special5',
								['special6']				=	'ns0000:Special6',
								['thick']					=	'ns0000:Thick',
								['middlethick']				=	'ns0000:MiddleThick',
								['thick2']					=	'ns0000:Thick2',
								['thick3']					=	'ns0000:Thick3',
								['thick4']					=	'ns0000:Thick4',
								['thin']					=	'ns0000:Thin',
								['transparency']			=	'ns0000:Transparency',
								['translucent']				=	'ns0000:Translucent',
								['color']					=	'ns0000:Color',
								['color1']					=	'ns0000:Color1',
								['color2']					=	'ns0000:Color2',
								['letterhead']				=	'ns0000:Letterhead',
								['preprinted']				=	'ns0000:Preprinted',
								['plainduplexbackside']		=	'ns0000:Plain_Duplex_Backside',
								['thickduplexbackside']		=	'ns0000:Thick_Duplex_Backside',
								['thick2duplexbackside']	=	'ns0000:Thick_Duplex_Backside2',
								['thick3duplexbackside']	=	'ns0000:Thick_Duplex_Backside3',
								['thick4duplexbackside']	=	'ns0000:Thick_Duplex_Backside4',
								['prepunched']				=	'ns0000:Prepunched',
								['labels']					=	'ns0000:Label',
								['bond']					=	'ns0000:Bond',
								['cardstock']				=	'ns0000:CardStock',
								['tabstock']				=	'ns0000:TabStockPreCut',
								['glossytabstock']			=	'ns0000:GlossyTabStock',
								['mattabstock']				=	'ns0000:MatTabStock',
								['moreglossytabstock']		=	'ns0000:MoreGlossyTabStock',
								['yellow']					=	'ns0000:Yellow',
								['green']					=	'ns0000:Green',
								['blue']					=	'ns0000:Blue',
								['purple']					=	'ns0000:Purple',
								['ivory']					=	'ns0000:Ivory',
								['orange']					=	'ns0000:Orange',
								['pink']					=	'ns0000:Pink',
								['red']						=	'ns0000:Red',
								['gray']					=	'ns0000:Gray',
								['glossy']					=	'ns0000:PhotographicGlossy',
								['semiglossy']				=	'ns0000:SemiGlossy',
								['glossycoated']			=	'ns0000:GlossyCoated',
								['matcoated']				=	'ns0000:MatCoated',
								['matfilm']					=	'ns0000:MatFilm',
								['thickmatcoated']			=	'ns0000:ThickMatCoated',
								['hgplain']					=	'ns0000:HGPlain',
								['envelope']				=	'ns0000:EnvelopePlain',
								['glossyenvelope']			=	'ns0000:GlossyEnvelope',
								['matenvelope']				=	'ns0000:MatEnvelope',
								['moreglossyenvelope']		=	'ns0000:MoreGlossyEnvelope',
								['postcard']				=	'ns0000:Jpost',
								['inkjetpostcard']			=	'ns0000:InkjetJpost',
								['coated']					=	'ns0000:Coated',
								['cadcoated']				=	'ns0000:CadCoated',
								['postcardduplexbackside']	=	'ns0000:Jpost_Duplex_Backside',
								['thickglossycoated']		=	'ns0000:ThickGlossyCoated',
								['waterproof']				=	'ns0000:WaterProof',
								['film']					=	'ns0000:Film',
								['thickglossy']				=	'ns0000:ThickGlossy',
								['black']					=	'ns0000:Black',
								['clearfile']				=	'ns0000:ClearFile',
								['magnet']					=	'ns0000:Magnet',
								['metallicpearl']			=	'ns0000:MetallicPearl',
								['synthetic']				=	'ns0000:Synthetic',
								['texture']					=	'ns0000:Texture',
								['ncr']						=	'ns0000:NCR',
								['auto']					=	'ns0000:AutoSelect',
								['none']					=	'ns0000:None',
								['+custom1']				=	'ns0000:Custom1',
								['+custom2']				=	'ns0000:Custom2',
								['+custom3']				=	'ns0000:Custom3',
								['+custom4']				=	'ns0000:Custom4',
								['+custom5']				=	'ns0000:Custom5',
								['+custom6']				=	'ns0000:Custom6',
								['+custom7']				=	'ns0000:Custom7',
								['+custom8']				=	'ns0000:Custom8',
								['+custom9']				=	'ns0000:Custom9',
								['+custom10']				=	'ns0000:Custom10',
								['+custom11']				=	'ns0000:Custom11',
								['+custom12']				=	'ns0000:Custom12',
								['+custom13']				=	'ns0000:Custom13',
								['+custom14']				=	'ns0000:Custom14',
								['+custom15']				=	'ns0000:Custom15',
								['+custom16']				=	'ns0000:Custom16',
								['+custom17']				=	'ns0000:Custom17',
								['+custom18']				=	'ns0000:Custom18',
								['+custom19']				=	'ns0000:Custom19',
								['+custom20']				=	'ns0000:Custom20',
								['+custom21']				=	'ns0000:Custom21',
								['+custom22']				=	'ns0000:Custom22',
								['+custom23']				=	'ns0000:Custom23',
								['+custom24']				=	'ns0000:Custom24',
								['+custom25']				=	'ns0000:Custom25',
								['+custom26']				=	'ns0000:Custom26',
								['+custom27']				=	'ns0000:Custom27',
								['+custom28']				=	'ns0000:Custom28',
								['+custom29']				=	'ns0000:Custom29',
								['+custom30']				=	'ns0000:Custom30',
								['+custom31']				=	'ns0000:Custom31',
								['+custom32']				=	'ns0000:Custom32',
								['+custom33']				=	'ns0000:Custom33',
								['+custom34']				=	'ns0000:Custom34',
								['+custom35']				=	'ns0000:Custom35',
								['+custom36']				=	'ns0000:Custom36',
								['+custom37']				=	'ns0000:Custom37',
								['+custom38']				=	'ns0000:Custom38',
								['+custom39']				=	'ns0000:Custom39',
								['+custom40']				=	'ns0000:Custom40',
								['+custom41']				=	'ns0000:Custom41',
								['+custom42']				=	'ns0000:Custom42',
								['+custom43']				=	'ns0000:Custom43',
								['+custom44']				=	'ns0000:Custom44',
								['+custom45']				=	'ns0000:Custom45',
								['+custom46']				=	'ns0000:Custom46',
								['+custom47']				=	'ns0000:Custom47',
								['+custom48']				=	'ns0000:Custom48',
								['+custom49']				=	'ns0000:Custom49',
								['+custom50']				=	'ns0000:Custom50',
								['+custom51']				=	'ns0000:Custom51',
								['+custom52']				=	'ns0000:Custom52',
								['+custom53']				=	'ns0000:Custom53',
								['+custom54']				=	'ns0000:Custom54',
								['+custom55']				=	'ns0000:Custom55',
								['+custom56']				=	'ns0000:Custom56',
								['+custom57']				=	'ns0000:Custom57',
								['+custom58']				=	'ns0000:Custom58',
								['+custom59']				=	'ns0000:Custom59',
								['+custom60']				=	'ns0000:Custom60',
								['+custom61']				=	'ns0000:Custom61',
								['+custom62']				=	'ns0000:Custom62',
								['+custom63']				=	'ns0000:Custom63',
								['+custom64']				=	'ns0000:Custom64',
								['+custom65']				=	'ns0000:Custom65',
								['+custom66']				=	'ns0000:Custom66',
								['+custom67']				=	'ns0000:Custom67',
								['+custom68']				=	'ns0000:Custom68',
								['+custom69']				=	'ns0000:Custom69',
								['+custom70']				=	'ns0000:Custom70',
								['+custom71']				=	'ns0000:Custom71',
								['+custom72']				=	'ns0000:Custom72',
								['+custom73']				=	'ns0000:Custom73',
								['+custom74']				=	'ns0000:Custom74',
								['+custom75']				=	'ns0000:Custom75',
								['+custom76']				=	'ns0000:Custom76',
								['+custom77']				=	'ns0000:Custom77',
								['+custom78']				=	'ns0000:Custom78',
								['+custom79']				=	'ns0000:Custom79',
								['+custom80']				=	'ns0000:Custom80',
								['+custom81']				=	'ns0000:Custom81',
								['+custom82']				=	'ns0000:Custom82',
								['+custom83']				=	'ns0000:Custom83',
								['+custom84']				=	'ns0000:Custom84',
								['+custom85']				=	'ns0000:Custom85',
								['+custom86']				=	'ns0000:Custom86',
								['+custom87']				=	'ns0000:Custom87',
								['+custom88']				=	'ns0000:Custom88',
								['+custom89']				=	'ns0000:Custom89',
								['+custom90']				=	'ns0000:Custom90',
								['+custom91']				=	'ns0000:Custom91',
								['+custom92']				=	'ns0000:Custom92',
								['+custom93']				=	'ns0000:Custom93',
								['+custom94']				=	'ns0000:Custom94',
								['+custom95']				=	'ns0000:Custom95',
								['+custom96']				=	'ns0000:Custom96',
								['+custom97']				=	'ns0000:Custom97',
								['+custom98']				=	'ns0000:Custom98',
								['+custom99']				=	'ns0000:Custom99',
								['+custom100']				=	'ns0000:Custom100',
								['+custom101']				=	'ns0000:Custom101',
								['+custom102']				=	'ns0000:Custom102',
								['+custom103']				=	'ns0000:Custom103',
								['+custom104']				=	'ns0000:Custom104',
								['+custom105']				=	'ns0000:Custom105',
								['+custom106']				=	'ns0000:Custom106',
								['+custom107']				=	'ns0000:Custom107',
								['+custom108']				=	'ns0000:Custom108',
								['+custom109']				=	'ns0000:Custom109',
								['+custom110']				=	'ns0000:Custom110',
								['+custom111']				=	'ns0000:Custom111',
								['+custom112']				=	'ns0000:Custom112',
								['+custom113']				=	'ns0000:Custom113',
								['+custom114']				=	'ns0000:Custom114',
								['+custom115']				=	'ns0000:Custom115',
								['+custom116']				=	'ns0000:Custom116',
								['+custom117']				=	'ns0000:Custom117',
								['+custom118']				=	'ns0000:Custom118',
								['+custom119']				=	'ns0000:Custom119',
								['+custom120']				=	'ns0000:Custom120',
								['+custom121']				=	'ns0000:Custom121',
								['+custom122']				=	'ns0000:Custom122',
								['+custom123']				=	'ns0000:Custom123',
								['+custom124']				=	'ns0000:Custom124',
								['+custom125']				=	'ns0000:Custom125',
								['+custom126']				=	'ns0000:Custom126',
								['+custom127']				=	'ns0000:Custom127',
								['+custom128']				=	'ns0000:Custom128',
								['+custom129']				=	'ns0000:Custom129',
								['+custom130']				=	'ns0000:Custom130',
								['+custom131']				=	'ns0000:Custom131',
								['+custom132']				=	'ns0000:Custom132',
								['+custom133']				=	'ns0000:Custom133',
								['+custom134']				=	'ns0000:Custom134',
								['+custom135']				=	'ns0000:Custom135',
								['+custom136']				=	'ns0000:Custom136',
								['+custom137']				=	'ns0000:Custom137',
								['+custom138']				=	'ns0000:Custom138',
								['+custom139']				=	'ns0000:Custom139',
								['+custom140']				=	'ns0000:Custom140',
								['+custom141']				=	'ns0000:Custom141',
								['+custom142']				=	'ns0000:Custom142',
								['+custom143']				=	'ns0000:Custom143',
								['+custom144']				=	'ns0000:Custom144',
								['+custom145']				=	'ns0000:Custom145',
								['+custom146']				=	'ns0000:Custom146',
								['+custom147']				=	'ns0000:Custom147',
								['+custom148']				=	'ns0000:Custom148',
								['+custom149']				=	'ns0000:Custom149',
								['+custom150']				=	'ns0000:Custom150',
								['+custom151']				=	'ns0000:Custom151',
								['+custom152']				=	'ns0000:Custom152',
								['+custom153']				=	'ns0000:Custom153',
								['+custom154']				=	'ns0000:Custom154',
								['+custom155']				=	'ns0000:Custom155',
								['+custom156']				=	'ns0000:Custom156',
								['+custom157']				=	'ns0000:Custom157',
								['+custom158']				=	'ns0000:Custom158',
								['+custom159']				=	'ns0000:Custom159',
								['+custom160']				=	'ns0000:Custom160',
								['+custom161']				=	'ns0000:Custom161',
								['+custom162']				=	'ns0000:Custom162',
								['+custom163']				=	'ns0000:Custom163',
								['+custom164']				=	'ns0000:Custom164',
								['+custom165']				=	'ns0000:Custom165',
								['+custom166']				=	'ns0000:Custom166',
								['+custom167']				=	'ns0000:Custom167',
								['+custom168']				=	'ns0000:Custom168',
								['+custom169']				=	'ns0000:Custom169',
								['+custom170']				=	'ns0000:Custom170',
								['+custom171']				=	'ns0000:Custom171',
								['+custom172']				=	'ns0000:Custom172',
								['+custom173']				=	'ns0000:Custom173',
								['+custom174']				=	'ns0000:Custom174',
								['+custom175']				=	'ns0000:Custom175',
								['+custom176']				=	'ns0000:Custom176',
								['+custom177']				=	'ns0000:Custom177',
								['+custom178']				=	'ns0000:Custom178',
								['+custom179']				=	'ns0000:Custom179',
								['+custom180']				=	'ns0000:Custom180',
								['+custom181']				=	'ns0000:Custom181',
								['+custom182']				=	'ns0000:Custom182',
								['+custom183']				=	'ns0000:Custom183',
								['+custom184']				=	'ns0000:Custom184',
								['+custom185']				=	'ns0000:Custom185',
								['+custom186']				=	'ns0000:Custom186',
								['+custom187']				=	'ns0000:Custom187',
								['+custom188']				=	'ns0000:Custom188',
								['+custom189']				=	'ns0000:Custom189',
								['+custom190']				=	'ns0000:Custom190',
								['+custom191']				=	'ns0000:Custom191',
								['+custom192']				=	'ns0000:Custom192',
								['+custom193']				=	'ns0000:Custom193',
								['+custom194']				=	'ns0000:Custom194',
								['+custom195']				=	'ns0000:Custom195',
								['+custom196']				=	'ns0000:Custom196',
								['+custom197']				=	'ns0000:Custom197',
								['+custom198']				=	'ns0000:Custom198',
								['+custom199']				=	'ns0000:Custom199',
								['+custom200']				=	'ns0000:Custom200',
							}
						local mediatype_val
						mediatype_val = mediatype_table[tbl['bannerpageprint_mediatype']]
						if(nil == mediatype_val)then
							mediatype_val = 'ns0000:Plain'
						end
						
						table.insert(result_table, {
							tag			= 	'psf:Feature',
							attribute	=
							{
								key		=	'name',
								value	=	'ns0000:BannerPageMediaType'
							},
							children	=	
								{
									tag			=	'psf:Option',
									attribute	=
									{
										key		=	'name',
										value	=	mediatype_val
									},
								}
						})
				end
				return result_table
			
			end
	},
	-- 14 Letterhead Mode
	letterheadmode	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobLetterheadMode'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					letterheadmode	=
					{
						['printerdefault']	=	'ns0000:PrinterDefault',
						['off']				=	'ns0000:Off',
						['auto']			=	'ns0000:Auto',
						['always']			=	'ns0000:Always'
					},
					default	=	{ 'item', 'ns0000:PrinterDefault' }
				}
			}
		}
	},
	-- 15 Duplex Mode for one sided print
	duplexmode	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobDuplexModeOneSidedPrint'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					duplexmode	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},

-- [04 Printing Area]
	-- 01 Document Size
	documentsize	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:PageMediaSize'
		},		
		children	=	function(tbl,option)
				
				local element_table	=
					{
						['12x18']				=	'ns0000:_12X18',
						['11x17']				=	'psk:NorthAmerica11x17',
						['legal']				=	'psk:NorthAmericaLegal',
						['letter']				=	'psk:NorthAmericaLetter',
						['executive']			=	'psk:NorthAmericaExecutive',
						['5.5x8.5']				=	'psk:NorthAmericaStatement',
						['a0']					=	'psk:ISOA0',
						['a1']					=	'psk:ISOA1',
						['a2']					=	'psk:ISOA2',
						['a3']					=	'psk:ISOA3',
						['a4']					=	'psk:ISOA4',
						['a5']					=	'psk:ISOA5',
						['a6']					=	'psk:ISOA6',
						['b1']					=	'psk:JISB1',
						['b2']					=	'psk:JISB2',
						['b3']					=	'psk:JISB3',
						['b4jis']				=	'psk:JISB4',
						['b5jis']				=	'psk:JISB5',
						['b6']					=	'psk:JISB6',
						['b7']					=	'psk:JISB7',
						['8x13']				=	'ns0000:_8X13',
						['8.25x13']				=	'ns0000:_8_25X13',
						['8.5x13']				=	'ns0000:FOLIO',
						['8.5x13.4']			=	'ns0000:_8_5X13_4',
						['com10env']			=	'psk:NorthAmericaNumber10Envelope',
						['monarchenv']			=	'psk:NorthAmericaMonarchEnvelope',
						['dlenv']				=	'psk:ISODLEnvelope',
						['c6env']				=	'psk:ISOC6Envelope',
						['c5env']				=	'psk:ISOC5Envelope',
						['chou3jenv']			=	'psk:JapanChou3Envelope',
						['chou4jenv']			=	'psk:JapanChou4Envelope',
						['you4jenv']			=	'psk:JapanYou4Envelope',
						['youchou3jenv']		=	'psk:JapanYou4EnvelopeRotated',
						['kaku1jenv']			=	'ns0000:JapanKaku1Envelope',
						['kaku2jenv']			=	'psk:JapanKaku2Envelope',
						['bd']					=	'ns0000:BD',
						['lineslider1']			=	'ns0000:LineSlider1',
						['lineslider2']			=	'ns0000:LineSlider2',
						['glt']					=	'ns0000:_8X10_5',
						['10x14']				=	'psk:NorthAmerica10x14',
						['10x15']				=	'ns0000:_10X15',
						['11x15']				=	'ns0000:_11X15',
						['15x20']				=	'ns0000:_15X20',
						['8k']					=	'ns0000:_8kai',
						['16k']					=	'ns0000:_16kai',
						['postcard']			=	'psk:JapanHagakiPostcard',
						['doublepostcard']		=	'psk:JapanDoubleHagakiPostcardRotated',
						['doublepostcardrotated']	=	'psk:JapanDoubleHagakiPostcard',
						['governmentlg']		=	'ns0000:_8_25X14',
						['engquatro']			=	'psk:NorthAmerica8x10',
						['sra3']				=	'ns0000:_320X450',
						['sra4']				=	'ns0000:_225X320',
						['11x14']				=	'ns0000:_11X14',
						['13x19.2']				=	'ns0000:_13X19_2',
						['13x19']				=	'ns0000:_13X19',
						['12.6x19.2']			=	'ns0000:_12_6X19_2',
						['12.6x18.5']			=	'ns0000:_12_6X18_5',
						['13x18']				=	'ns0000:_13X18',
						['226x310mm']			=	'ns0000:_226X310',
						['310x432mm']			=	'ns0000:_310X432',
						['8.5x12']				=	'psk:NorthAmericaGermanStandardFanfold',
						['17x22']				=	'ns0000:Ansic',
						['9x12']				=	'ns0000:_9X12',
						['18x24']				=	'ns0000:_18X24',
						['21x30']				=	'ns0000:_21X30',
						['22x34']				=	'ns0000:_22X34',
						['24x36']				=	'ns0000:_24X36',
						['30x42']				=	'ns0000:_30X42',
						['34x44']				=	'ns0000:_34X44',
						['36x48']				=	'ns0000:_36X48',
						['postcardstandard']	=	'ns0000:PostcardStandard',
						['kiku4']				=	'ns0000:Kiku4',
						['329x483mm']			=	'ns0000:_329X483',
						['photol']				=	'ns0000:PhotoL',
						['8.5x13.5']			=	'ns0000:_8_5X13_5',
						['kaku3jenv']			=	'psk:JapanKaku3Envelope',
						['synchrocut_a0width']	=	'ns0000:CustomSizeWidthA0',
						['synchrocut_a1width']	=	'ns0000:CustomSizeWidthA1',
						['synchrocut_a2width']	=	'ns0000:CustomSizeWidthA2',
						['synchrocut_a3width']	=	'ns0000:CustomSizeWidthA3',
						['synchrocut_a4width']	=	'ns0000:CustomSizeWidthA4',
						['synchrocut_customwidth']	=	'ns0000:CustomSizeSynchroCut',
						['custompapersize']		=	'psk:CustomMediaSize',
						['custompapersize1']	=	'ns0000:CustomSize1',
						['custompapersize2']	=	'ns0000:CustomSize2',
						['custompapersize3']	=	'ns0000:CustomSize3',
						['custompapersize4']	=	'ns0000:CustomSize4',
						['custompapersize5']	=	'ns0000:CustomSize5',
						['custompapersize6']	=	'ns0000:CustomSize6',
						['custompapersize7']	=	'ns0000:CustomSize7',
						['custompapersize8']	=	'ns0000:CustomSize8',
						['custompapersize9']	=	'ns0000:CustomSize9',
						['custompapersize10']	=	'ns0000:CustomSize10',
						['custompapersize11']	=	'ns0000:CustomSize11',
						['custompapersize12']	=	'ns0000:CustomSize12',
						['custompapersize13']	=	'ns0000:CustomSize13',
						['custompapersize14']	=	'ns0000:CustomSize14',
						['custompapersize15']	=	'ns0000:CustomSize15',
						['custompapersize16']	=	'ns0000:CustomSize16',
						['custompapersize17']	=	'ns0000:CustomSize17',
						['custompapersize18']	=	'ns0000:CustomSize18',
						['custompapersize19']	=	'ns0000:CustomSize19',
						['custompapersize20']	=	'ns0000:CustomSize20',
						['custompapersize21']	=	'ns0000:CustomSize21',
						['custompapersize22']	=	'ns0000:CustomSize22',
						['custompapersize23']	=	'ns0000:CustomSize23',
						['custompapersize24']	=	'ns0000:CustomSize24',
						['custompapersize25']	=	'ns0000:CustomSize25',
						['custompapersize26']	=	'ns0000:CustomSize26',
						['custompapersize27']	=	'ns0000:CustomSize27',
						['custompapersize28']	=	'ns0000:CustomSize28',
						['custompapersize29']	=	'ns0000:CustomSize29',
						['custompapersize30']	=	'ns0000:CustomSize30',
						['custompapersize31']	=	'ns0000:CustomSize31',
						['custompapersize32']	=	'ns0000:CustomSize32',
						['custompapersize33']	=	'ns0000:CustomSize33',
						['custompapersize34']	=	'ns0000:CustomSize34',
						['custompapersize35']	=	'ns0000:CustomSize35',
						['custompapersize36']	=	'ns0000:CustomSize36',
						['custompapersize37']	=	'ns0000:CustomSize37',
						['custompapersize38']	=	'ns0000:CustomSize38',
						['custompapersize39']	=	'ns0000:CustomSize39',
						['custompapersize40']	=	'ns0000:CustomSize40',
						['custompapersize41']	=	'ns0000:CustomSize41',
						['custompapersize42']	=	'ns0000:CustomSize42',
						['custompapersize43']	=	'ns0000:CustomSize43',
						['custompapersize44']	=	'ns0000:CustomSize44',
						['custompapersize45']	=	'ns0000:CustomSize45',
						['custompapersize46']	=	'ns0000:CustomSize46',
						['custompapersize47']	=	'ns0000:CustomSize47',
						['custompapersize48']	=	'ns0000:CustomSize48',
						['custompapersize49']	=	'ns0000:CustomSize49',
						['custompapersize50']	=	'ns0000:CustomSize50',
						['custompapersize51']	=	'ns0000:CustomSize51',
						['custompapersize52']	=	'ns0000:CustomSize52',
						['custompapersize53']	=	'ns0000:CustomSize53',
						['custompapersize54']	=	'ns0000:CustomSize54',
						['custompapersize55']	=	'ns0000:CustomSize55',
						['custompapersize56']	=	'ns0000:CustomSize56',
						['custompapersize57']	=	'ns0000:CustomSize57',
						['custompapersize58']	=	'ns0000:CustomSize58',
						['custompapersize59']	=	'ns0000:CustomSize59',
						['custompapersize60']	=	'ns0000:CustomSize60',
						['custompapersize61']	=	'ns0000:CustomSize61',
						['custompapersize62']	=	'ns0000:CustomSize62',
						['custompapersize63']	=	'ns0000:CustomSize63',
						['custompapersize64']	=	'ns0000:CustomSize64',
						['custompapersize65']	=	'ns0000:CustomSize65',
						['custompapersize66']	=	'ns0000:CustomSize66',
						['custompapersize67']	=	'ns0000:CustomSize67',
						['custompapersize68']	=	'ns0000:CustomSize68',
						['custompapersize69']	=	'ns0000:CustomSize69',
						['custompapersize70']	=	'ns0000:CustomSize70',
						['custompapersize71']	=	'ns0000:CustomSize71',
						['custompapersize72']	=	'ns0000:CustomSize72',
						['custompapersize73']	=	'ns0000:CustomSize73',
						['custompapersize74']	=	'ns0000:CustomSize74',
						['custompapersize75']	=	'ns0000:CustomSize75',
						['custompapersize76']	=	'ns0000:CustomSize76',
						['custompapersize77']	=	'ns0000:CustomSize77',
						['custompapersize78']	=	'ns0000:CustomSize78',
						['custompapersize79']	=	'ns0000:CustomSize79',
						['custompapersize80']	=	'ns0000:CustomSize80',
						['custompapersize81']	=	'ns0000:CustomSize81',
						['custompapersize82']	=	'ns0000:CustomSize82',
						['custompapersize83']	=	'ns0000:CustomSize83',
						['custompapersize84']	=	'ns0000:CustomSize84',
						['custompapersize85']	=	'ns0000:CustomSize85',
						['custompapersize86']	=	'ns0000:CustomSize86',
						['custompapersize87']	=	'ns0000:CustomSize87',
						['custompapersize88']	=	'ns0000:CustomSize88',
						['custompapersize89']	=	'ns0000:CustomSize89',
						['custompapersize90']	=	'ns0000:CustomSize90',
						['custompapersize91']	=	'ns0000:CustomSize91',
						['custompapersize92']	=	'ns0000:CustomSize92',
						['custompapersize93']	=	'ns0000:CustomSize93',
						['custompapersize94']	=	'ns0000:CustomSize94',
						['custompapersize95']	=	'ns0000:CustomSize95',
						['custompapersize96']	=	'ns0000:CustomSize96',
						['custompapersize97']	=	'ns0000:CustomSize97',
						['custompapersize98']	=	'ns0000:CustomSize98',
						['custompapersize99']	=	'ns0000:CustomSize99',
						['custompapersize100']	=	'ns0000:CustomSize100'
					}
				local paper_width
				local paper_height
				local cdb_val
				local document_val
				
				cdb_val = tbl['documentsize']
				document_val = element_table[cdb_val]
				
				if(nil == document_val)then
					cdb_val = 'a4'
					document_val = 'psk:ISOA4'
				end
				
				local current_paper = option['paper_info'][cdb_val]
				if(nil ~= current_paper					and
					nil ~= current_paper['mm']			and
					nil ~= current_paper['mm']['width']	and
					nil ~= current_paper['mm']['height']
					)then
					paper_width = tostring(current_paper['mm']['width'] * 100)
					paper_height = tostring(current_paper['mm']['height'] * 100)
				else
					paper_width = '270000'
					paper_height = '298000'
				end
				
				local result_table = {
						tag			=	'psf:Option',
						attribute	=
						{
							key	=	'name',
							value	= document_val
						},
						children	=
							{
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'psk:MediaSizeWidth'
										},
									children = {
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text = paper_width
										}
								},
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'psk:MediaSizeHeight'
										},
									children = {
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text = paper_height
										}
								}
							}
					}
			return result_table
			end
	},
	-- 01-02 Disable Custom Paper Size
	disablecustompapersize	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	=	'ns0000:JobAroundDefiniteSize'
		},
		children	=
		{
			tag 		=	'psf:Option',
			attribute	=
			{
				key 	=	'name',
				value 	=
				{
					disablecustompapersize	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					},
					default = {'item','ns0000:Off'}
				}
			},
		}
	},
	-- 02 Print Size
	printsize	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PagePrintPaperSize'
		},		
		children	=	function(tbl,option)
				
				local element_table	=
					{
						['sameasoriginalsize']	=	'ns0000:SameAsPageMediaSize',
						['12x18']				=	'ns0000:_12X18',
						['11x17']				=	'ns0000:NorthAmerica11x17',
						['legal']				=	'ns0000:NorthAmericaLegal',
						['letter']				=	'ns0000:NorthAmericaLetter',
						['executive']			=	'ns0000:NorthAmericaExecutive',
						['5.5x8.5']				=	'ns0000:NorthAmericaStatement',
						['a0']					=	'ns0000:ISOA0',
						['a1']					=	'ns0000:ISOA1',
						['a2']					=	'ns0000:ISOA2',
						['a3']					=	'ns0000:ISOA3',
						['a4']					=	'ns0000:ISOA4',
						['a5']					=	'ns0000:ISOA5',
						['a6']					=	'ns0000:ISOA6',
						['b1']					=	'ns0000:JISB1',
						['b2']					=	'ns0000:JISB2',
						['b3']					=	'ns0000:JISB3',
						['b4jis']				=	'ns0000:JISB4',
						['b5jis']				=	'ns0000:JISB5',
						['b6']					=	'ns0000:JISB6',
						['b7']					=	'ns0000:JISB7',
						['8x13']				=	'ns0000:_8X13',
						['8.25x13']				=	'ns0000:_8_25X13',
						['8.5x13']				=	'ns0000:FOLIO',
						['8.5x13.4']			=	'ns0000:_8_5X13_4',
						['com10env']			=	'ns0000:NorthAmericaNumber10Envelope',
						['monarchenv']			=	'ns0000:NorthAmericaMonarchEnvelope',
						['dlenv']				=	'ns0000:ISODLEnvelope',
						['c6env']				=	'ns0000:ISOC6Envelope',
						['c5env']				=	'ns0000:ISOC5Envelope',
						['chou3jenv']			=	'ns0000:JapanChou3Envelope',
						['chou4jenv']			=	'ns0000:JapanChou4Envelope',
						['you4jenv']			=	'ns0000:JapanYou4Envelope',
						['youchou3jenv']		=	'ns0000:JapanYou4EnvelopeRotated',
						['kaku1jenv']			=	'ns0000:JapanKaku1Envelope',
						['kaku2jenv']			=	'ns0000:JapanKaku2Envelope',
						['bd']					=	'ns0000:BD',
						['lineslider1']			=	'ns0000:LineSlider1',
						['lineslider2']			=	'ns0000:LineSlider2',
						['glt']					=	'ns0000:_8X10_5',
						['10x14']				=	'ns0000:NorthAmerica10x14',
						['10x15']				=	'ns0000:_10X15',
						['11x15']				=	'ns0000:_11X15',
						['15x20']				=	'ns0000:_15X20',
						['8k']					=	'ns0000:_8kai',
						['16k']					=	'ns0000:_16kai',
						['postcard']			=	'ns0000:JapanHagakiPostcard',
						['doublepostcard']		=	'ns0000:JapanDoubleHagakiPostcardRotated',
						['doublepostcardrotated']		=	'ns0000:JapanDoubleHagakiPostcard',
						['governmentlg']		=	'ns0000:_8_25X14',
						['engquatro']			=	'ns0000:NorthAmerica8x10',
						['sra3']				=	'ns0000:_320X450',
						['sra4']				=	'ns0000:_225X320',
						['11x14']				=	'ns0000:_11X14',
						['13x19.2']				=	'ns0000:_13X19_2',
						['13x19']				=	'ns0000:_13X19',
						['12.6x19.2']			=	'ns0000:_12_6X19_2',
						['12.6x18.5']			=	'ns0000:_12_6X18_5',
						['13x18']				=	'ns0000:_13X18',
						['226x310mm']			=	'ns0000:_226X310',
						['310x432mm']			=	'ns0000:_310X432',
						['8.5x12']				=	'ns0000:NorthAmericaGermanStandardFanfold',
						['17x22']				=	'ns0000:Ansic',
						['9x12']				=	'ns0000:_9X12',
						['18x24']				=	'ns0000:_18X24',
						['21x30']				=	'ns0000:_21X30',
						['22x34']				=	'ns0000:_22X34',
						['24x36']				=	'ns0000:_24X36',
						['30x42']				=	'ns0000:_30X42',
						['34x44']				=	'ns0000:_34X44',
						['36x48']				=	'ns0000:_36X48',
						['postcardstandard']	=	'ns0000:PostcardStandard',
						['kiku4']				=	'ns0000:Kiku4',
						['329x483mm']			=	'ns0000:_329X483',
						['photol']				=	'ns0000:PhotoL',
						['8.5x13.5']			=	'ns0000:_8_5X13_5',
						['kaku3jenv']			=	'ns0000:JapanKaku3Envelope',
						['synchrocut_a0width']	=	'ns0000:CustomSizeWidthA0',
						['synchrocut_a1width']	=	'ns0000:CustomSizeWidthA1',
						['synchrocut_a2width']	=	'ns0000:CustomSizeWidthA2',
						['synchrocut_a3width']	=	'ns0000:CustomSizeWidthA3',
						['synchrocut_a4width']	=	'ns0000:CustomSizeWidthA4',
						['synchrocut_customwidth']	=	'ns0000:CustomSizeSynchroCut',
						['custompapersize']		=	'ns0000:CustomMediaSize',
						['custompapersize1']	=	'ns0000:CustomSize1',
						['custompapersize2']	=	'ns0000:CustomSize2',
						['custompapersize3']	=	'ns0000:CustomSize3',
						['custompapersize4']	=	'ns0000:CustomSize4',
						['custompapersize5']	=	'ns0000:CustomSize5',
						['custompapersize6']	=	'ns0000:CustomSize6',
						['custompapersize7']	=	'ns0000:CustomSize7',
						['custompapersize8']	=	'ns0000:CustomSize8',
						['custompapersize9']	=	'ns0000:CustomSize9',
						['custompapersize10']	=	'ns0000:CustomSize10',
						['custompapersize11']	=	'ns0000:CustomSize11',
						['custompapersize12']	=	'ns0000:CustomSize12',
						['custompapersize13']	=	'ns0000:CustomSize13',
						['custompapersize14']	=	'ns0000:CustomSize14',
						['custompapersize15']	=	'ns0000:CustomSize15',
						['custompapersize16']	=	'ns0000:CustomSize16',
						['custompapersize17']	=	'ns0000:CustomSize17',
						['custompapersize18']	=	'ns0000:CustomSize18',
						['custompapersize19']	=	'ns0000:CustomSize19',
						['custompapersize20']	=	'ns0000:CustomSize20',
						['custompapersize21']	=	'ns0000:CustomSize21',
						['custompapersize22']	=	'ns0000:CustomSize22',
						['custompapersize23']	=	'ns0000:CustomSize23',
						['custompapersize24']	=	'ns0000:CustomSize24',
						['custompapersize25']	=	'ns0000:CustomSize25',
						['custompapersize26']	=	'ns0000:CustomSize26',
						['custompapersize27']	=	'ns0000:CustomSize27',
						['custompapersize28']	=	'ns0000:CustomSize28',
						['custompapersize29']	=	'ns0000:CustomSize29',
						['custompapersize30']	=	'ns0000:CustomSize30',
						['custompapersize31']	=	'ns0000:CustomSize31',
						['custompapersize32']	=	'ns0000:CustomSize32',
						['custompapersize33']	=	'ns0000:CustomSize33',
						['custompapersize34']	=	'ns0000:CustomSize34',
						['custompapersize35']	=	'ns0000:CustomSize35',
						['custompapersize36']	=	'ns0000:CustomSize36',
						['custompapersize37']	=	'ns0000:CustomSize37',
						['custompapersize38']	=	'ns0000:CustomSize38',
						['custompapersize39']	=	'ns0000:CustomSize39',
						['custompapersize40']	=	'ns0000:CustomSize40',
						['custompapersize41']	=	'ns0000:CustomSize41',
						['custompapersize42']	=	'ns0000:CustomSize42',
						['custompapersize43']	=	'ns0000:CustomSize43',
						['custompapersize44']	=	'ns0000:CustomSize44',
						['custompapersize45']	=	'ns0000:CustomSize45',
						['custompapersize46']	=	'ns0000:CustomSize46',
						['custompapersize47']	=	'ns0000:CustomSize47',
						['custompapersize48']	=	'ns0000:CustomSize48',
						['custompapersize49']	=	'ns0000:CustomSize49',
						['custompapersize50']	=	'ns0000:CustomSize50',
						['custompapersize51']	=	'ns0000:CustomSize51',
						['custompapersize52']	=	'ns0000:CustomSize52',
						['custompapersize53']	=	'ns0000:CustomSize53',
						['custompapersize54']	=	'ns0000:CustomSize54',
						['custompapersize55']	=	'ns0000:CustomSize55',
						['custompapersize56']	=	'ns0000:CustomSize56',
						['custompapersize57']	=	'ns0000:CustomSize57',
						['custompapersize58']	=	'ns0000:CustomSize58',
						['custompapersize59']	=	'ns0000:CustomSize59',
						['custompapersize60']	=	'ns0000:CustomSize60',
						['custompapersize61']	=	'ns0000:CustomSize61',
						['custompapersize62']	=	'ns0000:CustomSize62',
						['custompapersize63']	=	'ns0000:CustomSize63',
						['custompapersize64']	=	'ns0000:CustomSize64',
						['custompapersize65']	=	'ns0000:CustomSize65',
						['custompapersize66']	=	'ns0000:CustomSize66',
						['custompapersize67']	=	'ns0000:CustomSize67',
						['custompapersize68']	=	'ns0000:CustomSize68',
						['custompapersize69']	=	'ns0000:CustomSize69',
						['custompapersize70']	=	'ns0000:CustomSize70',
						['custompapersize71']	=	'ns0000:CustomSize71',
						['custompapersize72']	=	'ns0000:CustomSize72',
						['custompapersize73']	=	'ns0000:CustomSize73',
						['custompapersize74']	=	'ns0000:CustomSize74',
						['custompapersize75']	=	'ns0000:CustomSize75',
						['custompapersize76']	=	'ns0000:CustomSize76',
						['custompapersize77']	=	'ns0000:CustomSize77',
						['custompapersize78']	=	'ns0000:CustomSize78',
						['custompapersize79']	=	'ns0000:CustomSize79',
						['custompapersize80']	=	'ns0000:CustomSize80',
						['custompapersize81']	=	'ns0000:CustomSize81',
						['custompapersize82']	=	'ns0000:CustomSize82',
						['custompapersize83']	=	'ns0000:CustomSize83',
						['custompapersize84']	=	'ns0000:CustomSize84',
						['custompapersize85']	=	'ns0000:CustomSize85',
						['custompapersize86']	=	'ns0000:CustomSize86',
						['custompapersize87']	=	'ns0000:CustomSize87',
						['custompapersize88']	=	'ns0000:CustomSize88',
						['custompapersize89']	=	'ns0000:CustomSize89',
						['custompapersize90']	=	'ns0000:CustomSize90',
						['custompapersize91']	=	'ns0000:CustomSize91',
						['custompapersize92']	=	'ns0000:CustomSize92',
						['custompapersize93']	=	'ns0000:CustomSize93',
						['custompapersize94']	=	'ns0000:CustomSize94',
						['custompapersize95']	=	'ns0000:CustomSize95',
						['custompapersize96']	=	'ns0000:CustomSize96',
						['custompapersize97']	=	'ns0000:CustomSize97',
						['custompapersize98']	=	'ns0000:CustomSize98',
						['custompapersize99']	=	'ns0000:CustomSize99',
						['custompapersize100']	=	'ns0000:CustomSize100'
					}
				local paper_width
				local paper_height
				local cdb_val
				local print_val
				
				cdb_val = tbl['printsize']
				print_val = element_table[cdb_val]
				
				if('sameasoriginalsize' == cdb_val)then
					cdb_val = tbl['documentsize']
				end
				
				if(nil == print_val)then
					cdb_val = 'sameasoriginalsize'
					print_val = 'ns0000:SameAsPageMediaSize'
				end
				
				if('sameasoriginalsize' ~= cdb_val)then 
					local current_paper = option['paper_info'][cdb_val]
					paper_width = tostring(current_paper['mm']['width'] * 100)
					paper_height = tostring(current_paper['mm']['height'] * 100)
				end
				
				local result_table
				
				if(element_table['sameasoriginalsize'] == print_val)then
					result_table = {
								tag			=	'psf:Option',
								attribute	=
								{
									key	=	'name',
									value	= print_val
								}
							}
				else
					result_table = {
							tag			=	'psf:Option',
							attribute	=
							{
								key	=	'name',
								value	= print_val
							},
							children	=
								{
									{
										tag			= 	'psf:ScoredProperty',
										attribute	=
											{
												key		=	'name',
												value	=	'ns0000:MediaSizeWidth'
											},
										children = {
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text = paper_width
											}
									},
									{
										tag			= 	'psf:ScoredProperty',
										attribute	=
											{
												key		=	'name',
												value	=	'ns0000:MediaSizeHeight'
											},
										children = {
											tag			= 	'psf:Value',
											attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:integer'
												},
											text = paper_height
											}
									}
								}
						}
				end
			return result_table
			end
	},
	-- 05 Reduce/Enlarge
	reduceenlarge	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	=	'psk:PageScaling'
		},
		children	=
		{
			tag 		=	'psf:Option',
			attribute	=
			{
				key 	=	'name',
				value 	=
				{
					reduceenlarge	=
					{
						['off']				=	'psk:None',
						['zoom']			=	'psk:CustomSquare',
						['fittoprintsize']	=	'ns0000:FitToPaperSize',
						['directionalzoom']	=	'psk:Custom'
					}
				}
			},
			children	=	function(tbl)
								if(('zoom' == tbl['reduceenlarge'] and nil ==  tbl['zoomvalue'])
									or ('directionalzoom' == tbl['reduceenlarge'] and nil ==  tbl['directionalzoom_verticalvalue'] and nil == tbl['directionalzoom_horizontalvalue'] )
									or 'off' == tbl['reduceenlarge']
									or 'fittoprintsize' == tbl['reduceenlarge'])then
									return nil
								end
								
								local scored_table = {}
								-- Zoom
								if('zoom' == tbl['reduceenlarge'] and nil ~=  tbl['zoomvalue'])then
									table.insert(scored_table,
										{
											tag			=	'psf:ScoredProperty',
											attribute	=
												{
													key		=	'name',
													value	=	'psk:Scale'
												},
											children	=	{
													{
														tag			= 	'psf:Value',
														attribute	=
															{
																key		=	'xsi:type',
																value	=	'xsd:integer'
															},
														text	=	tbl['zoomvalue']
													}
												}
										}
									)
								end
								
								-- Directional Zoom
								if('directionalzoom' == tbl['reduceenlarge'] and nil ~=  tbl['directionalzoom_verticalvalue'])then
									table.insert(scored_table,
										{
											tag			=	'psf:ScoredProperty',
											attribute	=
												{
													key		=	'name',
													value	=	'psk:ScaleWidth'
												},
											children	=	{
													{
														tag			= 	'psf:Value',
														attribute	=
															{
																key		=	'xsi:type',
																value	=	'xsd:integer'
															},
														text	=	tbl['directionalzoom_verticalvalue']
													}
												}
										}
									)
								end
								if('directionalzoom' == tbl['reduceenlarge'] and nil ~=  tbl['directionalzoom_horizontalvalue'])then
									table.insert(scored_table,
										{
											tag			=	'psf:ScoredProperty',
											attribute	=
												{
													key		=	'name',
													value	=	'psk:ScaleHeight'
												},
											children	=	{
													{
														tag			= 	'psf:Value',
														attribute	=
															{
																key		=	'xsi:type',
																value	=	'xsd:integer'
															},
														text	=	tbl['directionalzoom_horizontalvalue']
													}
												}
										}
									)
								end
								return scored_table
							end
		}
	},
	-- 06 Adjust image position
	adjustimgpos_direction	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobAdjustImagePosition'
		},
		children	=
		{
			tag 		=	'psf:Option',
			attribute	=
			{
				key 	=	'name',
				value	=
				{
					adjustimgpos_direction	=
					{
						['downwardright']	=	'ns0000:DownwardRight',
						['downwardleft']	=	'ns0000:DownwardLeft',
						['upwardright']		=	'ns0000:UpwardRight',
						['upwardleft']		=	'ns0000:UpwardLeft'
					}
				}
			},
			children	=
			{
				{
					tag 		=	'psf:ScoredProperty',
					attribute	=
					{
						key 	=	'name',
						value 	=	'ns0000:ShiftMarginX'
					},
					children	=
					{
						tag 		=	'psf:Value',
						attribute	=
						{
							key 	=	'xsi:type',
							value	=	'xsd:integer'
						},
						text		=	function(tbl)
											local num = tonumber( tbl.adjustimgpos_leftrightmargin_mm )
											return tostring( ( num and num or 0 ) * 100 )
										end
					}
				},
				{
					tag 		=	'psf:ScoredProperty',
					attribute	=
					{
						key 	=	'name',
						value 	=	'ns0000:ShiftMarginY'
					},
					children	=
					{
						tag 		=	'psf:Value',
						attribute	=
						{
							key 	=	'xsi:type',
							value	=	'xsd:integer'
						},
						text		=	function(tbl)
											local num = tonumber( tbl.adjustimgpos_topbottommargin_mm )
											return tostring( ( num and num or 0 ) * 100 )
										end
					}
				}
			}
		}
	},
	-- 07 Shift image
	shiftimage	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobShiftImageToEdgeCorner'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					shiftimage	=
					{
						['off']							=	'ns0000:Off',
						['topleft_nooverlap']			=	'ns0000:TopLeftNoOverlap',
						['topcenter']					=	'ns0000:TopCenter',
						['topleft']						=	'ns0000:TopLeft',
						['topright']					=	'ns0000:TopRight',
						['bottomcenter']				=	'ns0000:BottomCenter',
						['bottomleft']					=	'ns0000:BottomLeft',
						['bottomright']					=	'ns0000:BottomRight',
						['center']						=	'ns0000:Center',
						['centerleft']					=	'ns0000:CenterLeft',
						['centerright']					=	'ns0000:CenterRight',
						['topleft_symmetric']			=	'ns0000:TopLeftSymmetric',
						['topright_symmetric']			=	'ns0000:TopRightSymmetric',
						['bottomleft_symmetric']		=	'ns0000:BottomLeftSymmetric',
						['bottomright_symmetric']		=	'ns0000:BottomRightSymmetric',
						['centerright_symmetric']		=	'ns0000:CenterRightSymmetric',
						['center_imposition']			=	'ns0000:CenterImposition',
						['topleft_samepos']				=	'ns0000:TopLeftSamePosition',
						['topright_samepos']			=	'ns0000:TopRightSamePosition',
						['bottomleft_samepos']			=	'ns0000:BottomLeftSamePosition',
						['bottomright_samepos']			=	'ns0000:BottomRightSamePosition',
						['topcenter_samepos']			=	'ns0000:TopCenterSamePosition',
						['bottomcenter_samepos']		=	'ns0000:BottomCenterSamePosition',
						['centerleft_samepos']			=	'ns0000:CenterLeftSamePosition',
						['centerright_samepos']			=	'ns0000:CenterRightSamePosition'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 08 Printable Area
	printablearea	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrintableArea'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					printablearea	=
					{
						['standard']		=	'ns0000:Regular',
						['maximum']			=	'ns0000:Maximum',
						['rpdlcompatible']	=	'ns0000:RPDL_Compatible',
						['standard2']		=	'ns0000:Regular2',
						['maximum2']		=	'ns0000:Maximum2',
						['pcl5compatible']	=	'ns0000:PCL5_Compatible',
						['enlargedmargin']	=	'ns0000:EnlargedMargin'
					},
					default	=	{ 'item', 'ns0000:Regular' }
				}
			}
		}
	},
	-- 11 Printer Fit to Print Size
	printer_fittoprintsize	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobFitToPrint'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					printer_fittoprintsize	=
					{
						['promptuser']			=	'ns0000:PromptUser',
						['nearestsizeandscale']	=	'ns0000:NearestSizeAndScale',
						['nearestsizeandcrop']	=	'ns0000:NearestSizeAndCrop'
					},
					default	=	{ 'item', 'ns0000:PromptUser' }
				}
			}
		}
	},
	-- 12 Edge to Edge Print
	edgetoedgeprint	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobEdgeToEdgePrint'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					edgetoedgeprint	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:EdgeToEdge',
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 13 Synchro Cut
	synchrocut	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageSynchroCut'
		},
		children	=	function(tbl)
			local result_table = {}

			if(nil ~= tbl['synchrocut_customwidth_mm'])then
				table.insert(result_table,
					{
						tag 		=	'psf:Option',
						children	=
						{
							tag 		=	'psf:ScoredProperty',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:CustomSynchroCutWidth'
							},
							children	=
							{
								tag 		=	'psf:Value',
								attribute	=
								{
									key 	=	'xsi:type',
									value 	=	'xsd:integer'
								},
								text 		=	tostring( tonumber(tbl['synchrocut_customwidth_mm'] * 100) )
							}
						}
					}
				)
			end

			if(nil ~= tbl['synchrocut_margin_top_mm'])then
				table.insert(result_table,
					{
						tag 		=	'psf:Option',
						children	=
						{
							tag 		=	'psf:ScoredProperty',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:MarginAdjustmentTop'
							},
							children	=
							{
								tag 		=	'psf:Value',
								attribute	=
								{
									key 	=	'xsi:type',
									value 	=	'xsd:integer'
								},
								text 		=	tostring( tonumber(tbl['synchrocut_margin_top_mm'] * 1000) )
							}
						}
					}
				)
			end

			if(nil ~= tbl['synchrocut_margin_bottom_mm'])then
				table.insert(result_table,
					{
						tag 		=	'psf:Option',
						children	=
						{
							tag 		=	'psf:ScoredProperty',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:MarginAdjustmentBottom'
							},
							children	=
							{
								tag 		=	'psf:Value',
								attribute	=
								{
									key 	=	'xsi:type',
									value 	=	'xsd:integer'
								},
								text 		=	tostring( tonumber(tbl['synchrocut_margin_bottom_mm'] * 1000) )
							}
						}
					}
				)
			end

			if(nil ~= tbl['synchrocut_margin_left_mm'])then
				table.insert(result_table,
					{
						tag 		=	'psf:Option',
						children	=
						{
							tag 		=	'psf:ScoredProperty',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:MarginAdjustmentLeft'
							},
							children	=
							{
								tag 		=	'psf:Value',
								attribute	=
								{
									key 	=	'xsi:type',
									value 	=	'xsd:integer'
								},
								text 		=	tostring( tonumber(tbl['synchrocut_margin_left_mm'] * 1000) )
							}
						}
					}
				)
			end

			if(nil ~= tbl['synchrocut_margin_right_mm'])then
				table.insert(result_table,
					{
						tag 		=	'psf:Option',
						children	=
						{
							tag 		=	'psf:ScoredProperty',
							attribute	=
							{
								key 	=	'name',
								value 	=	'ns0000:MarginAdjustmentRight'
							},
							children	=
							{
								tag 		=	'psf:Value',
								attribute	=
								{
									key 	=	'xsi:type',
									value 	=	'xsd:integer'
								},
								text 		=	tostring( tonumber(tbl['synchrocut_margin_right_mm'] * 1000) )
							}
						}
					}
				)
			end

			-- Set Maximum Cut Size
			if(nil ~= tbl['synchrocut_setmaxcutsize']) then
				local setcutsize_table	=
					{
						['off']				=	'ns0000:Off',
						['on']				=	'ns0000:On',
					}
				
				local setcutsize_val = setcutsize_table[tbl['synchrocut_setmaxcutsize']]
				if(nil == setcutsize_val) then
					setcutsize_val = 'ns0000:Off'
				end

				local setcutsize_child_table = nil
			
				-- Maximum Cut Size
				if(nil ~= tbl['synchrocut_maxcutsize_mm']
					and 'ns0000:Off' ~= setcutsize_val)then
					setcutsize_child_table = {}
					table.insert(setcutsize_child_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:MaximumCutSize'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tostring( tonumber( tbl['synchrocut_maxcutsize_mm'] ) * 100 )
									}
								}
						}
					)
				end

				table.insert(result_table,
					{
						tag			=	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	=	'ns0000:SetMaximumCutSize'
						},
						children	=
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key 	=	'name',
								value	=	setcutsize_val
							},
							children	=	setcutsize_child_table
						}
					}
				)
			end

			-- Print Position
			if(nil ~= tbl['synchrocut_position']) then
				local position_table	=
					{
						['left']				=	'ns0000:Left',
						['center']				=	'ns0000:Center',
						['right']				=	'ns0000:Right',
					}
				
				local position_val = position_table[tbl['synchrocut_position']]
				if(nil == position_val) then
					position_val = 'ns0000:Left'
				end
				
				table.insert(result_table,
					{
						tag			=	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	=	'ns0000:PrintPosition'
						},
						children	=
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key 	=	'name',
								value	=	position_val
							},
						}
					}
				)
			end

			-- Priority Image Direction
			if(nil ~= tbl['synchrocut_feeddirection']) then
				local direction_table	=
					{
						['lef']				=	'ns0000:Lef',
						['sef']				=	'ns0000:Sef',
					}
				
				local direction_val = direction_table[tbl['synchrocut_feeddirection']]
				if(nil == direction_val) then
					direction_val = 'ns0000:Lef'
				end
				
				table.insert(result_table,
					{
						tag			=	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	=	'ns0000:PriorityImageDirection'
						},
						children	=
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key 	=	'name',
								value	=	direction_val
							},
						}
					}
				)
			end

			return result_table
		end
	},
	
	-- 12 Create Margin
	createmargin	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobCreateMargin'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					createmargin	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	
--	[05 Page Layout]
	-- 01 Orientation
	orientation	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:PageOrientation'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=	function(tbl)
					if('portrait' == tbl['orientation'])then
						return 'psk:Portrait'
						
					elseif('landscape' == tbl['orientation'])then
						if(nil ~= tbl['rotatelandscape'] and 'on' == tbl['rotatelandscape'])then
							return 'psk:ReverseLandscape'
						else
							return 'psk:Landscape'
						end
					else
						--default
						return 'psk:Portrait'
					end
					
				end
			}
		}
	},
	-- 01-02 Rotate Mixed Original Orientation
	rotatemixedoriginalorientation	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobMixedDirectionRotation'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key	=	'name',
				value	=
				{
					rotatemixedoriginalorientation	=
					{
						['automatic']				=	'ns0000:Automatic',
						['printerdefault']			=	'ns0000:PrinterDefaults',
						['reverseprinterdefault']	=	'ns0000:ReversePrinterDefaults'
					},
					default	=	{ 'item', 'ns0000:Automatic' }
				}
			}
		}
	},
	-- 02 Rotated
	rotated	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobImageDirection'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					rotated	=
					{
						['on']	=	'ns0000:Reverse',
						['off']	=	'ns0000:Normal'
					},
					default	=	{ 'item', 'ns0000:Normal' }
				}
			}
		}
	},
	-- 03 Mirroring
	mirroring	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:PageMirrorImage'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					mirroring	=
					{
						['on']	=	'psk:MirrorImageWidth',
						['off']	=	'psk:None'
					},
					default	=	{ 'item', 'psk:None' }
				}
			}
		}
	},
	-- 04 Layout
	layout	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'psk:JobNUpAllDocumentsContiguously'
		},
		children	=	function(tbl)
			
			local result_table = {}

			local layout_table = {
						['1pagepersheet']	= '1',
						['2pagespersheet'] 	= '2',
						['4pagespersheet'] 	= '4',
						['6pagespersheet'] 	= '6',
						['8pagespersheet'] 	= '8',
						['9pagespersheet'] 	= '9',
						['16pagespersheet']	= '16'
					}
			local layout_val = layout_table[tbl['layout']]
			if(nil == layout_val)then
				layout_val = '1'
			end
			
			table.insert(result_table,
				{
					tag 		=	'psf:Option',
					children	=
					{
						tag 		=	'psf:ScoredProperty',
						attribute	=
						{
							key 	=	'name',
							value 	=	'psk:PagesPerSheet'
						},
						children	=
						{
							tag 		=	'psf:Value',
							attribute	=
							{
								key 	=	'xsi:type',
								value 	=	'xsd:integer'
							},
							text 		=	layout_val
						}
					}
				}
			)
			
			--pageorder
			if(nil ~= tbl['pageorder'])then
				local pageorder_table	=
					{
						['none']			=	'ns0000:None',
						['rightthendown']	=	'psk:RightBottom',
						['downthenright']	=	'psk:BottomRight',
						['leftthendown']	=	'psk:LeftBottom',
						['downthenleft']	=	'psk:BottomLeft',
						['lefttoright']		=	'ns0000:LeftRightOrTopBottom',
						['righttoleft']		=	'ns0000:RightLeftOrTopBottom'
					}
				local pageorder_val = pageorder_table[tbl['pageorder']]
				if(nil == pageorder_val)then
					pageorder_val = 'ns0000:None'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'psk:PresentationDirection'
						},
						
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	pageorder_val
							}
						}
					}
				)
			end
			
			--drawframeborder
			if(nil ~= tbl['drawframeborder'])then
				local drawframeborder_table	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					}
				local drawframeborder_val = drawframeborder_table[tbl['drawframeborder']]
				if(nil == drawframeborder_val)then
					drawframeborder_val = 'ns0000:Off'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:Frame'
						},
						
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	drawframeborder_val
							}
						}
					}
				)
			end
			
			--drawborderline
			if(nil ~= tbl['drawborderline'])then
				local drawborderline_table	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					}
				local drawborderline_val = drawborderline_table[tbl['drawborderline']]
				if(nil == drawborderline_val)then
					drawborderline_val = 'ns0000:Off'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:Border'
						},
						
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	drawborderline_val
							}
						}
					}
				)
			end
		
		-- layout_rotatemixedoriginalorientation
		if(nil ~= tbl['layout_rotatemixedoriginalorientation'])then
			local mixed_table	=
				{
					['rotate']		=	'ns0000:RotateNaturally',
					['reduce']		=	'ns0000:ReduceWithoutRotation',
					['pagebreak']	=	'ns0000:NotMix'
				}
			local mixed_val = mixed_table[tbl['layout_rotatemixedoriginalorientation']]
			if(nil == mixed_val)then
				mixed_val = 'ns0000:RotateNaturally'
			end
			
			table.insert(result_table,
				{
					tag 		= 	'psf:Feature',
					attribute	=
					{
						key 	=	'name',
						value 	= 	'ns0000:NUpMixedDirectionLayout'
					},
					
					children = {
						tag 		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	mixed_val
						}
					}
				}
			)
		end
		return result_table
		end
	},
	-- 05 Booklet
	booklet	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobBooklet'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local booklet_table	=
				{
					['off']			=	'ns0000:Off',
					['booklet']		=	'ns0000:Booklet',
					['minibook']	=	'ns0000:MiniBook',
				}
			local booklet_val = booklet_table[tbl['booklet']]
			if(nil == booklet_val)then
				booklet_val = 'ns0000:Off'
			end
			
			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key	=	'name',
						value	= booklet_val
					}
				}
			)
			
			local option_table = {}
			-- Creep inside
			if('booklet' == tbl['booklet'] and nil ~= tbl['booklet_creepinsidemargin_mm'])then
				table.insert(option_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:InsideMargin'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tostring( tbl['booklet_creepinsidemargin_mm'] * 100 )
								}
							}
					}
				)
			end
			
			-- Creep outside
			if('booklet' == tbl['booklet'] and nil ~= tbl['booklet_creepoutsidemargin_mm'])then
				table.insert(option_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:OutsideMargin'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tostring( tbl['booklet_creepoutsidemargin_mm'] * 100 )
								}
							}
					}
				)
			end
			
			if(0 ~= table.getn(option_table))then
				result_table[1]['children'] = option_table
			end
			
			-- Booklet Page Order
			if(nil ~= tbl['booklet_pageorder'])then
				local booklet_pageorder_table	=
					{
						['opentoleftortop']			=	'ns0000:OpenToLeftOrTop',
						['opentorightorbottom']		=	'ns0000:OpenToRightOrBottom',
						['opentorightortop']		=	'ns0000:OpenToRightOrTop'
					}
				local booklet_pageorder_val = booklet_pageorder_table[tbl['booklet_pageorder']]
				if(nil == booklet_pageorder_val)then
					booklet_pageorder_val = 'ns0000:OpenToLeftOrTop'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:BookletPageOrder'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	booklet_pageorder_val
							}
						}
					}
				)
			end
			
			-- Booklet Mixed Direction
			if(nil ~= tbl['booklet_rotatemixedoriginalorientation'])then
				local booklet_rotatemixedoriginalorientation_table	=
					{
						['rotate']		=	'ns0000:RotateNaturally',
						['reduce']		=	'ns0000:ReduceWithoutRotation',
					}
				local booklet_rotatemixedoriginalorientation_val = booklet_rotatemixedoriginalorientation_table[tbl['booklet_rotatemixedoriginalorientation']]
				if(nil == booklet_rotatemixedoriginalorientation_val)then
					booklet_rotatemixedoriginalorientation_val = 'ns0000:OpenToLeftOrTop'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:BookletMixedDirectionLayout'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	booklet_rotatemixedoriginalorientation_val
							}
						}
					}
				)
			end
			-- Booklet EqualMagnification
			if(nil ~= tbl['booklet_equalmagnification'])then
			
				local booklet_equalmagnification_table	=
						{
							['off']		=	'ns0000:Off',
							['on']		=	'ns0000:On'
						}
				local booklet_equalmagnification_val = booklet_equalmagnification_table[tbl['booklet_equalmagnification']]
				if(nil == booklet_equalmagnification_val)then
					booklet_equalmagnification_val = 'ns0000:Off'
				end
					
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:BookletEqualMagnification'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	booklet_equalmagnification_val
							}
						}
					}
				)
			end
			return result_table
		end
	},
	-- 06 Poster
	poster	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:PagePoster'
		},
		children	=
		{
			tag 		=	'psf:Option',
			children	=
			{
				tag 		=	'psf:ScoredProperty',
				attribute	=
				{
					key 	=	'name',
					value	=	'psk:SheetsPerPage'
				},
				children	=
				{
					tag 		=	'psf:Value',
					attribute	=
					{
						key 	=	'xsi:type',
						value	=	'xsd:integer'
					},
					text		=	function(tbl)
										local t =
										{
											['off']					=	'1',
											['1pageinto2sheets']	=	'2',
											['1pageinto4sheets']	=	'4',
											['1pageinto9sheets']	=	'9'
										}

										return t[tbl.poster] and t[tbl.poster] or t['off'] 
									end
				}
			}
		}
	},
	-- 07 Speed
	speed	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobSpeedPrintContiguously'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					speed	=
					{
						['off']							=	'ns0000:Off',
						['lefttorightortoptobottom']	=	'ns0000:LeftToRightOrTopToBottom',
						['righttoleftortoptobottom']	=	'ns0000:RightToLeftOrTopToBottom'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 08 Double
	double	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobDoublePrint'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					double	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	
	-- 09 GuideBook Fold
	guidebookfold	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobGuideBookFold'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local guidebookfold_table	=
				{
					['off']		=	'ns0000:Off',
					['on']		=	'ns0000:On',
				}
			local guidebookfold_val = guidebookfold_table[tbl['guidebookfold']]
			if(nil == guidebookfold_val)then
				guidebookfold_val = 'ns0000:Off'
			end
			
			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key	=	'name',
						value	= guidebookfold_val
					}
				}
			)
			
			-- 09-01 GuideBook Fold::Draw Border Line
			if(nil ~= tbl['guidebookfold_drawborderline'])then
				local guidebookfold_drawborderline_table	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
					}
				local guidebookfold_drawborderline_val = guidebookfold_drawborderline_table[tbl['guidebookfold_drawborderline']]
				if(nil == guidebookfold_drawborderline_val)then
					guidebookfold_drawborderline_val = 'ns0000:Off'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:Border'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	guidebookfold_drawborderline_val
							}
						}
					}
				)
			end
			
			return result_table
		end
	},
	-- 11 Repeat
	['repeat']	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobRepeatPrint'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local repeat_table	=
				{
					['off']			=	'ns0000:Off',
					['2repeat']		=	'ns0000:Repeat2',
					['4repeat']		=	'ns0000:Repeat4',
					['9repeat']		=	'ns0000:Repeat9',
					['16repeat']	=	'ns0000:Repeat16'
				}
			local repeat_val = repeat_table[tbl['repeat']]
			if(nil == repeat_val)then
				repeat_val = 'ns0000:Off'
			end
			
			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key	=	'name',
						value	= repeat_val
					}
				}
			)
			
			-- 11-01 Repeat::Draw Border Line for Repeat 
			if(nil ~= tbl['repeat_drawborderline'])then
				local repeat_drawborderline_table	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
					}
				local repeat_drawborderline_val = repeat_drawborderline_table[tbl['repeat_drawborderline']]
				if(nil == repeat_drawborderline_val)then
					repeat_drawborderline_val = 'ns0000:Off'
				end

				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:RepeatFrameBorder'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	repeat_drawborderline_val
							}
						}
					}
				)
			end
			
			return result_table
		end
	},
	-- 12 Leaflet Fold
	leafletfold	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobLeafletFold'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local leafletfold_table	=
				{
					['off']					=	'ns0000:Off',
					['1_4pagespersheet']	=	'ns0000:1_4PagesPerSheet',
					['4_4pagespersheet']	=	'ns0000:4_4PagesPerSheet',
				}
			local leafletfold_val = leafletfold_table[tbl['leafletfold']]
			if(nil == leafletfold_val)then
				leafletfold_val = 'ns0000:Off'
			end
			
			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key	=	'name',
						value	= leafletfold_val
					}
				}
			)
			
			-- 12-01 Leaflet Fold::Draw Border Line
			if(nil ~= tbl['leafletfold_drawborderline'])then
				local leafletfold_drawborderline_table	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
					}
				local leafletfold_drawborderline_val = leafletfold_drawborderline_table[tbl['leafletfold_drawborderline']]
				if(nil == leafletfold_drawborderline_val)then
					leafletfold_drawborderline_val = 'ns0000:Off'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:Border'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	leafletfold_drawborderline_val
							}
						}
					}
				)
			end
			
			return result_table
		end
	},
	
	-- 13 Manual Duplex
	manualduplex	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobManualDuplex'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					manualduplex	=
					{
						['off']				=	'ns0000:Off',
						['evenpageprint']	=	'ns0000:EvenPagePrint',
						['oddpageprint']	=	'ns0000:OddPagePrint'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	
-- [06 Image]
	-- 01 Watermark
	pwmk_print	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageWatermark'
		},
		children	=	function(tbl)
			local result_table = {}
			if( nil ~= tbl['pwmk_print'] and 'off' == tbl['pwmk_print']) then
				table.insert(result_table,
					{
						tag		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	'ns0000:Off'
						}
					})
			elseif(nil ~= tbl['pwmk_print'] and 'on' == tbl['pwmk_print'] and nil ~= tbl['pwmk_namelist'])then
				table.insert(result_table,
					{
						tag		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	'ns0000:On'
						},
						children	=
						{
							tag			= 	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:WatermarkItem'
								},
								children =
								{
									tag			= 	'psf:Value',
									attribute	=
									{
										key		=	'xsi:type',
										value	=	'xsd:string'
									},
									text		=	tbl['pwmk_namelist']
								}
						}
					})
			end
			return result_table
			end
	},
	-- 02 Header/Footer
	phf_print	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageHeaderFooter'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local headerfooter_table	=
				{
					['off']	=	'ns0000:Off',
					['on']	=	'ns0000:On',
				}
			local headerfooter_val = headerfooter_table[tbl['phf_print']]
			if(nil == headerfooter_val)then
				headerfooter_val = 'ns0000:Off'
			end
			
			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key		=	'name',
						value	=	headerfooter_val
					}
				}
			)
			
			local scored_table = {}
			-- Font
			if('on' == tbl['phf_print'] and nil ~= tbl['phf_font'])then
				table.insert(scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:FontName'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['phf_font']
								}
							}
					}
				)
			end
			
			-- Font Size
			if('on' == tbl['phf_print'] and nil ~= tbl['phf_fontsize'])then
				table.insert(scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:FontSize'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tbl['phf_fontsize']
								}
							}
					}
				)
			end
			
			if(0 ~= table.getn(scored_table))then
				result_table[1]['children'] = scored_table
			end
			
			-- phf_perlogicalpage
			if(nil ~= tbl['phf_perlogicalpage'])then
				local headerfooter_printper_table	=
					{
					
						['off']	=	'ns0000:PhysicalPage',
						['on']	=	'ns0000:OriginalPage',
					}
				local headerfooter_printper_val = headerfooter_printper_table[tbl['phf_perlogicalpage']]
				if(nil == headerfooter_printper_val)then
					headerfooter_printper_val = 'ns0000:OriginalPage'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:HeaderFooterPrintPer'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	headerfooter_printper_val
							}
						}
					}
				)
			end
			
			-- phf_dateandtime_print
			if(nil ~= tbl['phf_dateandtime_print'])then
				local headerfooter_datetime_table	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					}
				local headerfooter_datetime_val = headerfooter_datetime_table[tbl['phf_dateandtime_print']]
				if(nil == headerfooter_datetime_val)then
					headerfooter_datetime_val = 'ns0000:Off'
				end
				
				local datetime_feature_table = {}
				table.insert(datetime_feature_table,
					{
						tag 		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	headerfooter_datetime_val
						}
					}
				)
				
				-- phf_dateandtime_position
				if(nil ~= tbl['phf_dateandtime_position'])then
					local headerfooter_datetime_position_table	=
						{
							['topright']		=	'ns0000:TopRight',
							['topleft']			=	'ns0000:TopLeft',
							['topcenter']		=	'ns0000:TopCenter',
							['bottomright']		=	'ns0000:BottomRight',
							['bottomleft']		=	'ns0000:BottomLeft',
							['bottomcenter']	=	'ns0000:BottomCenter',
						}
					local headerfooter_datetime_position_val = headerfooter_datetime_position_table[tbl['phf_dateandtime_position']]
					if(nil == headerfooter_datetime_position_val)then
						headerfooter_datetime_position_val = 'ns0000:TopLeft'
					end
					
					table.insert(datetime_feature_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:HeaderFooterDatePosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	headerfooter_datetime_position_val
								}
							}
						}
					)
				end
				
				-- phf_dateandtime_format
				if(nil ~= tbl['phf_dateandtime_format'])then
					local headerfooter_datetime_format_table	=
						{
							['mmddyyyy_slash']				=	'ns0000:MMDDYYYY_SlashFormat',
							['mmddyyyy_dot']				=	'ns0000:MMDDYYYY_DotFormat',
							['ddmmyyyy_slash']				=	'ns0000:DDMMYYYY_SlashFormat',
							['ddmmyyyy_dot']				=	'ns0000:DDMMYYYY_DotFormat',
							['yyyymmdd_dot']				=	'ns0000:YYYYMMDD_DotFormat',
							['mmddyyyy_slash_hhmm_colon']	=	'ns0000:MMDDYYYYhhmm_SlashFormat',
							['mmddyyyy_dot_hhmm_colon']		=	'ns0000:MMDDYYYYhhmm_DotFormat',
							['ddmmyyyy_slash_hhmm_colon']	=	'ns0000:DDMMYYYYhhmm_SlashFormat',
							['ddmmyyyy_dot_hhmm_colon']		=	'ns0000:YYYYMMDDhhmm_DotFormat',
							['yyyymmdd_dot_hhmm_colon']		=	'ns0000:DDMMYYYYhhmm_DotFormat',
							['yyyymmdd_jpn']				=	'ns0000:YYYYMMDD_JapaneseFormat',
							['yyyymmdd_jpn_hhmm_jpn']		=	'ns0000:YYYYMMDDhhmm_JapaneseFormat',
						}
					local headerfooter_datetime_format_val = headerfooter_datetime_format_table[tbl['phf_dateandtime_format']]
					if(nil == headerfooter_datetime_format_val)then
						headerfooter_datetime_format_val = 'ns0000:YYYYMMDD_DotFormat'
					end
					
					table.insert(datetime_feature_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:HeaderFooterDateFormat'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	headerfooter_datetime_format_val
								}
							}
						}
					)
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:HeaderFooterDate'
						},
						children = datetime_feature_table
					}
				)
			end
			
			-- phf_pagenumber_print
			if(nil ~= tbl['phf_pagenumber_print'])then
				local headerfooter_number_table	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					}
				local headerfooter_number_val = headerfooter_number_table[tbl['phf_pagenumber_print']]
				if(nil == headerfooter_number_val)then
					headerfooter_number_val = 'ns0000:Off'
				end
				
				local number_feature_table = {}
				table.insert(number_feature_table,
					{
						tag 		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	headerfooter_number_val
						}
					}
				)
				
				-- phf_pagenumber_position
				if(nil ~= tbl['phf_pagenumber_position'])then
					local headerfooter_number_position_table	=
						{
							['topright']			=	'ns0000:TopRight',
							['topleft']				=	'ns0000:TopLeft',
							['topcenter']			=	'ns0000:TopCenter',
							['bottomright']			=	'ns0000:BottomRight',
							['bottomleft']			=	'ns0000:BottomLeft',
							['bottomcenter']		=	'ns0000:BottomCenter',
							['insidetopleft']		=	'ns0000:InsideTopOrLeft',
							['insidetopright']		=	'ns0000:InsideTopOrRight',
							['insidebottomleft']	=	'ns0000:InsideBottomOrLeft',
							['insidebottomright']	=	'ns0000:InsideBottomOrRight',
							['outsidetopleft']		=	'ns0000:OutsideTopOrLeft',
							['outsidetopright']		=	'ns0000:OutsideTopOrRight',
							['outsidebottomleft']	=	'ns0000:OutsideBottomOrLeft',
							['outsidebottomright']	=	'ns0000:OutsideBottomOrRight',
						}
					local headerfooter_number_position_val = headerfooter_number_position_table[tbl['phf_pagenumber_position']]
					if(nil == headerfooter_number_position_val)then
						headerfooter_number_position_val = 'ns0000:BottomCenter'
					end
					
					table.insert(number_feature_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:HeaderFooterNumberPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	headerfooter_number_position_val
								}
							}
						}
					)
				end
				
				-- phf_dateandtime_format
				if(nil ~= tbl['phf_pagenumber_format'])then
					local headerfooter_number_format_table	=
						{
							['p_only']		=	'ns0000:PNumber',
							['hyphen']		=	'ns0000:NumberHyphen',
							['p_dot']		=	'ns0000:PDotNumber',
							['none']		=	'ns0000:OnlyNumber',
							['jpn_page']	=	'ns0000:JapanesePageNumber',
						}
					local headerfooter_number_format_val = headerfooter_number_format_table[tbl['phf_pagenumber_format']]
					if(nil == headerfooter_number_format_val)then
						headerfooter_number_format_val = 'ns0000:OnlyNumber'
					end
					
					table.insert(number_feature_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:HeaderFooterNumberFormat'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	headerfooter_number_format_val
								}
							}
						}
					)
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:HeaderFooterNumber'
						},
						children = number_feature_table
					}
				)
			end
			
			-- phf_text_print
			if(nil ~= tbl['phf_text_print'])then
				local headerfooter_text_table	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					}
				local headerfooter_text_val = headerfooter_text_table[tbl['phf_text_print']]
				if(nil == headerfooter_text_val)then
					headerfooter_text_val = 'ns0000:Off'
				end
				
				local text_feature_table = {}
				table.insert(text_feature_table,
					{
						tag 		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	headerfooter_text_val
						}
					}
				)
				
				-- phf_text_position
				if(nil ~= tbl['phf_text_position'])then
					local headerfooter_text_position_table	=
						{
							['topright']			=	'ns0000:TopRight',
							['topleft']				=	'ns0000:TopLeft',
							['topcenter']			=	'ns0000:TopCenter',
							['bottomright']			=	'ns0000:BottomRight',
							['bottomleft']			=	'ns0000:BottomLeft',
							['bottomcenter']		=	'ns0000:BottomCenter',
						}
					local headerfooter_text_position_val = headerfooter_text_position_table[tbl['phf_text_position']]
					if(nil == headerfooter_text_position_val)then
						headerfooter_text_position_val = 'ns0000:BottomLeft'
					end
					
					table.insert(text_feature_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:HeaderFooterTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	headerfooter_text_position_val
								}
							}
						}
					)
				end
				
				-- phf_text_type
				if(nil ~= tbl['phf_text_type'])then
					local headerfooter_text_format_table	=
						{
							['filename']		=	'ns0000:FileName',
							['logonname']		=	'ns0000:LoginName',
							['userdefinedtext']	=	'ns0000:Custom',
						}
					local headerfooter_text_format_val = headerfooter_text_format_table[tbl['phf_text_type']]
					if(nil == headerfooter_text_format_val)then
						headerfooter_text_format_val = 'ns0000:FileName'
					end
					
					if('userdefinedtext' == tbl['phf_text_type'] and nil ~= tbl['phf_text_userdefined'])then
						table.insert(text_feature_table,
							{
								tag 		= 	'psf:Feature',
								attribute	=
								{
									key 	=	'name',
									value 	= 	'ns0000:HeaderFooterTextFormat'
								},
								children = {
									tag 		=	'psf:Option',
									attribute	=
									{
										key		=	'name',
										value	=	headerfooter_text_format_val
									},
									children	=
									{
										tag			= 	'psf:ScoredProperty',
										attribute	=
											{
												key		=	'name',
												value	=	'ns0000:CustomText'
											},
											children =
											{
												tag			= 	'psf:Value',
												attribute	=
												{
													key		=	'xsi:type',
													value	=	'xsd:string'
												},
												text		=	tbl['phf_text_userdefined']
											}
									}
								}
							}
						)
					else
						table.insert(text_feature_table,
							{
								tag 		= 	'psf:Feature',
								attribute	=
								{
									key 	=	'name',
									value 	= 	'ns0000:HeaderFooterTextFormat'
								},
								children = {
									tag 		=	'psf:Option',
									attribute	=
									{
										key		=	'name',
										value	=	headerfooter_text_format_val
									}
								}
							}
						)
					end
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:HeaderFooterText'
						},
						children = text_feature_table
					}
				)
			end
			
			return result_table
		end
	},
	-- 03 Image Watermark
	piw_print	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageImageWatermark'
		},
		children	=	function(tbl)
			local result_table = {}
			if( nil ~= tbl['piw_print'] and 'off' == tbl['piw_print']) then
				table.insert(result_table,
					{
						tag		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	'ns0000:Off'
						}
					})
			elseif(nil ~= tbl['piw_print'] and 'on' == tbl['piw_print'] and nil ~= tbl['piw_namelist'])then
				table.insert(result_table,
					{
						tag		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	'ns0000:On'
						},
						children	=
						{
							tag			= 	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:ImageWatermarkItem'
								},
								children =
								{
									tag			= 	'psf:Value',
									attribute	=
									{
										key		=	'xsi:type',
										value	=	'xsd:string'
									},
									text		=	tbl['piw_namelist']
								}
						}
					})
			end
			return result_table
			end
	},
	-- 04 OverlayWatermark
	pow_print	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageOverlayWatermark'
		},
		children	=	function(tbl)
			local result_table = {}
			if( nil ~= tbl['pow_print'] and 'off' == tbl['pow_print']) then
				table.insert(result_table,
					{
						tag		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	'ns0000:Off'
						}
					})
			elseif(nil ~= tbl['pow_print'] and 'on' == tbl['pow_print'] and nil ~= tbl['pow_namelist'])then
				table.insert(result_table,
					{
						tag		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	'ns0000:On'
						},
						children	=
						{
							tag			= 	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:OverlayWatermarkItem'
								},
								children =
								{
									tag			= 	'psf:Value',
									attribute	=
									{
										key		=	'xsi:type',
										value	=	'xsd:string'
									},
									text		=	tbl['pow_namelist']
								}
						}
					})
			end
			return result_table
			end
	},
-- [07 Security]
	-- 01 Copy Control Print (Printer)
	cc_print	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobCopyControlPrint'
		},
		children	=	function(tbl)
				
				local result_table
				local copycontrol_val 
				if('off' == tbl['cc_print'])then
					copycontrol_val = 'ns0000:Off'
					
				elseif('on' == tbl['cc_print'] and nil ~= tbl['cc_type'])then
					local copycontrol_type_table	=
						{
							['preventioncopypattern']	=	'ns0000:CopyPreventionDataSecurity',
							['copyguard']				=	'ns0000:CopyGuard',
						}
					copycontrol_val = copycontrol_type_table[tbl['cc_type']]
				end
				
				if(nil == copycontrol_val)then
					copycontrol_val = 'ns0000:Off'
				end
				
				result_table =
					{
						tag			=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	copycontrol_val
						},
					}
				return result_table
			
			end
	},
	-- 01-01 Prevention Copy Pattern (Printer)
	cc_preventioncopypattern_text	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobCopyPrevention'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local preventiontext_table = {}
			local preventiontext_scored_table = {}
			
			-- CopyPreventionText
			if(nil ~= tbl['cc_preventioncopypattern_text'])then
				table.insert(preventiontext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyPreventionTextString'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['cc_preventioncopypattern_text']
								}
							}
					}
				)
			end
			
			-- FontSize
			if(nil ~= tbl['cc_preventioncopypattern_size'])then
				table.insert(preventiontext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyPreventionFontSize'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tbl['cc_preventioncopypattern_size']
								}
							}
					}
				)
			end
			
			table.insert(preventiontext_table,
				{
					tag			=	'psf:Option',
					children	=	preventiontext_scored_table
				}
			)
			-- Font
			if(nil ~= tbl['cc_preventioncopypattern_font'])then
				local font_element_table	=
						{
							['albertus-medium']	=	'ns0000:Albertus_Medium',
							['albertus-extra-bold']	=	'ns0000:Albertus_Extra_Bold',
							['antiqueolive']	=	'ns0000:AntiqueOlive',
							['albertus']	=	'ns0000:Albertus',
							['albertus-italic']	=	'ns0000:Albertus_Italic',
							['albertus-light']	=	'ns0000:Albertus_Light',
							['antiqueolive-bold']	=	'ns0000:AntiqueOlive_Bold',
							['antiqueolive-compact']	=	'ns0000:AntiqueOlive_Compact',
							['antiqueolive-italic']	=	'ns0000:AntiqueOlive_Italic',
							['antiqueolive-roman']	=	'ns0000:AntiqueOlive_Roman',
							['apple-chancery']	=	'ns0000:Apple_Chancery',
							['arial']	=	'ns0000:Arial',
							['arial-bold']	=	'ns0000:Arial_Bold',
							['arial-bold-italic']	=	'ns0000:Arial_Bold_Italic',
							['arial-italic']	=	'ns0000:Arial_Italic',
							['bodoni']	=	'ns0000:Bodoni',
							['bodoni-bold']	=	'ns0000:Bodoni_Bold',
							['bodoni-bold-italic']	=	'ns0000:Bodoni_Bold_Italic',
							['bodoni-italic']	=	'ns0000:Bodoni_Italic',
							['bodoni-poster']	=	'ns0000:Bodoni_Poster',
							['bodoni-poster-compressed']	=	'ns0000:Bodoni_Poster_Compressed',
							['carta']	=	'ns0000:Carta',
							['cg-omega']	=	'ns0000:CG_Omega',
							['cg-omega-bold']	=	'ns0000:CG_Omega_Bold',
							['cg-omega-bold-italic']	=	'ns0000:CG_Omega_Bold_Italic',
							['cg-omega-italic']	=	'ns0000:CG_Omega_Italic',
							['cg-times']	=	'ns0000:CG_Times',
							['cg-times-bold']	=	'ns0000:CG_Times_Bold',
							['cg-times-bold-italic']	=	'ns0000:CG_Times_Bold_Italic',
							['cg-times-italic']	=	'ns0000:CG_Times_Italic',
							['chicago']	=	'ns0000:Chicago',
							['clarendon']	=	'ns0000:Clarendon',
							['clarendon-bold']	=	'ns0000:Clarendon_Bold',
							['clarendon-light']	=	'ns0000:Clarendon_Light',
							['clarendon-condensed']	=	'ns0000:Clarendon_Condensed',
							['cooperblack']	=	'ns0000:CooperBlack',
							['cooperblack-italic']	=	'ns0000:CooperBlack_Italic',
							['copperplate-gothic-32bc']	=	'ns0000:Copperplate_Gothic_33BC',
							['copperplate-gothic-33bc']	=	'ns0000:Copperplate_Gothic_32BC',
							['coronet']	=	'ns0000:Coronet',
							['courier']	=	'ns0000:Courier',
							['courier-bold']	=	'ns0000:Courier_Bold',
							['courier-bold-oblique']	=	'ns0000:Courier_Bold_Oblique',
							['courier-bold-italic']	=	'ns0000:Courier_Bold_Italic',
							['courier-italic']	=	'ns0000:Courier_Italic',
							['courier-oblique']	=	'ns0000:Courier_Oblique',
							['courierps']	=	'ns0000:CourierPS',
							['courierps-bold']	=	'ns0000:CourierPS_Bold',
							['courierps-bold-oblique']	=	'ns0000:CourierPS_Bold_Oblique',
							['courierps-oblique']	=	'ns0000:CourierPS_Oblique',
							['eurostile']	=	'ns0000:Eurostile',
							['eurostile-bold']	=	'ns0000:Eurostile_Bold',
							['eurostile-bold-extended-two']	=	'ns0000:Eurostile_Bold_Extended_Two',
							['eurostile-extended-two']	=	'ns0000:Eurostile_Extended_Two',
							['garamond-antiqua']	=	'ns0000:Garamond_Antiqua',
							['garamond-halbfett']	=	'ns0000:Garamond_Halbfett',
							['garamond-kursiv']	=	'ns0000:Garamond_Kursiv',
							['garamond-kursiv-halbfett']	=	'ns0000:Garamond_Kursiv_Halbfett',
							['geneva']	=	'ns0000:Geneva',
							['gillsans']	=	'ns0000:GillSans',
							['gillsans-bold']	=	'ns0000:GillSans_Bold',
							['gillsans-bold-italic']	=	'ns0000:GillSans_Bold_Italic',
							['gillsans-condensed']	=	'ns0000:GillSans_Condensed',
							['gillsans-condensed-bold']	=	'ns0000:GillSans_Condensed_Bold',
							['gillsans-extra-bold']	=	'ns0000:GillSans_Extra_Bold',
							['gillsans-italic']	=	'ns0000:GillSans_Italic',
							['gillsans-light']	=	'ns0000:GillSans_Light',
							['gillsans-light-italic']	=	'ns0000:GillSans_Light_Italic',
							['goudy-bold']	=	'ns0000:Goudy_Bold',
							['goudy-bold-italic']	=	'ns0000:Goudy_Bold_Italic',
							['goudy-extrabold']	=	'ns0000:Goudy_ExtraBold',
							['goudy-oldstyle']	=	'ns0000:Goudy_Oldstyle',
							['goudy-oldstyle-italic']	=	'ns0000:Goudy_Oldstyle_Italic',
							['helvetica']	=	'ns0000:Helvetica',
							['helvetica-bold']	=	'ns0000:Helvetica_Bold',
							['helvetica-bold-oblique']	=	'ns0000:Helvetica_Bold_Oblique',
							['helvetica-condensed']	=	'ns0000:Helvetica_Condensed',
							['helvetica-condensed-bold']	=	'ns0000:Helvetica_Condensed_Bold',
							['helvetica-condensed-bold-oblique']	=	'ns0000:Helvetica_Condensed_Bold_Oblique',
							['helvetica-condensed-oblique']	=	'ns0000:Helvetica_Condensed_Oblique',
							['helvetica-narrow']	=	'ns0000:Helvetica_Narrow',
							['helvetica-narrow-bold']	=	'ns0000:Helvetica_Narrow_Bold',
							['helvetica-narrow-bold-oblique']	=	'ns0000:Helvetica_Narrow_Bold_Oblique',
							['helvetica-narrow-oblique']	=	'ns0000:Helvetica_Narrow_Oblique',
							['helvetica-oblique']	=	'ns0000:Helvetica_Oblique',
							['hoeflertext']	=	'ns0000:HoeflerText',
							['hoeflertext-black']	=	'ns0000:HoeflerText_Black',
							['hoeflertext-black-italic']	=	'ns0000:HoeflerText_Black_Italic',
							['hoeflertext-italic']	=	'ns0000:HoeflerText_Italic',
							['hoeflertext-ornaments']	=	'ns0000:HoeflerText_Ornaments',
							['itc-avantgarde-gothic-book']	=	'ns0000:ITC_AvantGarde_Gothic_Book',
							['itc-avantgarde-gothic-book-oblique']	=	'ns0000:ITC_AvantGarde_Gothic_Book_Oblique',
							['itc-avantgarde-gothic-demi']	=	'ns0000:ITC_AvantGarde_Gothic_Demi',
							['itc-avantgarde-gothic-demi-oblique']	=	'ns0000:ITC_AvantGarde_Gothic_Demi_Oblique',
							['itc-bookman-demi']	=	'ns0000:ITC_Bookman_Demi',
							['itc-bookman-demi-italic']	=	'ns0000:ITC_Bookman_Demi_Italic',
							['itc-bookman-light']	=	'ns0000:ITC_Bookman_Light',
							['itc-bookman-light-italic']	=	'ns0000:ITC_Bookman_Light_Italic',
							['itc-lubalin-graph-book']	=	'ns0000:ITC_Lubalin_Graph_Book',
							['itc-lubalin-graph-book-oblique']	=	'ns0000:ITC_Lubalin_Graph_Book_Oblique',
							['itc-lubalin-graph-demi']	=	'ns0000:ITC_Lubalin_Graph_Demi',
							['itc-lubalin-graph-demi-oblique']	=	'ns0000:ITC_Lubalin_Graph_Demi_Oblique',
							['itc-mona-lisa-recut']	=	'ns0000:ITC_Mona_Lisa_Recut',
							['itc-symbol']	=	'ns0000:ITC_Symbol',
							['itc-zapfchancery-mediumitalic']	=	'ns0000:ITC_ZapfChancery_MediumItalic',
							['itc-zapfdingbats']	=	'ns0000:ITC_ZapfDingbats',
							['joanna']	=	'ns0000:Joanna',
							['joanna-bold']	=	'ns0000:Joanna_Bold',
							['joanna-bold-italic']	=	'ns0000:Joanna_Bold_Italic',
							['joanna-italic']	=	'ns0000:Joanna_Italic',
							['lettergothic']	=	'ns0000:LetterGothic',
							['lettergothic-bold']	=	'ns0000:LetterGothic_Bold',
							['lettergothic-bold-slanted']	=	'ns0000:LetterGothic_Bold_Slanted',
							['lettergothic-slanted']	=	'ns0000:LetterGothic_Slanted',
							['lettergothic-italic']	=	'ns0000:LetterGothic_Italic',
							['marigold']	=	'ns0000:Marigold',
							['monaco']	=	'ns0000:Monaco',
							['new-century-schoolbook-bold']	=	'ns0000:New_Century_Schoolbook_Bold',
							['new-century-schoolbook-bold-italic']	=	'ns0000:New_Century_Schoolbook_Bold_Italic',
							['new-century-schoolbook-italic']	=	'ns0000:New_Century_Schoolbook_Italic',
							['new-century-schoolbook-roman']	=	'ns0000:New_Century_Schoolbook_Roman',
							['newyork']	=	'ns0000:NewYork',
							['optima']	=	'ns0000:Optima',
							['optima-bold']	=	'ns0000:Optima_Bold',
							['optima-bold-italic']	=	'ns0000:Optima_Bold_Italic',
							['optima-italic']	=	'ns0000:Optima_Italic',
							['oxford']	=	'ns0000:Oxford',
							['palatino-bold']	=	'ns0000:Palatino_Bold',
							['palatino-bold-italic']	=	'ns0000:Palatino_Bold_Italic',
							['palatino-italic']	=	'ns0000:Palatino_Italic',
							['palatino-roman']	=	'ns0000:Palatino_Roman',
							['stempel-garamond-bold']	=	'ns0000:Stempel_Garamond_Bold',
							['stempel-garamond-bold-italic']	=	'ns0000:Stempel_Garamond_Bold_Italic',
							['stempel-garamond-italic']	=	'ns0000:Stempel_Garamond_Italic',
							['stempel-garamond-roman']	=	'ns0000:Stempel_Garamond_Roman',
							['symbol']	=	'ns0000:Symbol',
							['symbolps']	=	'ns0000:SymbolPS',
							['tekton']	=	'ns0000:Tekton',
							['times-bold']	=	'ns0000:Times_Bold',
							['times-bold-italic']	=	'ns0000:Times_Bold_Italic',
							['times-italic']	=	'ns0000:Times_Italic',
							['times-new-roman']	=	'ns0000:Times_New_Roman',
							['times-new-roman-bold']	=	'ns0000:Times_New_Roman_Bold',
							['times-new-roman-bold-italic']	=	'ns0000:Times_New_Roman_Bold_Italic',
							['times-new-roman-italic']	=	'ns0000:Times_New_Roman_Italic',
							['times-roman']	=	'ns0000:Times_Roman',
							['univers']	=	'ns0000:Univers',
							['univers-bold']	=	'ns0000:Univers_Bold',
							['univers-bold-oblique']	=	'ns0000:Univers_Bold_Oblique',
							['univers-bold-condensed']	=	'ns0000:Univers_Bold_Condensed',
							['univers-bold-condensed-italic']	=	'ns0000:Univers_Bold_Condensed_Italic',
							['univers-bold-italic']	=	'ns0000:Univers_Bold_Italic',
							['univers-medium']	=	'ns0000:Univers_Medium',
							['univers-medium-condensed']	=	'ns0000:Univers_Medium_Condensed',
							['univers-medium-condensed-italic']	=	'ns0000:Univers_Medium_Condensed_Italic',
							['univers-medium-italic']	=	'ns0000:Univers_Medium_Italic',
							['univers-light']	=	'ns0000:Univers_Oblique',
							['univers-light-oblique']	=	'ns0000:Univers_Light',
							['univers-oblique']	=	'ns0000:Univers_Light_Oblique',
							['universcondensed']	=	'ns0000:UniversCondensed',
							['universcondensed-bold']	=	'ns0000:UniversCondensed_Bold',
							['universcondensed-bold-oblique']	=	'ns0000:UniversCondensed_Bold_Oblique',
							['universcondensed-oblique']	=	'ns0000:UniversCondensed_Oblique',
							['universesextended']	=	'ns0000:UniversesExtended',
							['universesextended-bold']	=	'ns0000:UniversesExtended_Bold',
							['universesextended-bold-oblique']	=	'ns0000:UniversesExtended_Bold_Oblique',
							['universesextended-oblique']	=	'ns0000:UniversesExtended_Oblique',
							['wingdings']	=	'ns0000:Wingdings',
							['heiseikakugo-w5-unijis-utf8-h']	=	'ns0000:HeiseiKakuGo_W5',
							['heiseimin-w3-unijis-utf8-h']	=	'ns0000:HeiseiMin_W3',
							['ryumin-light-unijis-utf8-h']	=	'ns0000:Ryumin_Light',
							['gothicbbb-medium-unijis-utf8-h']	=	'ns0000:GothicBBB_Medium',
							['hgheiseikakugo-w5-unijis-utf8-h']	=	'ns0000:HGHeiseiKakuGo_W5',
							['hgheiseimin-w3-unijis-utf8-h']	=	'ns0000:HGHeiseiMin_W3',
							['nimbussans-bold']	=	'ns0000:NimbusSans_Bold',
							['nimbusmonops-bold']	=	'ns0000:NimbusMonoPS_Bold',
							['nimbusroman-bold']	=	'ns0000:NimbusRoman_Bold',
						}
				
				local font_val = font_element_table[tbl['cc_preventioncopypattern_font']]
				if(nil == font_val)then
					font_val = 'ns0000:Arial'
				end
				
				table.insert(preventiontext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionTextFont'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	font_val
							}
						}
					}
				)
			end
			
			if(nil ~= tbl['cc_preventioncopypattern_font_irips'])then
				local font_element_table	=
						{
							['nimbussans-bold']	=	'ns0000:NimbusSans_Bold',
							['nimbusmonops-bold']	=	'ns0000:NimbusMonoPS_Bold',
							['nimbusroman-bold']	=	'ns0000:NimbusRoman_Bold',
							['hgheiseimin-w3-unijis-utf8-h']	=	'ns0000:HGHeiseiMin_W3',
							['hgheiseikakugo-w5-unijis-utf8-h']	=	'ns0000:HGHeiseiKakuGo_W5',
						}
				
				local font_val = font_element_table[tbl['cc_preventioncopypattern_font_irips']]
				if(nil == font_val)then
					font_val = 'ns0000:NimbusSans_Bold'
				end
				
				table.insert(preventiontext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionTextFontIrips'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	font_val
							}
						}
					}
				)
			end
			
			-- TextPosition
			if(nil ~= tbl['cc_preventioncopypattern_position'])then
				local position_element_table	=
						{
							['center']			=	'ns0000:Center',
							['topleft']			=	'ns0000:TopLeft',
							['centertop']		=	'ns0000:TopCenter',
							['topright']		=	'ns0000:TopRight',
							['bottomleft']		=	'ns0000:BottomLeft',
							['centerbottom']	=	'ns0000:BottomCenter',
							['bottomright']		=	'ns0000:BottomRight',
						}
				
				local position_val = position_element_table[tbl['cc_preventioncopypattern_position']]
				if(nil == position_val)then
					position_val = 'ns0000:Center'
				end
				
				if('center' == tbl['cc_preventioncopypattern_position'] and nil ~= tbl['cc_preventioncopypattern_angle'])then
					table.insert(preventiontext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	position_val
								},
								children	=
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'ns0000:CopyPreventionTextAngle'
										},
										children =
										{
											tag			= 	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
											text		=	tbl['cc_preventioncopypattern_angle']
										}
								}
							}
						}
					)
				else
					table.insert(preventiontext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	position_val
								}
							}
						}
					)
				end
			end
			-- TextType
			if(nil ~= tbl['cc_preventioncopypattern_texttype'])then
				local texttype_element_table	=
						{
							['userdefined']								=	'ns0000:UserDefined',
							['loginname']								=	'ns0000:WindowsLoginName',
							['printjobname']							=	'ns0000:PrintJobName',
							['printjobtime']							=	'ns0000:PrintJobTime',
							['loginnameandprintjobname']				=	'ns0000:WindowsLoginName_PrintJobName',
							['loginnameandprintjobtime']				=	'ns0000:WindowsLoginName_PrintJobTime',
							['printjobnameandprintjobtime']				=	'ns0000:PrintJobName_PrintJobTime',
							['loginnameandprintjobnameandprintjobtime']	=	'ns0000:WindowsLoginName_PrintJobName_PrintJobTime',
						}
				
				local texttype_val = texttype_element_table[tbl['cc_preventioncopypattern_texttype']]
				if(nil == texttype_val)then
					texttype_val = 'ns0000:UserDefined'
				end
				
				table.insert(preventiontext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionTextType'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	texttype_val
							}
						}
					}
				)
			end
			
			-- RepeatText
			if(nil ~= tbl['cc_preventioncopypattern_repeat'])then
				local repeat_element_table	=
						{
							['off']								=	'ns0000:Off',
							['repeat']							=	'ns0000:Repeat',
							['repeatandrotatecarriagereturn']	=	'ns0000:RepeatAndRotate',
						}
				
				local repeat_val = repeat_element_table[tbl['cc_preventioncopypattern_repeat']]
				if(nil == repeat_val)then
					repeat_val = 'ns0000:Off'
				end
				
				if('off' ~= tbl['cc_preventioncopypattern_repeat'] and nil ~= tbl['cc_preventioncopypattern_linespace'])then
					table.insert(preventiontext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionRepeatedText'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	repeat_val
								},
								children	=
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'ns0000:CopyPreventionLineSpace'
										},
										children =
										{
											tag			= 	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
											text		=	tbl['cc_preventioncopypattern_linespace']
										}
								}
							}
						}
					)
				else
					table.insert(preventiontext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionRepeatedText'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	repeat_val
								}
							}
						}
					)
				end
			end
			
			
			table.insert(result_table, {
					tag			= 	'psf:Feature',
					attribute	=
					{
						key		=	'name',
						value	=	'ns0000:CopyPreventionText'
					},
					children	=	preventiontext_table
				}
			)
			
			-- MaskType
			if(nil ~= tbl['cc_preventioncopypattern_masktype'])then
				local masktype_element_table	=
					{
						['none']				=	'ns0000:None',
						['wavecrest']			=	'ns0000:WaveCrest',
						['mesh']				=	'ns0000:Mesh',
						['lattice1']			=	'ns0000:Lattice1',
						['lattice2']			=	'ns0000:Lattice2',
						['interlockingcircles']	=	'ns0000:InterlockingCircles',
						['shokkoh']				=	'ns0000:Shokkoh',
						['matsukawabishi']		=	'ns0000:Matsukawabishi',
						['scale']				=	'ns0000:Scale',
						['higaki']				=	'ns0000:Higaki',
						['hexagonal']			=	'ns0000:Hexagonal',
					}
				local masktype_val = masktype_element_table[tbl['cc_preventioncopypattern_masktype']]
				if(nil == masktype_val)then
					masktype_val = 'ns0000:None'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionMaskType'
						},
						children =
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	masktype_val
							}
						}
					}
				)
			end
			
			-- Pattern Effects
			if(nil ~= tbl['cc_preventioncopypattern_patterneffects'])then
				local patterneffects_element_table	=
					{
						['normal']								=	'ns0000:Normal',
						['reversepatterns']						=	'ns0000:ReversePatterns',
						['reversepatternsandbackgroundonly']	=	'ns0000:ReverseAndBackgroundOnly',
						['textonly']							=	'ns0000:TextOnly',
					}
				local patterneffects_val = patterneffects_element_table[tbl['cc_preventioncopypattern_patterneffects']]
				if(nil == patterneffects_val)then
					patterneffects_val = 'ns0000:Normal'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionPatternEffects'
						},
						children =
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	patterneffects_val
							}
						}
					}
				)
			end
			
			-- Color
			if(nil ~= tbl['cc_preventioncopypattern_color'])then
				local color_element_table	=
					{
							['black']	=	'ns0000:Black',
							['cyan']	=	'ns0000:Cyan',
							['magenta']	=	'ns0000:Magenta',
					}
				local color_val = color_element_table[tbl['cc_preventioncopypattern_color']]
				if(nil == color_val)then
					color_val = 'ns0000:Black'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionColor'
						},
						children	=
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	color_val
							}
						}
					}
				)
			end
			
			-- Density
			if(nil ~= tbl['cc_preventioncopypattern_density'])then
				local density_element_table	=
					{
							['verylight']	=	'ns0000:VeryLight',
							['light']		=	'ns0000:Light',
							['middle']		=	'ns0000:Middle',
							['dark']		=	'ns0000:Dark',
							['verydark']	=	'ns0000:VeryDark',
					}
				local density_val = density_element_table[tbl['cc_preventioncopypattern_density']]
				if(nil == density_val)then
					density_val = 'ns0000:Middle'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionDensity'
						},
						children	=
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	density_val
							}
						}
					}
				)
			end
			
			return result_table
		end
	},
	-- 02-02 Copy Guard (Printer)
	cc_copyguard_text	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobCopyGuard'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local copyguardtext_table = {}
			local copyguardtext_scored_table = {}
			
			-- CopyGuardText
			if(nil ~= tbl['cc_copyguard_text'])then
				table.insert(copyguardtext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyGuardTextString'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['cc_copyguard_text']
								}
							}
					}
				)
			end
			
			-- FontSize
			if(nil ~= tbl['cc_copyguard_size'])then
				table.insert(copyguardtext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyGuardFontSize'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tbl['cc_copyguard_size']
								}
							}
					}
				)
			end
			
			table.insert(copyguardtext_table,
				{
					tag			=	'psf:Option',
					children	=	copyguardtext_scored_table
				}
			)
			
			-- Font
			if(nil ~= tbl['cc_copyguard_font'])then
				local font_element_table	=
						{
							['albertus-medium']	=	'ns0000:Albertus_Medium',
							['albertus-extra-bold']	=	'ns0000:Albertus_Extra_Bold',
							['antiqueolive']	=	'ns0000:AntiqueOlive',
							['albertus']	=	'ns0000:Albertus',
							['albertus-italic']	=	'ns0000:Albertus_Italic',
							['albertus-light']	=	'ns0000:Albertus_Light',
							['antiqueolive-bold']	=	'ns0000:AntiqueOlive_Bold',
							['antiqueolive-compact']	=	'ns0000:AntiqueOlive_Compact',
							['antiqueolive-italic']	=	'ns0000:AntiqueOlive_Italic',
							['antiqueolive-roman']	=	'ns0000:AntiqueOlive_Roman',
							['apple-chancery']	=	'ns0000:Apple_Chancery',
							['arial']	=	'ns0000:Arial',
							['arial-bold']	=	'ns0000:Arial_Bold',
							['arial-bold-italic']	=	'ns0000:Arial_Bold_Italic',
							['arial-italic']	=	'ns0000:Arial_Italic',
							['bodoni']	=	'ns0000:Bodoni',
							['bodoni-bold']	=	'ns0000:Bodoni_Bold',
							['bodoni-bold-italic']	=	'ns0000:Bodoni_Bold_Italic',
							['bodoni-italic']	=	'ns0000:Bodoni_Italic',
							['bodoni-poster']	=	'ns0000:Bodoni_Poster',
							['bodoni-poster-compressed']	=	'ns0000:Bodoni_Poster_Compressed',
							['carta']	=	'ns0000:Carta',
							['cg-omega']	=	'ns0000:CG_Omega',
							['cg-omega-bold']	=	'ns0000:CG_Omega_Bold',
							['cg-omega-bold-italic']	=	'ns0000:CG_Omega_Bold_Italic',
							['cg-omega-italic']	=	'ns0000:CG_Omega_Italic',
							['cg-times']	=	'ns0000:CG_Times',
							['cg-times-bold']	=	'ns0000:CG_Times_Bold',
							['cg-times-bold-italic']	=	'ns0000:CG_Times_Bold_Italic',
							['cg-times-italic']	=	'ns0000:CG_Times_Italic',
							['chicago']	=	'ns0000:Chicago',
							['clarendon']	=	'ns0000:Clarendon',
							['clarendon-bold']	=	'ns0000:Clarendon_Bold',
							['clarendon-light']	=	'ns0000:Clarendon_Light',
							['clarendon-condensed']	=	'ns0000:Clarendon_Condensed',
							['cooperblack']	=	'ns0000:CooperBlack',
							['cooperblack-italic']	=	'ns0000:CooperBlack_Italic',
							['copperplate-gothic-32bc']	=	'ns0000:Copperplate_Gothic_33BC',
							['copperplate-gothic-33bc']	=	'ns0000:Copperplate_Gothic_32BC',
							['coronet']	=	'ns0000:Coronet',
							['courier']	=	'ns0000:Courier',
							['courier-bold']	=	'ns0000:Courier_Bold',
							['courier-bold-oblique']	=	'ns0000:Courier_Bold_Oblique',
							['courier-bold-italic']	=	'ns0000:Courier_Bold_Italic',
							['courier-italic']	=	'ns0000:Courier_Italic',
							['courier-oblique']	=	'ns0000:Courier_Oblique',
							['courierps']	=	'ns0000:CourierPS',
							['courierps-bold']	=	'ns0000:CourierPS_Bold',
							['courierps-bold-oblique']	=	'ns0000:CourierPS_Bold_Oblique',
							['courierps-oblique']	=	'ns0000:CourierPS_Oblique',
							['eurostile']	=	'ns0000:Eurostile',
							['eurostile-bold']	=	'ns0000:Eurostile_Bold',
							['eurostile-bold-extended-two']	=	'ns0000:Eurostile_Bold_Extended_Two',
							['eurostile-extended-two']	=	'ns0000:Eurostile_Extended_Two',
							['garamond-antiqua']	=	'ns0000:Garamond_Antiqua',
							['garamond-halbfett']	=	'ns0000:Garamond_Halbfett',
							['garamond-kursiv']	=	'ns0000:Garamond_Kursiv',
							['garamond-kursiv-halbfett']	=	'ns0000:Garamond_Kursiv_Halbfett',
							['geneva']	=	'ns0000:Geneva',
							['gillsans']	=	'ns0000:GillSans',
							['gillsans-bold']	=	'ns0000:GillSans_Bold',
							['gillsans-bold-italic']	=	'ns0000:GillSans_Bold_Italic',
							['gillsans-condensed']	=	'ns0000:GillSans_Condensed',
							['gillsans-condensed-bold']	=	'ns0000:GillSans_Condensed_Bold',
							['gillsans-extra-bold']	=	'ns0000:GillSans_Extra_Bold',
							['gillsans-italic']	=	'ns0000:GillSans_Italic',
							['gillsans-light']	=	'ns0000:GillSans_Light',
							['gillsans-light-italic']	=	'ns0000:GillSans_Light_Italic',
							['goudy-bold']	=	'ns0000:Goudy_Bold',
							['goudy-bold-italic']	=	'ns0000:Goudy_Bold_Italic',
							['goudy-extrabold']	=	'ns0000:Goudy_ExtraBold',
							['goudy-oldstyle']	=	'ns0000:Goudy_Oldstyle',
							['goudy-oldstyle-italic']	=	'ns0000:Goudy_Oldstyle_Italic',
							['helvetica']	=	'ns0000:Helvetica',
							['helvetica-bold']	=	'ns0000:Helvetica_Bold',
							['helvetica-bold-oblique']	=	'ns0000:Helvetica_Bold_Oblique',
							['helvetica-condensed']	=	'ns0000:Helvetica_Condensed',
							['helvetica-condensed-bold']	=	'ns0000:Helvetica_Condensed_Bold',
							['helvetica-condensed-bold-oblique']	=	'ns0000:Helvetica_Condensed_Bold_Oblique',
							['helvetica-condensed-oblique']	=	'ns0000:Helvetica_Condensed_Oblique',
							['helvetica-narrow']	=	'ns0000:Helvetica_Narrow',
							['helvetica-narrow-bold']	=	'ns0000:Helvetica_Narrow_Bold',
							['helvetica-narrow-bold-oblique']	=	'ns0000:Helvetica_Narrow_Bold_Oblique',
							['helvetica-narrow-oblique']	=	'ns0000:Helvetica_Narrow_Oblique',
							['helvetica-oblique']	=	'ns0000:Helvetica_Oblique',
							['hoeflertext']	=	'ns0000:HoeflerText',
							['hoeflertext-black']	=	'ns0000:HoeflerText_Black',
							['hoeflertext-black-italic']	=	'ns0000:HoeflerText_Black_Italic',
							['hoeflertext-italic']	=	'ns0000:HoeflerText_Italic',
							['hoeflertext-ornaments']	=	'ns0000:HoeflerText_Ornaments',
							['itc-avantgarde-gothic-book']	=	'ns0000:ITC_AvantGarde_Gothic_Book',
							['itc-avantgarde-gothic-book-oblique']	=	'ns0000:ITC_AvantGarde_Gothic_Book_Oblique',
							['itc-avantgarde-gothic-demi']	=	'ns0000:ITC_AvantGarde_Gothic_Demi',
							['itc-avantgarde-gothic-demi-oblique']	=	'ns0000:ITC_AvantGarde_Gothic_Demi_Oblique',
							['itc-bookman-demi']	=	'ns0000:ITC_Bookman_Demi',
							['itc-bookman-demi-italic']	=	'ns0000:ITC_Bookman_Demi_Italic',
							['itc-bookman-light']	=	'ns0000:ITC_Bookman_Light',
							['itc-bookman-light-italic']	=	'ns0000:ITC_Bookman_Light_Italic',
							['itc-lubalin-graph-book']	=	'ns0000:ITC_Lubalin_Graph_Book',
							['itc-lubalin-graph-book-oblique']	=	'ns0000:ITC_Lubalin_Graph_Book_Oblique',
							['itc-lubalin-graph-demi']	=	'ns0000:ITC_Lubalin_Graph_Demi',
							['itc-lubalin-graph-demi-oblique']	=	'ns0000:ITC_Lubalin_Graph_Demi_Oblique',
							['itc-mona-lisa-recut']	=	'ns0000:ITC_Mona_Lisa_Recut',
							['itc-symbol']	=	'ns0000:ITC_Symbol',
							['itc-zapfchancery-mediumitalic']	=	'ns0000:ITC_ZapfChancery_MediumItalic',
							['itc-zapfdingbats']	=	'ns0000:ITC_ZapfDingbats',
							['joanna']	=	'ns0000:Joanna',
							['joanna-bold']	=	'ns0000:Joanna_Bold',
							['joanna-bold-italic']	=	'ns0000:Joanna_Bold_Italic',
							['joanna-italic']	=	'ns0000:Joanna_Italic',
							['lettergothic']	=	'ns0000:LetterGothic',
							['lettergothic-bold']	=	'ns0000:LetterGothic_Bold',
							['lettergothic-bold-slanted']	=	'ns0000:LetterGothic_Bold_Slanted',
							['lettergothic-slanted']	=	'ns0000:LetterGothic_Slanted',
							['lettergothic-italic']	=	'ns0000:LetterGothic_Italic',
							['marigold']	=	'ns0000:Marigold',
							['monaco']	=	'ns0000:Monaco',
							['new-century-schoolbook-bold']	=	'ns0000:New_Century_Schoolbook_Bold',
							['new-century-schoolbook-bold-italic']	=	'ns0000:New_Century_Schoolbook_Bold_Italic',
							['new-century-schoolbook-italic']	=	'ns0000:New_Century_Schoolbook_Italic',
							['new-century-schoolbook-roman']	=	'ns0000:New_Century_Schoolbook_Roman',
							['newyork']	=	'ns0000:NewYork',
							['optima']	=	'ns0000:Optima',
							['optima-bold']	=	'ns0000:Optima_Bold',
							['optima-bold-italic']	=	'ns0000:Optima_Bold_Italic',
							['optima-italic']	=	'ns0000:Optima_Italic',
							['oxford']	=	'ns0000:Oxford',
							['palatino-bold']	=	'ns0000:Palatino_Bold',
							['palatino-bold-italic']	=	'ns0000:Palatino_Bold_Italic',
							['palatino-italic']	=	'ns0000:Palatino_Italic',
							['palatino-roman']	=	'ns0000:Palatino_Roman',
							['stempel-garamond-bold']	=	'ns0000:Stempel_Garamond_Bold',
							['stempel-garamond-bold-italic']	=	'ns0000:Stempel_Garamond_Bold_Italic',
							['stempel-garamond-italic']	=	'ns0000:Stempel_Garamond_Italic',
							['stempel-garamond-roman']	=	'ns0000:Stempel_Garamond_Roman',
							['symbol']	=	'ns0000:Symbol',
							['symbolps']	=	'ns0000:SymbolPS',
							['tekton']	=	'ns0000:Tekton',
							['times-bold']	=	'ns0000:Times_Bold',
							['times-bold-italic']	=	'ns0000:Times_Bold_Italic',
							['times-italic']	=	'ns0000:Times_Italic',
							['times-new-roman']	=	'ns0000:Times_New_Roman',
							['times-new-roman-bold']	=	'ns0000:Times_New_Roman_Bold',
							['times-new-roman-bold-italic']	=	'ns0000:Times_New_Roman_Bold_Italic',
							['times-new-roman-italic']	=	'ns0000:Times_New_Roman_Italic',
							['times-roman']	=	'ns0000:Times_Roman',
							['univers']	=	'ns0000:Univers',
							['univers-bold']	=	'ns0000:Univers_Bold',
							['univers-bold-oblique']	=	'ns0000:Univers_Bold_Oblique',
							['univers-bold-condensed']	=	'ns0000:Univers_Bold_Condensed',
							['univers-bold-condensed-italic']	=	'ns0000:Univers_Bold_Condensed_Italic',
							['univers-bold-italic']	=	'ns0000:Univers_Bold_Italic',
							['univers-medium']	=	'ns0000:Univers_Medium',
							['univers-medium-condensed']	=	'ns0000:Univers_Medium_Condensed',
							['univers-medium-condensed-italic']	=	'ns0000:Univers_Medium_Condensed_Italic',
							['univers-medium-italic']	=	'ns0000:Univers_Medium_Italic',
							['univers-light']	=	'ns0000:Univers_Oblique',
							['univers-light-oblique']	=	'ns0000:Univers_Light',
							['univers-oblique']	=	'ns0000:Univers_Light_Oblique',
							['universcondensed']	=	'ns0000:UniversCondensed',
							['universcondensed-bold']	=	'ns0000:UniversCondensed_Bold',
							['universcondensed-bold-oblique']	=	'ns0000:UniversCondensed_Bold_Oblique',
							['universcondensed-oblique']	=	'ns0000:UniversCondensed_Oblique',
							['universesextended']	=	'ns0000:UniversesExtended',
							['universesextended-bold']	=	'ns0000:UniversesExtended_Bold',
							['universesextended-bold-oblique']	=	'ns0000:UniversesExtended_Bold_Oblique',
							['universesextended-oblique']	=	'ns0000:UniversesExtended_Oblique',
							['wingdings']	=	'ns0000:Wingdings',
							['heiseikakugo-w5-unijis-utf8-h']	=	'ns0000:HeiseiKakuGo_W5',
							['heiseimin-w3-unijis-utf8-h']	=	'ns0000:HeiseiMin_W3',
							['ryumin-light-unijis-utf8-h']	=	'ns0000:Ryumin_Light',
							['gothicbbb-medium-unijis-utf8-h']	=	'ns0000:GothicBBB_Medium',
							['hgheiseikakugo-w5-unijis-utf8-h']	=	'ns0000:HGHeiseiKakuGo_W5',
							['hgheiseimin-w3-unijis-utf8-h']	=	'ns0000:HGHeiseiMin_W3',
							['nimbussans-bold']	=	'ns0000:NimbusSans_Bold',
							['nimbusmonops-bold']	=	'ns0000:NimbusMonoPS_Bold',
							['nimbusroman-bold']	=	'ns0000:NimbusRoman_Bold',
						}
				
				local font_val = font_element_table[tbl['cc_copyguard_font']]
				if(nil == font_val)then
					font_val = 'ns0000:Arial'
				end
				
				table.insert(copyguardtext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyGuardTextFont'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	font_val
							}
						}
					}
				)
			end
			
			if(nil ~= tbl['cc_copyguard_font_irips'])then
				local font_element_table	=
						{
							['nimbussans-bold']	=	'ns0000:NimbusSans_Bold',
							['nimbusmonops-bold']	=	'ns0000:NimbusMonoPS_Bold',
							['nimbusroman-bold']	=	'ns0000:NimbusRoman_Bold',
							['hgheiseimin-w3-unijis-utf8-h']	=	'ns0000:HGHeiseiMin_W3',
							['hgheiseikakugo-w5-unijis-utf8-h']	=	'ns0000:HGHeiseiKakuGo_W5',
						}
				
				local font_val = font_element_table[tbl['cc_copyguard_font_irips']]
				if(nil == font_val)then
					font_val = 'ns0000:NimbusSans_Bold'
				end
				
				table.insert(copyguardtext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyGuardTextFontIrips'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	font_val
							}
						}
					}
				)
			end
			
			-- TextPosition
			if(nil ~= tbl['cc_copyguard_position'])then
				local position_element_table	=
						{
							['center']			=	'ns0000:Center',
							['topleft']			=	'ns0000:TopLeft',
							['centertop']		=	'ns0000:TopCenter',
							['topright']		=	'ns0000:TopRight',
							['bottomleft']		=	'ns0000:BottomLeft',
							['centerbottom']	=	'ns0000:BottomCenter',
							['bottomright']		=	'ns0000:BottomRight',
						}
				
				local position_val = position_element_table[tbl['cc_copyguard_position']]
				if(nil == position_val)then
					position_val = 'ns0000:Center'
				end
				
				if('center' == tbl['cc_copyguard_position'] and nil ~= tbl['cc_copyguard_angle'])then
					table.insert(copyguardtext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyGuardTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	position_val
								},
								children	=
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'ns0000:CopyGuardTextAngle'
										},
										children =
										{
											tag			= 	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
											text		=	tbl['cc_copyguard_angle']
										}
								}
							}
						}
					)
				else
					table.insert(copyguardtext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyGuardTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	position_val
								}
							}
						}
					)
				end
			end
			
			-- TextType
			if(nil ~= tbl['cc_copyguard_texttype'])then
				local texttype_element_table	=
						{
							['userdefined']								=	'ns0000:UserDefined',
							['loginname']								=	'ns0000:WindowsLoginName',
							['printjobname']							=	'ns0000:PrintJobName',
							['printjobtime']							=	'ns0000:PrintJobTime',
							['loginnameandprintjobname']				=	'ns0000:WindowsLoginName_PrintJobName',
							['loginnameandprintjobtime']				=	'ns0000:WindowsLoginName_PrintJobTime',
							['printjobnameandprintjobtime']				=	'ns0000:PrintJobName_PrintJobTime',
							['loginnameandprintjobnameandprintjobtime']	=	'ns0000:WindowsLoginName_PrintJobName_PrintJobTime',
						}
				
				local texttype_val = texttype_element_table[tbl['cc_copyguard_texttype']]
				if(nil == texttype_val)then
					texttype_val = 'ns0000:UserDefined'
				end
				
				table.insert(copyguardtext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyGuardTextType'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	texttype_val
							}
						}
					}
				)
			end
			
			-- RepeatText
			if(nil ~= tbl['cc_copyguard_repeat'])then
				local repeat_element_table	=
						{
							['off']								=	'ns0000:Off',
							['repeat']							=	'ns0000:Repeat',
							['repeatandrotatecarriagereturn']	=	'ns0000:RepeatAndRotate',
						}
				
				local repeat_val = repeat_element_table[tbl['cc_copyguard_repeat']]
				if(nil == repeat_val)then
					repeat_val = 'ns0000:Off'
				end
				
				if('off' ~= tbl['cc_copyguard_repeat'] and nil ~= tbl['cc_copyguard_linespace'])then
					table.insert(copyguardtext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyGuardRepeatedText'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	repeat_val
								},
								children	=
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'ns0000:CopyGuardLineSpace'
										},
										children =
										{
											tag			= 	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
											text		=	tbl['cc_copyguard_linespace']
										}
								}
							}
						}
					)
				else
					table.insert(copyguardtext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyGuardRepeatedText'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	repeat_val
								}
							}
						}
					)
				end
			end
			
			table.insert(result_table, {
					tag			= 	'psf:Feature',
					attribute	=
					{
						key		=	'name',
						value	=	'ns0000:CopyGuardText'
					},
					children	=	copyguardtext_table
				}
			)
			
			-- Pattern Effects
			if(nil ~= tbl['cc_copyguard_patterneffects'])then
				local patterneffects_element_table	=
					{
						['normal']			=	'ns0000:Normal',
						['backgroundonly']	=	'ns0000:BackgroundOnly'
					}
				local patterneffects_val = patterneffects_element_table[tbl['cc_copyguard_patterneffects']]
				if(nil == patterneffects_val)then
					patterneffects_val = 'ns0000:Normal'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyGuardPatternEffects'
						},
						children =
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	patterneffects_val
							}
						}
					}
				)
			end
			
			return result_table
		end
	},
	
	-- 02 Copy Control Print (Driver)
	pdcc_print	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageCopyControlPrint'
		},
		children	=	function(tbl)
				
				local result_table
				local copycontrol_val 
				if('off' == tbl['pdcc_print'])then
					copycontrol_val = 'ns0000:Off'
					
				elseif('on' == tbl['pdcc_print'] and nil ~= tbl['pdcc_type'])then
					local copycontrol_type_table	=
						{
							['preventioncopypattern']	=	'ns0000:CopyPreventionDataSecurity',
							['copyguard']				=	'ns0000:CopyGuard',
						}
					copycontrol_val = copycontrol_type_table[tbl['pdcc_type']]
				end
				
				if(nil == copycontrol_val)then
					copycontrol_val = 'ns0000:Off'
				end
				
				result_table =
					{
						tag			=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	copycontrol_val
						},
					}
				return result_table
			
			end
	},
	-- 02-01 Prevention Copy Pattern (Driver)
	pdcc_preventioncopypattern_text	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageCopyPrevention'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local preventiontext_table = {}
			local preventiontext_scored_table = {}
			
			-- CopyPreventionText
			if(nil ~= tbl['pdcc_preventioncopypattern_text'])then
				table.insert(preventiontext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyPreventionTextString'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['pdcc_preventioncopypattern_text']
								}
							}
					}
				)
			end
			
			-- Font
			if(nil ~= tbl['pdcc_preventioncopypattern_font'])then
				table.insert(preventiontext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyPreventionFont'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['pdcc_preventioncopypattern_font']
								}
							}
					}
				)
			end
			
			-- FontSize
			if(nil ~= tbl['pdcc_preventioncopypattern_size'])then
				table.insert(preventiontext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyPreventionFontSize'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tbl['pdcc_preventioncopypattern_size']
								}
							}
					}
				)
			end
			
			table.insert(preventiontext_table,
				{
					tag			=	'psf:Option',
					children	=	preventiontext_scored_table
				}
			)
			
			-- TextPosition
			if(nil ~= tbl['pdcc_preventioncopypattern_position'])then
				local position_element_table	=
						{
							['center']			=	'ns0000:Center',
							['topleft']			=	'ns0000:TopLeft',
							['centertop']		=	'ns0000:TopCenter',
							['topright']		=	'ns0000:TopRight',
							['bottomleft']		=	'ns0000:BottomLeft',
							['centerbottom']	=	'ns0000:BottomCenter',
							['bottomright']		=	'ns0000:BottomRight',
						}
				
				local position_val = position_element_table[tbl['pdcc_preventioncopypattern_position']]
				if(nil == position_val)then
					position_val = 'ns0000:Center'
				end
				
				if('center' == tbl['pdcc_preventioncopypattern_position'] and nil ~= tbl['pdcc_preventioncopypattern_angle'])then
					table.insert(preventiontext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	position_val
								},
								children	=
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'ns0000:CopyPreventionTextAngle'
										},
										children =
										{
											tag			= 	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
											text		=	tbl['pdcc_preventioncopypattern_angle']
										}
								}
							}
						}
					)
				else
					table.insert(preventiontext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	position_val
								}
							}
						}
					)
				end
			end
			
			-- FontStyle
			if(nil ~= tbl['pdcc_preventioncopypattern_fontstyle'])then
				local fontstyle_element_table	=
						{
							['regular']		=	'ns0000:Normal',
							['bold']		=	'ns0000:Bold',
							['italic']		=	'ns0000:Italic',
							['bolditalic']	=	'ns0000:BoldItalic',
						}
				
				local fontstyle_val = fontstyle_element_table[tbl['pdcc_preventioncopypattern_fontstyle']]
				if(nil == fontstyle_val)then
					fontstyle_val = 'ns0000:Normal'
				end
				
				table.insert(preventiontext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionTextFontStyle'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	fontstyle_val
							}
						}
					}
				)
			end
			
			-- TextType
			if(nil ~= tbl['pdcc_preventioncopypattern_texttype'])then
				local texttype_element_table	=
						{
							['userdefined']								=	'ns0000:UserDefined',
							['loginname']								=	'ns0000:WindowsLoginName',
							['printjobname']							=	'ns0000:PrintJobName',
							['printjobtime']							=	'ns0000:PrintJobTime',
							['loginnameandprintjobname']				=	'ns0000:WindowsLoginName_PrintJobName',
							['loginnameandprintjobtime']				=	'ns0000:WindowsLoginName_PrintJobTime',
							['printjobnameandprintjobtime']				=	'ns0000:PrintJobName_PrintJobTime',
							['loginnameandprintjobnameandprintjobtime']	=	'ns0000:WindowsLoginName_PrintJobName_PrintJobTime',
						}
				
				local texttype_val = texttype_element_table[tbl['pdcc_preventioncopypattern_texttype']]
				if(nil == texttype_val)then
					texttype_val = 'ns0000:UserDefined'
				end
				
				table.insert(preventiontext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionTextType'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	texttype_val
							}
						}
					}
				)
			end
			
			-- RepeatText
			if(nil ~= tbl['pdcc_preventioncopypattern_repeat'])then
				local repeat_element_table	=
						{
							['off']								=	'ns0000:Off',
							['repeat']							=	'ns0000:Repeat',
							['repeatandrotatecarriagereturn']	=	'ns0000:RepeatAndRotate',
						}
				
				local repeat_val = repeat_element_table[tbl['pdcc_preventioncopypattern_repeat']]
				if(nil == repeat_val)then
					repeat_val = 'ns0000:Off'
				end
				
				if('off' ~= tbl['pdcc_preventioncopypattern_repeat'] and nil ~= tbl['pdcc_preventioncopypattern_linespace'])then
					table.insert(preventiontext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionRepeatedText'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	repeat_val
								},
								children	=
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'ns0000:CopyPreventionLineSpace'
										},
										children =
										{
											tag			= 	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
											text		=	tbl['pdcc_preventioncopypattern_linespace']
										}
								}
							}
						}
					)
				else
					table.insert(preventiontext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionRepeatedText'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	repeat_val
								}
							}
						}
					)
				end
			end
			
			-- OutlineText
			if(nil ~= tbl['pdcc_preventioncopypattern_outline'])then
				local outline_element_table	=
						{
							['off']		=	'ns0000:Off',
							['on']		=	'ns0000:On',
						}
				
				local outline_val = outline_element_table[tbl['pdcc_preventioncopypattern_outline']]
				if(nil == outline_val)then
					outline_val = 'ns0000:Off'
				end
				
				table.insert(preventiontext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionTextOutline'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	outline_val
							}
						}
					}
				)
			end
			
			-- TextOnly
			if(nil ~= tbl['pdcc_preventioncopypattern_textonly'])then
				local textonly_element_table	=
						{
							['off']		=	'ns0000:Off',
							['on']		=	'ns0000:On',
						}
				
				local textonly_val = textonly_element_table[tbl['pdcc_preventioncopypattern_textonly']]
				if(nil == textonly_val)then
					textonly_val = 'ns0000:Off'
				end
				
				table.insert(preventiontext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionTextOnly'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	textonly_val
							}
						}
					}
				)
			end
			
			table.insert(result_table, {
					tag			= 	'psf:Feature',
					attribute	=
					{
						key		=	'name',
						value	=	'ns0000:CopyPreventionText'
					},
					children	=	preventiontext_table
				}
			)
			
			-- MaskType
			if(nil ~= tbl['pdcc_preventioncopypattern_masktype'])then
				local masktype_element_table	=
					{
						['none']				=	'ns0000:None',
						['wavecrest']			=	'ns0000:WaveCrest',
						['mesh']				=	'ns0000:Mesh',
						['lattice1']			=	'ns0000:Lattice1',
						['lattice2']			=	'ns0000:Lattice2',
						['interlockingcircles']	=	'ns0000:InterlockingCircles',
						['shokkoh']				=	'ns0000:Shokkoh',
						['matsukawabishi']		=	'ns0000:Matsukawabishi',
						['scale']				=	'ns0000:Scale',
						['higaki']				=	'ns0000:Higaki',
						['hexagonal']			=	'ns0000:Hexagonal',
					}
				local masktype_val = masktype_element_table[tbl['pdcc_preventioncopypattern_masktype']]
				if(nil == masktype_val)then
					masktype_val = 'ns0000:None'
				end
				
				local masktype_feature_table = {}
				table.insert(masktype_feature_table,
					{
						tag 		=	'psf:Option',
						attribute	=
						{
							key		=	'name',
							value	=	masktype_val
						}
					}
				)
				
				-- ReversePatterns
				if(nil ~= tbl['pdcc_preventioncopypattern_reversepatterns'])then
					local reversepattern_element_table	=
						{
							['off']	=	'ns0000:Off',
							['on']	=	'ns0000:On',
						}
					local reversepattern_val = reversepattern_element_table[tbl['pdcc_preventioncopypattern_reversepatterns']]
					if(nil == reversepattern_val)then
						reversepattern_val = 'ns0000:Off'
					end
					
					table.insert(masktype_feature_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionReversePatterns'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	reversepattern_val
								}
							}
						}
					)
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionMaskType'
						},
						children = masktype_feature_table
					}
				)
			end
			
			-- Clip
			if(nil ~= tbl['pdcc_preventioncopypattern_clip'])then
				local clip_element_table	=
					{
							['off']	=	'ns0000:Off',
							['on']	=	'ns0000:On'
					}
				local clip_val = clip_element_table[tbl['pdcc_preventioncopypattern_clip']]
				if(nil == clip_val)then
					clip_val = 'ns0000:Off'
				end
				
				local clip_property_table = {}
				
				if(nil ~= tbl['pdcc_preventioncopypattern_left'])then
					table.insert(clip_property_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:CopyPreventionClippingLeft'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tostring(tbl['pdcc_preventioncopypattern_left'] * 1000 )
									}
								}
						}
					)
				end
				
				if(nil ~= tbl['pdcc_preventioncopypattern_right'])then
					table.insert(clip_property_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:CopyPreventionClippingRight'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tostring(tbl['pdcc_preventioncopypattern_right'] * 1000 )
									}
								}
						}
					)
				end
				
				if(nil ~= tbl['pdcc_preventioncopypattern_top'])then
					table.insert(clip_property_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:CopyPreventionClippingTop'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tostring(tbl['pdcc_preventioncopypattern_top'] * 1000 )
									}
								}
						}
					)
				end
				
				if(nil ~= tbl['pdcc_preventioncopypattern_bottom'])then
					table.insert(clip_property_table,
						{
							tag			=	'psf:ScoredProperty',
							attribute	=
								{
									key		=	'name',
									value	=	'ns0000:CopyPreventionClippingBottom'
								},
							children	=	{
									{
										tag			= 	'psf:Value',
										attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
										text	=	tostring(tbl['pdcc_preventioncopypattern_bottom'] * 1000 )
									}
								}
						}
					)
				end
				
				if( 'ns0000:On' == clip_val and 0 ~= table.getn(clip_property_table) ) then
					table.insert(result_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionClipping'
							},
							children	=
							{
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	clip_val
								},
								children = clip_property_table
							}
						}
					)
				else
					table.insert(result_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyPreventionClipping'
							},
							children	=
							{
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	clip_val
								}
							}
						}
					)
				end
			end
			
			-- Color
			if(nil ~= tbl['pdcc_preventioncopypattern_color'])then
				local color_element_table	=
					{
							['black']	=	'ns0000:Black',
							['cyan']	=	'ns0000:Cyan',
							['magenta']	=	'ns0000:Magenta',
					}
				local color_val = color_element_table[tbl['pdcc_preventioncopypattern_color']]
				if(nil == color_val)then
					color_val = 'ns0000:Black'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionColor'
						},
						children	=
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	color_val
							}
						}
					}
				)
			end
			
			-- Density
			if(nil ~= tbl['pdcc_preventioncopypattern_density'])then
				local density_element_table	=
					{
							['verylight']	=	'ns0000:VeryLight',
							['light']		=	'ns0000:Light',
							['middle']		=	'ns0000:Middle',
							['dark']		=	'ns0000:Dark',
							['verydark']	=	'ns0000:VeryDark',
					}
				local density_val = density_element_table[tbl['pdcc_preventioncopypattern_density']]
				if(nil == density_val)then
					density_val = 'ns0000:Middle'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyPreventionDensity'
						},
						children	=
						{
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	density_val
							}
						}
					}
				)
			end
			
			return result_table
		end
	},
	-- 02-02 Copy Guard (Driver)
	pdcc_copyguard_text	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageCopyGuard'
		},
		children	=	function(tbl)
			local result_table = {}
			
			local copyguardtext_table = {}
			local copyguardtext_scored_table = {}
			
			-- CopyGuardText
			if(nil ~= tbl['pdcc_copyguard_text'])then
				table.insert(copyguardtext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyGuardTextString'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['pdcc_copyguard_text']
								}
							}
					}
				)
			end
			
			-- Font
			if(nil ~= tbl['pdcc_copyguard_font'])then
				table.insert(copyguardtext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyGuardFont'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:string'
										},
									text	=	tbl['pdcc_copyguard_font']
								}
							}
					}
				)
			end
			
			-- FontSize
			if(nil ~= tbl['pdcc_copyguard_size'])then
				table.insert(copyguardtext_scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:CopyGuardFontSize'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tbl['pdcc_copyguard_size']
								}
							}
					}
				)
			end
			
			table.insert(copyguardtext_table,
				{
					tag			=	'psf:Option',
					children	=	copyguardtext_scored_table
				}
			)
			
			-- TextPosition
			if(nil ~= tbl['pdcc_copyguard_position'])then
				local position_element_table	=
						{
							['center']			=	'ns0000:Center',
							['topleft']			=	'ns0000:TopLeft',
							['centertop']		=	'ns0000:TopCenter',
							['topright']		=	'ns0000:TopRight',
							['bottomleft']		=	'ns0000:BottomLeft',
							['centerbottom']	=	'ns0000:BottomCenter',
							['bottomright']		=	'ns0000:BottomRight',
						}
				
				local position_val = position_element_table[tbl['pdcc_copyguard_position']]
				if(nil == position_val)then
					position_val = 'ns0000:Center'
				end
				
				if('center' == tbl['pdcc_copyguard_position'] and nil ~= tbl['pdcc_copyguard_angle'])then
					table.insert(copyguardtext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyGuardTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	position_val
								},
								children	=
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'ns0000:CopyGuardTextAngle'
										},
										children =
										{
											tag			= 	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
											text		=	tbl['pdcc_copyguard_angle']
										}
								}
							}
						}
					)
				else
					table.insert(copyguardtext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyGuardTextPosition'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	position_val
								}
							}
						}
					)
				end
			end
			
			-- FontStyle
			if(nil ~= tbl['pdcc_copyguard_fontstyle'])then
				local fontstyle_element_table	=
						{
							['regular']		=	'ns0000:Normal',
							['bold']		=	'ns0000:Bold',
							['italic']		=	'ns0000:Italic',
							['bolditalic']	=	'ns0000:BoldItalic',
						}
				
				local fontstyle_val = fontstyle_element_table[tbl['pdcc_copyguard_fontstyle']]
				if(nil == fontstyle_val)then
					fontstyle_val = 'ns0000:Normal'
				end
				
				table.insert(copyguardtext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyGuardTextFontStyle'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	fontstyle_val
							}
						}
					}
				)
			end
			
			-- TextType
			if(nil ~= tbl['pdcc_copyguard_texttype'])then
				local texttype_element_table	=
						{
							['userdefined']								=	'ns0000:UserDefined',
							['loginname']								=	'ns0000:WindowsLoginName',
							['printjobname']							=	'ns0000:PrintJobName',
							['printjobtime']							=	'ns0000:PrintJobTime',
							['loginnameandprintjobname']				=	'ns0000:WindowsLoginName_PrintJobName',
							['loginnameandprintjobtime']				=	'ns0000:WindowsLoginName_PrintJobTime',
							['printjobnameandprintjobtime']				=	'ns0000:PrintJobName_PrintJobTime',
							['loginnameandprintjobnameandprintjobtime']	=	'ns0000:WindowsLoginName_PrintJobName_PrintJobTime',
						}
				
				local texttype_val = texttype_element_table[tbl['pdcc_copyguard_texttype']]
				if(nil == texttype_val)then
					texttype_val = 'ns0000:UserDefined'
				end
				
				table.insert(copyguardtext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyGuardTextType'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	texttype_val
							}
						}
					}
				)
			end
			
			-- RepeatText
			if(nil ~= tbl['pdcc_copyguard_repeat'])then
				local repeat_element_table	=
						{
							['off']								=	'ns0000:Off',
							['repeat']							=	'ns0000:Repeat',
							['repeatandrotatecarriagereturn']	=	'ns0000:RepeatAndRotate',
						}
				
				local repeat_val = repeat_element_table[tbl['pdcc_copyguard_repeat']]
				if(nil == repeat_val)then
					repeat_val = 'ns0000:Off'
				end
				
				if('off' ~= tbl['pdcc_copyguard_repeat'] and nil ~= tbl['pdcc_copyguard_linespace'])then
					table.insert(copyguardtext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyGuardRepeatedText'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	repeat_val
								},
								children	=
								{
									tag			= 	'psf:ScoredProperty',
									attribute	=
										{
											key		=	'name',
											value	=	'ns0000:CopyGuardLineSpace'
										},
										children =
										{
											tag			= 	'psf:Value',
											attribute	=
											{
												key		=	'xsi:type',
												value	=	'xsd:integer'
											},
											text		=	tbl['pdcc_copyguard_linespace']
										}
								}
							}
						}
					)
				else
					table.insert(copyguardtext_table,
						{
							tag 		= 	'psf:Feature',
							attribute	=
							{
								key 	=	'name',
								value 	= 	'ns0000:CopyGuardRepeatedText'
							},
							children = {
								tag 		=	'psf:Option',
								attribute	=
								{
									key		=	'name',
									value	=	repeat_val
								}
							}
						}
					)
				end
			end
			
			-- OutlineText
			if(nil ~= tbl['pdcc_copyguard_outline'])then
				local outline_element_table	=
						{
							['off']		=	'ns0000:Off',
							['on']		=	'ns0000:On',
						}
				
				local outline_val = outline_element_table[tbl['pdcc_copyguard_outline']]
				if(nil == outline_val)then
					outline_val = 'ns0000:Off'
				end
				
				table.insert(copyguardtext_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CopyGuardTextOutline'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	outline_val
							}
						}
					}
				)
			end
			
			table.insert(result_table, {
					tag			= 	'psf:Feature',
					attribute	=
					{
						key		=	'name',
						value	=	'ns0000:CopyGuardText'
					},
					children	=	copyguardtext_table
				}
			)
			
			return result_table
		end
	},
	-- 04 SecretNumbering
	secretnumbering	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobSecretNumbering'
		},
		children	=	function(tbl)
			local result_table = {}

			local secretnumbering_table	=
				{
					['off']	=	'ns0000:Off',
					['on']	=	'ns0000:On',
				}
			local secretnumbering_val = secretnumbering_table[tbl['secretnumbering']]
			if(nil == secretnumbering_val)then
				secretnumbering_val = 'ns0000:Off'
			end

			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key		=	'name',
						value	=	secretnumbering_val
					}
				}
			)

			local scored_table = {}
			-- secretnumbering_number
			if('on' == tbl['secretnumbering'] and nil ~= tbl['secretnumbering_number'])then
				table.insert(scored_table,
					{
						tag			=	'psf:ScoredProperty',
						attribute	=
							{
								key		=	'name',
								value	=	'ns0000:StartNumber'
							},
						children	=	{
								{
									tag			= 	'psf:Value',
									attribute	=
										{
											key		=	'xsi:type',
											value	=	'xsd:integer'
										},
									text	=	tbl['secretnumbering_number']
								}
							}
					}
				)
			end

			if(0 ~= table.getn(scored_table))then
				result_table[1]['children'] = scored_table
			end

			-- secretnumbering_size
			if(nil ~= tbl['secretnumbering_size'])then
				local secretnumbering_size_table	=
					{
						['small']	=	'ns0000:Small',
						['middle']	=	'ns0000:Middle',
						['large']	=	'ns0000:Large',
					}
				local secretnumbering_size_table_val = secretnumbering_size_table[tbl['secretnumbering_size']]
				if(nil == secretnumbering_size_table_val)then
					secretnumbering_size_table_val = 'ns0000:Middle'
				end

				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:SecretNumberingSize'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	secretnumbering_size_table_val
							}
						}
					}
				)
			end

			-- secretnumbering_density
			if(nil ~= tbl['secretnumbering_density'])then
				local secretnumbering_density_table	=
					{
						['light']		=	'ns0000:Light',
						['middle']		=	'ns0000:Middle',
						['littledark']	=	'ns0000:LittleDark',
						['dark']		=	'ns0000:Dark',
					}
				local secretnumbering_density_table_val = secretnumbering_density_table[tbl['secretnumbering_density']]
				if(nil == secretnumbering_density_table_val)then
					secretnumbering_density_table_val = 'ns0000:Middle'
				end

				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:SecretNumberingDensity'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	secretnumbering_density_table_val
							}
						}
					}
				)
			end

			-- secretnumbering_color
			if(nil ~= tbl['secretnumbering_color'])then
				local secretnumbering_color_table	=
					{
						['black']	=	'ns0000:Black',
						['red']		=	'ns0000:Red',
						['green']	=	'ns0000:Green',
						['blue']	=	'ns0000:Blue',
						['cyan']	=	'ns0000:Cyan',
						['magenta']	=	'ns0000:Magenta',
						['yellow']	=	'ns0000:Yellow',
					}
				local secretnumbering_color_table_val = secretnumbering_color_table[tbl['secretnumbering_color']]
				if(nil == secretnumbering_color_table_val)then
					secretnumbering_color_table_val = 'ns0000:Black'
				end

				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:SecretNumberingColor'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	secretnumbering_color_table_val
							}
						}
					}
				)
			end
			return result_table
		end
	},
-- [08 PrintQuality]
	-- 01 Color/Black and White
	colorbw	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:PageOutputColor'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=	function(tbl)
					if('on' == tbl['fixdmcolor'])then
						return 'psk:Color'
						
					elseif('blackandwhite' == tbl['colorbw'])then
						return 'psk:Monochrome'
					else
						--default
						return 'psk:Color'
					end
					
				end
			}
		}
	},
	-- 02 Print Quality Preset
	printqualitypreset	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrintQualityPreset'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					printqualitypreset	=
					{
						['genericdocument']	=	'ns0000:GenericDocument',
						['photographic']	=	'ns0000:Photographic',
						['dtp']				=	'ns0000:DTP',
						['pop']				=	'ns0000:POP',
						['cad']				=	'ns0000:CAD',
						['automatic']		=	'ns0000:Auto',
						['manual']			=	'ns0000:Manual'
					},
					default	=	{ 'item', 'ns0000:GenericDocument' }
				}
			}
		}
	},
	-- 02-01 Print Quality Adjustment
	printqualityadjustment	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrintQualityAdjustment'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					printqualityadjustment	=
					{
						['standard']	=	'ns0000:Standard',
						['advanced']	=	'ns0000:Advanced'
					},
					default	=	{ 'item', 'ns0000:Standard' }
				}
			}
		}
	},
	-- 03 Color Profile
	colorprofile_setting	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobColorProfileSelectObject'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					colorprofile_setting	=
					{
						['setallobject']	=	'ns0000:SetAllObject',
						['seteachobject']	=	'ns0000:SetEachObject'
					},
					default	=	{ 'item', 'ns0000:SetAllObject' }
				}
			}
		}
	},
	-- 03-01 Color Profile :: ALL(PS,PCL)
	colorprofile	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageColorProfile'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					colorprofile	=
					{
						['automatic']				=	'ns0000:Auto',
						['automaticbright']			=	'ns0000:AutomaticBright',
						['automaticdeep']			=	'ns0000:AutomaticDeep',
						['text']					=	'ns0000:Text',
						['textbright']				=	'ns0000:TextBright',
						['textdeep']				=	'ns0000:TextDeep',
						['photographic']			=	'ns0000:Photographic',
						['photographicbright']		=	'ns0000:PhotographicBright',
						['photographicdeep']		=	'ns0000:PhotographicDeep',
						['presentation']			=	'ns0000:Presentation',
						['presentationbright']		=	'ns0000:PresentationBright',
						['presentationdeep']		=	'ns0000:PresentationDeep',
						['cad']						=	'ns0000:AutoCADDocument',
						['solidcolor']				=	'ns0000:SolidColor',
						['pop']						=	'ns0000:POP',
						['usersetting']				=	'ns0000:PSUser',
						['clpsimulation7']			=	'ns0000:CLPSimulation7',
						['clpsimulation4']			=	'ns0000:CLPSimulation4',
						['clpsimulation1']			=	'ns0000:CLPSimulation1',
						['clpsimulation6']			=	'ns0000:CLPSimulation6',
						['clpsimulation3']			=	'ns0000:CLPSimulation3',
						['clpsimulation5']			=	'ns0000:CLPSimulation5',
						['clpsimulation9']			=	'ns0000:CLPSimulation9',
						['clpsimulation2']			=	'ns0000:CLPSimulation2',
						['clpsimulation8']			=	'ns0000:CLPSimulation8',
						['custom1photograph']		=	'ns0000:Custom1Photograph',
						['custom1business']			=	'ns0000:Custom1Business',
						['custom1colorimetric']		=	'ns0000:Custom1Colorimetric',
						['custom2photograph']		=	'ns0000:Custom2Photograph',
						['custom2business']			=	'ns0000:Custom2Business',
						['custom2colorimetric']		=	'ns0000:Custom2Colorimetric',
						['off']						=	'ns0000:None',
						['manual']					=	'ns0000:Manual',
						['useicm']					=	'ns0000:UseICM',
						['automaticgray']			=	'ns0000:AutomaticGray',
						['coloruniversaldesign']	=	'ns0000:ColorUniversalDesign'
					},
					default	=	{ 'item', 'ns0000:Auto' }
				}
			}
		}
	},
	-- 03-01 Color Profile :: ALL(RPCS)
	pcp_colorprofile	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageColorProfile'
		},
		children	=	function( tbl )
			local val = tbl.pcp_colorprofile

			local retVal = 
			{
				tag			=	'psf:Option',
				attribute	=
				{
					key		=	'name',
					value	=	( function()
						local t	=
						{
							['automatic']				=	'ns0000:Auto',
							['automaticbright']			=	'ns0000:AutomaticBright',
							['automaticdeep']			=	'ns0000:AutomaticDeep',
							['text']					=	'ns0000:Text',
							['textbright']				=	'ns0000:TextBright',
							['textdeep']				=	'ns0000:TextDeep',
							['photographic']			=	'ns0000:Photographic',
							['photographicbright']		=	'ns0000:PhotographicBright',
							['photographicdeep']		=	'ns0000:PhotographicDeep',
							['presentation']			=	'ns0000:Presentation',
							['presentationbright']		=	'ns0000:PresentationBright',
							['presentationdeep']		=	'ns0000:PresentationDeep',
							['cad']						=	'ns0000:AutoCADDocument',
							['solidcolor']				=	'ns0000:SolidColor',
							['usersetting']				=	'ns0000:PSUser',
							['pop']						=	'ns0000:POP',
							['clpsimulation7']			=	'ns0000:CLPSimulation7',
							['clpsimulation4']			=	'ns0000:CLPSimulation4',
							['clpsimulation1']			=	'ns0000:CLPSimulation1',
							['clpsimulation6']			=	'ns0000:CLPSimulation6',
							['clpsimulation3']			=	'ns0000:CLPSimulation3',
							['clpsimulation5']			=	'ns0000:CLPSimulation5',
							['clpsimulation9']			=	'ns0000:CLPSimulation9',
							['clpsimulation2']			=	'ns0000:CLPSimulation2',
							['custom1photograph']		=	'ns0000:Custom1Photograph',
							['custom1business']			=	'ns0000:Custom1Business',
							['custom1colorimetric']		=	'ns0000:Custom1Colorimetric',
							['custom2photograph']		=	'ns0000:Custom2Photograph',
							['custom2business']			=	'ns0000:Custom2Business',
							['custom2colorimetric']		=	'ns0000:Custom2Colorimetric',
							['off']						=	'ns0000:None',
							['manual']					=	'ns0000:Manual',
							['useicm']					=	'ns0000:UseICM',
							['automaticgray']			=	'ns0000:AutomaticGray',
							['coloruniversaldesign']	=	'ns0000:ColorUniversalDesign'
						}

						return t[ val ] and t[ val ] or 'ns0000:AddProfile'
					end )()
				}
			}

			if 'ns0000:AddProfile' == retVal.attribute.value then
				retVal.children =
				{
					tag 		=	'psf:ScoredProperty',
					attribute	=
					{
						key 	=	'name',
						value 	=	'ns0000:ProfileName'
					},
					children	=
					{
						tag 		=	'psf:Value',
						attribute	=
						{
							key 	=	'xsi:type',
							value 	=	'xsd:string'
						},
						text 		=	val
					}
				}
			end

			return retVal
		end
	},
	-- 03-02 Color Profile :: Object[Text](PS,PCL)
	text_colorprofile	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageColorProfileForText'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					text_colorprofile	=
					{
						['off']				=	'ns0000:None',
						['text']			=	'ns0000:Text',
						['textbright']			=	'ns0000:TextBright',
						['textdeep']			=	'ns0000:TextDeep',
						['presentation']	=	'ns0000:Presentation',
						['presentationbright']	=	'ns0000:PresentationBright',
						['presentationdeep']	=	'ns0000:PresentationDeep',
						['photographic']	=	'ns0000:Photographic',
						['photographicbright']	=	'ns0000:PhotographicBright',
						['photographicdeep']	=	'ns0000:PhotographicDeep',
						['pop']				=	'ns0000:POP',
						['clpsimulation7']	=	'ns0000:CLPSimulation7',
						['clpsimulation4']	=	'ns0000:CLPSimulation4',
						['clpsimulation1']	=	'ns0000:CLPSimulation1',
						['clpsimulation6']	=	'ns0000:CLPSimulation6',
						['clpsimulation3']	=	'ns0000:CLPSimulation3',
						['clpsimulation5']	=	'ns0000:CLPSimulation5',
						['clpsimulation9']	=	'ns0000:CLPSimulation9',
						['clpsimulation2']	=	'ns0000:CLPSimulation2',
						['clpsimulation8']	=	'ns0000:CLPSimulation8',
						['chinared']		=	'ns0000:CustomRed'
					},
					default	=	{ 'item', 'ns0000:Text' }
				}
			}
		}
	},
	-- 03-02 Color Profile :: Object[Text](RPCS)
	pcp_text_colorprofile	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageColorProfileForText'
		},
		children	=	function( tbl )
			local val = tbl.pcp_text_colorprofile

			local retVal = 
			{
				tag			=	'psf:Option',
				attribute	=
				{
					key		=	'name',
					value	=	( function()
						local t	=
						{
							['off']				=	'ns0000:None',
							['text']			=	'ns0000:Text',
							['textbright']			=	'ns0000:TextBright',
							['textdeep']			=	'ns0000:TextDeep',
							['presentation']	=	'ns0000:Presentation',
							['presentationbright']	=	'ns0000:PresentationBright',
							['presentationdeep']	=	'ns0000:PresentationDeep',
							['photographic']	=	'ns0000:Photographic',
							['photographicbright']	=	'ns0000:PhotographicBright',
							['photographicdeep']	=	'ns0000:PhotographicDeep',
							['pop']				=	'ns0000:POP',
							['clpsimulation7']	=	'ns0000:CLPSimulation7',
							['clpsimulation4']	=	'ns0000:CLPSimulation4',
							['clpsimulation1']	=	'ns0000:CLPSimulation1',
							['clpsimulation6']	=	'ns0000:CLPSimulation6',
							['clpsimulation3']	=	'ns0000:CLPSimulation3',
							['clpsimulation5']	=	'ns0000:CLPSimulation5',
							['clpsimulation9']	=	'ns0000:CLPSimulation9',
							['clpsimulation2']	=	'ns0000:CLPSimulation2',
							['chinared']		=	'ns0000:CustomRed'
						}

						return t[ val ] and t[ val ] or 'ns0000:AddProfile'
					end )()
				}
			}

			if 'ns0000:AddProfile' == retVal.attribute.value then
				retVal.children =
				{
					tag 		=	'psf:ScoredProperty',
					attribute	=
					{
						key 	=	'name',
						value 	=	'ns0000:ProfileName'
					},
					children	=
					{
						tag 		=	'psf:Value',
						attribute	=
						{
							key 	=	'xsi:type',
							value 	=	'xsd:string'
						},
						text 		=	val
					}
				}
			end

			return retVal
		end
	},
	-- 03-02 Color Profile :: Object[Photo](PS,PCL)
	photo_colorprofile	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageColorProfileForPhoto'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					photo_colorprofile	=
					{
						['off']				=	'ns0000:None',
						['text']			=	'ns0000:Text',
						['textbright']			=	'ns0000:TextBright',
						['textdeep']			=	'ns0000:TextDeep',
						['presentation']	=	'ns0000:Presentation',
						['presentationbright']	=	'ns0000:PresentationBright',
						['presentationdeep']	=	'ns0000:PresentationDeep',
						['photographic']	=	'ns0000:Photographic',
						['photographicbright']	=	'ns0000:PhotographicBright',
						['photographicdeep']	=	'ns0000:PhotographicDeep',
						['pop']				=	'ns0000:POP',
						['clpsimulation7']	=	'ns0000:CLPSimulation7',
						['clpsimulation4']	=	'ns0000:CLPSimulation4',
						['clpsimulation1']	=	'ns0000:CLPSimulation1',
						['clpsimulation6']	=	'ns0000:CLPSimulation6',
						['clpsimulation3']	=	'ns0000:CLPSimulation3',
						['clpsimulation5']	=	'ns0000:CLPSimulation5',
						['clpsimulation9']	=	'ns0000:CLPSimulation9',
						['clpsimulation2']	=	'ns0000:CLPSimulation2',
						['clpsimulation8']	=	'ns0000:CLPSimulation8',
						['chinared']		=	'ns0000:CustomRed'
					},
					default	=	{ 'item', 'ns0000:Photographic' }
				}
			}
		}
	},
	-- 03-02 Color Profile :: Object[Photo](RPCS)
	pcp_photo_colorprofile	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageColorProfileForPhoto'
		},
		children	=	function( tbl )
			local val = tbl.pcp_photo_colorprofile

			local retVal = 
			{
				tag			=	'psf:Option',
				attribute	=
				{
					key		=	'name',
					value	=	( function()
						local t	=
						{
							['off']				=	'ns0000:None',
							['text']			=	'ns0000:Text',
							['textbright']			=	'ns0000:TextBright',
							['textdeep']			=	'ns0000:TextDeep',
							['presentation']	=	'ns0000:Presentation',
							['presentationbright']	=	'ns0000:PresentationBright',
							['presentationdeep']	=	'ns0000:PresentationDeep',
							['photographic']	=	'ns0000:Photographic',
							['photographicbright']	=	'ns0000:PhotographicBright',
							['photographicdeep']	=	'ns0000:PhotographicDeep',
							['pop']				=	'ns0000:POP',
							['clpsimulation7']	=	'ns0000:CLPSimulation7',
							['clpsimulation4']	=	'ns0000:CLPSimulation4',
							['clpsimulation1']	=	'ns0000:CLPSimulation1',
							['clpsimulation6']	=	'ns0000:CLPSimulation6',
							['clpsimulation3']	=	'ns0000:CLPSimulation3',
							['clpsimulation5']	=	'ns0000:CLPSimulation5',
							['clpsimulation9']	=	'ns0000:CLPSimulation9',
							['clpsimulation2']	=	'ns0000:CLPSimulation2',
							['chinared']		=	'ns0000:CustomRed'
						}

						return t[ val ] and t[ val ] or 'ns0000:AddProfile'
					end )()
				}
			}

			if 'ns0000:AddProfile' == retVal.attribute.value then
				retVal.children =
				{
					tag 		=	'psf:ScoredProperty',
					attribute	=
					{
						key 	=	'name',
						value 	=	'ns0000:ProfileName'
					},
					children	=
					{
						tag 		=	'psf:Value',
						attribute	=
						{
							key 	=	'xsi:type',
							value 	=	'xsd:string'
						},
						text 		=	val
					}
				}
			end

			return retVal
		end
	},
	-- 03-02 Color Profile :: Object[Graphics](PS,PCL)
	graphics_colorprofile	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageColorProfileForGraphics'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					graphics_colorprofile	=
					{
						['off']				=	'ns0000:None',
						['text']			=	'ns0000:Text',
						['textbright']			=	'ns0000:TextBright',
						['textdeep']			=	'ns0000:TextDeep',
						['presentation']	=	'ns0000:Presentation',
						['presentationbright']	=	'ns0000:PresentationBright',
						['presentationdeep']	=	'ns0000:PresentationDeep',
						['photographic']	=	'ns0000:Photographic',
						['photographicbright']	=	'ns0000:PhotographicBright',
						['photographicdeep']	=	'ns0000:PhotographicDeep',
						['pop']				=	'ns0000:POP',
						['clpsimulation7']	=	'ns0000:CLPSimulation7',
						['clpsimulation4']	=	'ns0000:CLPSimulation4',
						['clpsimulation1']	=	'ns0000:CLPSimulation1',
						['clpsimulation6']	=	'ns0000:CLPSimulation6',
						['clpsimulation3']	=	'ns0000:CLPSimulation3',
						['clpsimulation5']	=	'ns0000:CLPSimulation5',
						['clpsimulation9']	=	'ns0000:CLPSimulation9',
						['clpsimulation2']	=	'ns0000:CLPSimulation2',
						['clpsimulation8']	=	'ns0000:CLPSimulation8',
						['chinared']		=	'ns0000:CustomRed'
					},
					default	=	{ 'item', 'ns0000:Presentation' }
				}
			}
		}
	},
	-- 03-02 Color Profile :: Object[Graphics](RPCS)
	pcp_graphics_colorprofile	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageColorProfileForGraphics'
		},
		children	=	function( tbl )
			local val = tbl.pcp_graphics_colorprofile

			local retVal = 
			{
				tag			=	'psf:Option',
				attribute	=
				{
					key		=	'name',
					value	=	( function()
						local t	=
						{
							['off']				=	'ns0000:None',
							['text']			=	'ns0000:Text',
							['textbright']			=	'ns0000:TextBright',
							['textdeep']			=	'ns0000:TextDeep',
							['presentation']	=	'ns0000:Presentation',
							['presentationbright']	=	'ns0000:PresentationBright',
							['presentationdeep']	=	'ns0000:PresentationDeep',
							['photographic']	=	'ns0000:Photographic',
							['photographicbright']	=	'ns0000:PhotographicBright',
							['photographicdeep']	=	'ns0000:PhotographicDeep',
							['pop']				=	'ns0000:POP',
							['clpsimulation7']	=	'ns0000:CLPSimulation7',
							['clpsimulation4']	=	'ns0000:CLPSimulation4',
							['clpsimulation1']	=	'ns0000:CLPSimulation1',
							['clpsimulation6']	=	'ns0000:CLPSimulation6',
							['clpsimulation3']	=	'ns0000:CLPSimulation3',
							['clpsimulation5']	=	'ns0000:CLPSimulation5',
							['clpsimulation9']	=	'ns0000:CLPSimulation9',
							['clpsimulation2']	=	'ns0000:CLPSimulation2',
							['chinared']		=	'ns0000:CustomRed'
						}

						return t[ val ] and t[ val ] or 'ns0000:AddProfile'
					end )()
				}
			}

			if 'ns0000:AddProfile' == retVal.attribute.value then
				retVal.children =
				{
					tag 		=	'psf:ScoredProperty',
					attribute	=
					{
						key 	=	'name',
						value 	=	'ns0000:ProfileName'
					},
					children	=
					{
						tag 		=	'psf:Value',
						attribute	=
						{
							key 	=	'xsi:type',
							value 	=	'xsd:string'
						},
						text 		=	val
					}
				}
			end

			return retVal
		end
	},
	-- 03-03 ICM Intent(PS)
	icmintent 	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'psk:PageICMRenderingIntent'
		},
		children = {
			tag 		=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					icmintent	=
					{
						['saturation']			=	'psk:BusinessGraphics',
						['perceptual']			=	'psk:Photographs',
						['relativecolormetric']	=	'psk:RelativeColorimetric',
						['absolutecolormetric']	=	'psk:AbsoluteColorimetric',
					}
				}
			}
		}
	},
	-- 03-03 ICM Intent(RPCS)
	pcp_icmintent 	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'psk:PageICMRenderingIntent'
		},
		children = {
			tag 		=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					pcp_icmintent	=
					{
						['saturation']			=	'psk:BusinessGraphics',
						['perceptual']			=	'psk:Photographs',
						['relativecolormetric']	=	'psk:RelativeColorimetric',
						['absolutecolormetric']	=	'psk:AbsoluteColorimetric',
					}
				}
			}
		}
	},
	-- 03-04 CMYK Simulation Profile
	cmyksimulationprofile 	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'ns0000:DocumentRcmyksimulation'
		},
		children = {
			tag 		=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					cmyksimulationprofile	=
					{
						['off']				=	'ns0000:Off',
						['usoffsetprint']	=	'ns0000:USOffsetPrint',
						['euroscale']		=	'ns0000:Euroscale',
						['japancolor']		=	'ns0000:JapanColor',
						['jmpa']			=	'ns0000:JPMA',
						['pantone']			=	'ns0000:PANTONE',
						['trans01']			=	'ns0000:Trans01',
						['custom1']			=	'ns0000:Custom1',
						['custom2']			=	'ns0000:Custom2',
						['custom3']			=	'ns0000:Custom3',
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 03-05 Color Profile Distribution (PS)
	colorprofile_distribution 	=
	{
		{
			tag 		= 	'psf:Feature',
			attribute	=
			{
				key 	=	'name',
				value 	= 	'ns0000:PageColorProfileDistribution'
			},
			children = {
				tag 		=	'psf:Option',
				attribute	=
				{
					key		=	'name',
					value	=
					{
						colorprofile_distribution	=
						{
							['host']				=	'ns0000:Host',
							['printer']				=	'ns0000:Printer',
							['printercalibration']	=	'ns0000:PrinterCalibration',
						}
					}
				}
			}
		},
		{
			tag 		= 	'psf:Feature',
			attribute	=
			{
				key 	=	'name',
				value 	= 	'psk:PageColorManagement'
			},
			children = {
				tag 		=	'psf:Option',
				attribute	=
				{
					key		=	'name',
					value	=	function(tbl)
					
						if(nil ~= tbl['printqualityadjustment']) then
							if('advanced' == tbl['printqualityadjustment'] and 'setallobject' ~= tbl['colorprofile_setting']) then
								return 'psk:None'
							elseif( ('standard' == tbl['printqualityadjustment']) or
									('advanced' == tbl['printqualityadjustment'] and 'setallobject' == tbl['colorprofile_setting']) ) then
								if((nil ~= tbl['colorprofile'] and 'useicm' ~= tbl['colorprofile']) or (nil ~= tbl['pcp_colorprofile'] and 'useicm' ~= tbl['pcp_colorprofile']))then
									return 'psk:None'
								end
							end
						else
							if((nil ~= tbl['colorprofile'] and 'useicm' ~= tbl['colorprofile']) or (nil ~= tbl['pcp_colorprofile'] and 'useicm' ~= tbl['pcp_colorprofile']))then
								return 'psk:None'
							end
						end
						
						local management_table	=
						{
							['host']				=	'psk:System',
							['printer']				=	'psk:Driver',
							['printercalibration']	=	'psk:Device',
						}
						
						return management_table[tbl['colorprofile_distribution']]
					end
				}
			}
		}
	},
	-- 03-05 Color Profile Distribution (RPCS)
	pcp_distribution 	=
	{
		{
			tag 		= 	'psf:Feature',
			attribute	=
			{
				key 	=	'name',
				value 	= 	'psk:PageColorManagement'
			},
			children =
			{
				tag 		=	'psf:Option',
				attribute	=
				{
					key		=	'name',
					value	=	function(tbl)
						if(nil ~= tbl['printqualityadjustment']) then
							if('advanced' == tbl['printqualityadjustment'] and 'setallobject' ~= tbl['colorprofile_setting']) then
								return 'psk:None'
							elseif( ('standard' == tbl['printqualityadjustment']) or
									('advanced' == tbl['printqualityadjustment'] and 'setallobject' == tbl['colorprofile_setting']) ) then
								if((nil ~= tbl['colorprofile'] and 'useicm' ~= tbl['colorprofile']) or (nil ~= tbl['pcp_colorprofile'] and 'useicm' ~= tbl['pcp_colorprofile']))then
									return 'psk:None'
								end
							end
						else
							if((nil ~= tbl['colorprofile'] and 'useicm' ~= tbl['colorprofile']) or (nil ~= tbl['pcp_colorprofile'] and 'useicm' ~= tbl['pcp_colorprofile']))then
								return 'psk:None'
							end
						end
						
						local management_table	=
						{
							['host']				=	'psk:System',
							['printer']				=	'psk:Driver',
							['printercalibration']	=	'psk:Device',
							['printerdriver']		=	'psk:Driver'
						}
						return management_table[tbl['pcp_distribution']] and management_table[tbl['pcp_distribution']] or management_table['host']
					end
				}
			}
		},
		{
			tag 		= 	'psf:Feature',
			attribute	=
			{
				key 	=	'name',
				value 	= 	'ns0000:PageColorProfileDistribution'
			},
			children =
			{
				tag 		=	'psf:Option',
				attribute	=
				{
					key		=	'name',
					value	=	function(tbl)
						local management_table	=
						{
							['host']				=	'ns0000:Host',
							['printer']				=	'ns0000:Printer',
							['printercalibration']	=	'ns0000:PrinterCalibration',
							['printerdriver']		=	'ns0000:PrinterDriver',
						}
						return management_table[tbl['pcp_distribution']] and management_table[tbl['pcp_distribution']] or management_table['host']
					end
				}
			}
		}
	},
	-- 04 Gray Reproduction
	grayreproduction	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobGrayReproduction'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					grayreproduction	=
					{
						['kblack']						=	'ns0000:BlackForAllObjects',
						['cmyk']						=	'ns0000:CMYK',
						['kblackfortext']				=	'ns0000:BlackForTextOnly',
						['kblackperdot']				=	'ns0000:BlackForGrayPixelsOnly',
						['kblackperpage']				=	'ns0000:BlackForGrayPageOnly',
						['kblackonlypureblack']			=	'ns0000:BlackOnlyPureBlack',
						['kblackonlypureblackfortext']	=	'ns0000:BlackOnlyPureBlackForText',
						['kblackbyprofile']				=	'ns0000:BlackByProfile',
						['kblackfortextandgraphic']		=	'ns0000:BlackForTextAndGraphic',
						['kblackforallobject']			=	'ns0000:BlackAndUCRForAllObjects',
						['auto']						=	'ns0000:Auto'
					},
					default	=	{ 'item', 'ns0000:BlackForAllObjects' }
				}
			}
		}
	},
	-- 05 Dithering
	dithering_setting	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobDitheringSelectObject'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					dithering_setting	=
					{
						['setallobject']	=	'ns0000:SetAllObject',
						['seteachobject']	=	'ns0000:SetEachObject'
					},
					default	=	{ 'item', 'ns0000:SetAllObject' }
				}
			}
		}
	},
	-- 05-01 Dithering :: All
	dithering	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobDither'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					dithering	=
					{
						['automatic']							=	'ns0000:Auto',
						['photographic']						=	'ns0000:Photographic',
						['text']								=	'ns0000:Text',
						['textline']							=	'ns0000:Line',
						['cad']									=	'ns0000:CAD',
						['usersetting']							=	'ns0000:User',
						['multilevel']							=	'ns0000:Multi-Level',
						['automaticuseerrordiffusionimage']		=	'ns0000:Auto_ErrorDiffusionImageOnly',
						['photographicuseerrordiffusionimage']	=	'ns0000:Photographic_ErrorDiffusionImageOnly',
						['textuseerrordiffusionimage']			=	'ns0000:Text_ErrorDiffusionImageOnly',
						['textlineuseerrordiffusionimage']		=	'ns0000:Line_ErrorDiffusionImageOnly',
						['automaticuseerrordiffusionall']		=	'ns0000:Auto_ErrorDiffusionAllObject',
						['photographicuseerrordiffusionall']	=	'ns0000:Photographic_ErrorDiffusionAllObject',
						['textuseerrordiffusionall']			=	'ns0000:Text_ErrorDiffusionAllObject',
						['textlineuseerrordiffusionall']		=	'ns0000:Line_ErrorDiffusionAllObject',
						['manual']								=	'ns0000:Manual'
					},
					default	=	{ 'item', 'ns0000:Auto' }
				}
			}
		}
	},
	-- 05-02 Dithering :: Object[Text]
	text_dithering	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobDitherForText'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					text_dithering	=
					{
						['text']			=	'ns0000:Text',
						['photographic']	=	'ns0000:Photographic',
						['textline']		=	'ns0000:Line',
						['multilevel']		=	'ns0000:Multi-Level'
					},
					default	= { 'item', 'ns0000:Text' }
				}
			}
		}
	},
	-- 05-02 Dithering :: Object[Photo]
	photo_dithering	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobDitherForPhoto'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					photo_dithering	=
					{
						['text']			=	'ns0000:Text',
						['photographic']	=	'ns0000:Photographic',
						['textline']		=	'ns0000:Line'
					},
					default	=	{ 'item', 'ns0000:Photographic' }
				}
			}
		}
	},
	-- 05-02 Dithering :: Object[Graphics]
	graphics_dithering	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobDitherForGraphics'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					graphics_dithering	=
					{
						['text']			=	'ns0000:Text',
						['photographic']	=	'ns0000:Photographic',
						['textline']		=	'ns0000:Line',
						['multilevel']		=	'ns0000:Multi-Level'
					},
					default	=	{ 'item', 'ns0000:Photographic' }
				}
			}
		}
	},
	-- 05-03 Enlarge Dither Brush Pattern
	dithering_enlargebrushpattern 	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'ns0000:JobEnlargeDitherBrushPattern'
		},
		children = {
			tag 		=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					dithering_enlargebrushpattern	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
					}
				}
			}
		}
	},
	-- 05-04 Shift Dither Brush Position
	dithering_shiftbrushpattern	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'ns0000:JobShiftDitherBrushPosition'
		},
		children = {
			tag 		=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					dithering_shiftbrushpattern	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
					}
				}
			}
		}
	},
	-- 06 Balance Adjustment
	balanceadjustment	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	=	'ns0000:JobBalanceAdjustment'
		},
		children	=
		{
			tag 		=	'psf:Option',
			attribute	=
			{
				key 	=	'name',
				value 	=
				{
					balanceadjustment	=
					{
						['setallobject']		=	'ns0000:SetAllObject',
						['seteachobject']		=	'ns0000:SetEachObject',
					}
				}
			},
			children	=	function(tbl)
								local scored_table = {}
								
								if('setallobject' == tbl['balanceadjustment'])then
								-- All Object
									---AllBrightness--
									if(nil ~= tbl['all_brightness'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:BrightnessAll'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['all_brightness']
														}
													}
											}
										)
									end
									---AllContrast--
									if(nil ~= tbl['all_contrast'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ContrastAll'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['all_contrast']
														}
													}
											}
										)
									end
									---AllSaturation--
									if(nil ~= tbl['all_saturation'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:SaturationAll'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['all_saturation']
														}
													}
											}
										)
									end
									---AllColorBalanceRed--
									if(nil ~= tbl['all_colorbalance_red'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceRAll'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['all_colorbalance_red']
														}
													}
											}
										)
									end
									---AllColorBalanceGreen--
									if(nil ~= tbl['all_colorbalance_green'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceGAll'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['all_colorbalance_green']
														}
													}
											}
										)
									end
									---AllColorBalanceBlue--
									if(nil ~= tbl['all_colorbalance_blue'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceBAll'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['all_colorbalance_blue']
														}
													}
											}
										)
									end
								else
								-- Each Object
									---TextBrightness--
									if(nil ~= tbl['text_brightness'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:BrightnessText'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['text_brightness']
														}
													}
											}
										)
									end
									---TextContrast--
									if(nil ~= tbl['text_contrast'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ContrastText'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['text_contrast']
														}
													}
											}
										)
									end
									---TextSaturation--
									if(nil ~= tbl['text_saturation'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:SaturationText'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['text_saturation']
														}
													}
											}
										)
									end
									---TextColorBalanceRed--
									if(nil ~= tbl['text_colorbalance_red'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceRText'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['text_colorbalance_red']
														}
													}
											}
										)
									end
									---TextColorBalanceGreen--
									if(nil ~= tbl['text_colorbalance_green'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceGText'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['text_colorbalance_green']
														}
													}
											}
										)
									end
									---TextColorBalanceBlue--
									if(nil ~= tbl['text_colorbalance_blue'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceBText'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['text_colorbalance_blue']
														}
													}
											}
										)
									end
									---PhotoBrightness--
									if(nil ~= tbl['photo_brightness'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:BrightnessPhoto'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['photo_brightness']
														}
													}
											}
										)
									end
									---PhotoContrast--
									if(nil ~= tbl['photo_contrast'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ContrastPhoto'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['photo_contrast']
														}
													}
											}
										)
									end
									---PhotoSaturation--
									if(nil ~= tbl['photo_saturation'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:SaturationPhoto'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['photo_saturation']
														}
													}
											}
										)
									end
									---PhotoColorBalanceRed--
									if(nil ~= tbl['photo_colorbalance_red'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceRPhoto'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['photo_colorbalance_red']
														}
													}
											}
										)
									end
									---PhotoColorBalanceGreen--
									if(nil ~= tbl['photo_colorbalance_green'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceGPhoto'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['photo_colorbalance_green']
														}
													}
											}
										)
									end
									---PhotoColorBalanceBlue--
									if(nil ~= tbl['photo_colorbalance_blue'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceBPhoto'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['photo_colorbalance_blue']
														}
													}
											}
										)
									end
									---GraphicsBrightness--
									if(nil ~= tbl['graphics_brightness'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:BrightnessGraphics'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['graphics_brightness']
														}
													}
											}
										)
									end
									---GraphicsContrast--
									if(nil ~= tbl['graphics_contrast'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ContrastGraphics'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['graphics_contrast']
														}
													}
											}
										)
									end
									---GraphicsSaturation--
									if(nil ~= tbl['graphics_saturation'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:SaturationGraphics'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['graphics_saturation']
														}
													}
											}
										)
									end
									---GraphicsColorBalanceRed--
									if(nil ~= tbl['graphics_colorbalance_red'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceRGraphics'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['graphics_colorbalance_red']
														}
													}
											}
										)
									end
									---GraphicsColorBalanceGreen--
									if(nil ~= tbl['graphics_colorbalance_green'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceGGraphics'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['graphics_colorbalance_green']
														}
													}
											}
										)
									end
									---GraphicsColorBalanceBlue--
									if(nil ~= tbl['graphics_colorbalance_blue'])then
										table.insert(scored_table,
											{
												tag			=	'psf:ScoredProperty',
												attribute	=
													{
														key		=	'name',
														value	=	'ns0000:ColorBalanceBGraphics'
													},
												children	=	{
														{
															tag			= 	'psf:Value',
															attribute	=
																{
																	key		=	'xsi:type',
																	value	=	'xsd:integer'
																},
															text	=	tbl['graphics_colorbalance_blue']
														}
													}
											}
										)
									end
								end
								
								return scored_table
							end
		}
	},
	-- 07 Resolution
	resolution	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:PageResolution'
		},
		children	=
		{
			tag 		=	'psf:Option',
			attribute	=
			{
				key 	=	'name',
				value	=
				{
					resolution	=
					{
						['200']						=	'ns0000:_200dpi',
						['300']						=	'ns0000:_300dpi',
						['300p1m1']						=	'ns0000:_300dpi_P1_M1',
						['400']						=	'ns0000:_400dpi',
						['300to600']				=	'ns0000:_300to600dpi',
						['300x300to38400x600']		=	'ns0000:_300x300to38400x600',
						['600']						=	'ns0000:_600dpi',
						['1200x600']				=	'ns0000:_1200x600',
						['600x1200']				=	'ns0000:_600x1200',
						['2400x600']				=	'ns0000:_2400x600',
						['9600x600']				=	'ns0000:_9600x600',
						['38400x600']				=	'ns0000:_38400x600',
						['1200']					=	'ns0000:_1200dpi',
						['4800x1200']				=	'ns0000:_4800x1200',
						['150x150to300x150p1m1']	=	'ns0000:_150x150to300x150dpi_P1_M1',
						['300x300to600x300p1m2']	=	'ns0000:_300x300to600x300dpi_P1_M2',
						['300x300to600x300p1m5']	=	'ns0000:_300x300to600x300dpi_P1_M5',
						['600p1m2']					=	'ns0000:_600dpi_P1_M2',
						['600p1m5']					=	'ns0000:_600dpi_P1_M5',
						['600p2m2']					=	'ns0000:_600dpi_P2_M2',
						['600pf1b2m2']				=	'ns0000:_600dpi_PF1B2_M2',
						['600p2m2fy']				=	'ns0000:_600dpi_P2_M2_FY',
						['1200p2m4']				=	'ns0000:_1200dpi_P2_M4',
						['1200p4m4']					=	'ns0000:_1200dpi_P4_M4',
						['1200x1200to4800x1200p16m4']	=	'ns0000:_1200x1200to4800x1200dpi_P16_M4'
					},
					default	=	{ 'item', 'ns0000:_600dpi' }
				}
			},
			children	=
			{
				{
					tag 		=	'psf:ScoredProperty',
					attribute	=
					{
						key 	=	'name',
						value	=	'psk:ResolutionX'
					},
					children	=
					{
						tag 		=	'psf:Value',
						attribute	=
						{
							key 	=	'xsi:type',
							value	=	'xsd:integer'
						},
						text		=	function(tbl)
											local t =
											{
												['200']			=	'200',
												['300']			=	'300',
												['300p1m1']						=	'300',
												['400']			=	'400',
												['300to600']	=	'300',
												['300x300to38400x600']	=	'300',
												['600']			=	'600',
												['1200x600']	=	'600',
												['600x1200']	=	'600',
												['2400x600']	=	'600',
												['9600x600']	=	'600',
												['38400x600']	=	'600',
												['1200']		=	'1200',
												['4800x1200']		=	'1200',
												['150x150to300x150p1m1']		=	'150',
												['300x300to600x300p1m2']		=	'300',
												['300x300to600x300p1m5']		=	'300',
												['600p1m2']		=	'600',
												['600p1m5']		=	'600',
												['600p2m2']		=	'600',
												['600pf1b2m2']		=	'600',
												['600p2m2fy']		=	'600',
												['1200p2m4']		=	'1200',
												['1200p4m4']					=	'1200',
												['1200x1200to4800x1200p16m4']	=	'1200'
											}
											return t[tbl.resolution] and t[tbl.resolution] or t['600']
										end
					}
				},
				{
					tag 		=	'psf:ScoredProperty',
					attribute	=
					{
						key 	=	'name',
						value	=	'psk:ResolutionY'
					},
					children	=
					{
						tag 		=	'psf:Value',
						attribute	=
						{
							key 	=	'xsi:type',
							value	=	'xsd:integer'
						},
						text		=	function(tbl)
											local t =
											{
												['200']			=	'200',
												['300']			=	'300',
												['300p1m1']						=	'300',
												['400']			=	'400',
												['300to600']	=	'300',
												['300x300to38400x600']	=	'300',
												['600']			=	'600',
												['1200x600']	=	'600',
												['600x1200']	=	'600',
												['2400x600']	=	'600',
												['9600x600']	=	'600',
												['38400x600']	=	'600',
												['1200']		=	'1200',
												['4800x1200']		=	'1200',
												['150x150to300x150p1m1']		=	'150',
												['300x300to600x300p1m2']		=	'300',
												['300x300to600x300p1m5']		=	'300',
												['600p1m2']		=	'600',
												['600p1m5']		=	'600',
												['600p2m2']		=	'600',
												['600pf1b2m2']		=	'600',
												['600p2m2fy']		=	'600',
												['1200p2m4']		=	'1200',
												['1200p4m4']					=	'1200',
												['1200x1200to4800x1200p16m4']	=	'1200'
											}

											return t[tbl.resolution] and t[tbl.resolution] or t['600']
										end
					}
				}
			}
		}
	},
	-- 08 Two Toner Print
	twotonerprint	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobTwoTonerPrint'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					twotonerprint	=
					{
						['off']				=	'ns0000:Off',
						['blackandcyan']	=	'ns0000:BlackAndCyan',
						['blackandmagenta']	=	'ns0000:BlackAndMagenta',
						['blackandyellow']	=	'ns0000:BlackAndYellow',
						['blackandred']		=	'ns0000:BlackAndRed',
						['redandblack']		=	'ns0000:RedAndBlack'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 10 Color Universal Design
	coloruniversaldesign	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobColorUniversalDesign'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					coloruniversaldesign	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 11 Image Processing
	imageprocessing	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'psk:PagePhotoPrintingIntent'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					imageprocessing	=
					{
						['standard']			=	'psk:PhotoDraft',
						['highquality']			=	'psk:PhotoStandard',
						['best']				=	'psk:PhotoBest',
						['normal']				=	'ns0000:PhotoNormal',
						['lowcompression']		=	'ns0000:PhotoHighQuality',
						['highcompression']		=	'ns0000:PhotoSpeed',
						['highestcompression']	=	'ns0000:PhotoHighSpeed'
					},
					default	=	{ 'item', 'psk:PhotoDraft' }
				}
			}
		}
	},
	-- 12 Vector/Raster
	graphicsmode	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobGraphicsMode'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					graphicsmode	=
					{
						['vector']	=	'ns0000:Vector',
						['raster']	=	'ns0000:Raster'
					},
					default	=	{ 'item', 'ns0000:Vector' }
				}
			}
		}
	},
	-- 13 Black Over Print
	blackoverprint	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobBlackOverPrint'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					blackoverprint	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 14 Edge Smoothing
	edgesmoothing	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobSmoothing'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					edgesmoothing	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 15 Print All Text as Black
	printalltextasblack	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'ns0000:JobPrintTextAsBlack'
		},
		children = {
			tag 		=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					printalltextasblack	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
					}
				}
			}
		}
	},
	-- 16 Fuser Setting
	fusersetting	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobFuserSetting'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					fusersetting	=
					{
						['standard']	=	'ns0000:Standard',
						['highquality']	=	'ns0000:HighQuality'
					},
					default	=	{ 'item', 'ns0000:Standard' }
				}
			}
		}
	},
	-- 18-01 Toner Saving
	tonersaving	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'ns0000:JobPrintDensity'
		},
		children = {
			tag 		=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					tonersaving	=
					{
						['off']			=	'ns0000:Off',
						['on']			=	'ns0000:On',
						['tonersave1']	=	'ns0000:Mode1',
						['tonersave2']	=	'ns0000:Mode2',
						['levelcolor']	=	'ns0000:LevelColor',
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 18-02 Enhanced Toner Saving
	enhancedtonersaving	=
	{
		tag			= 	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrintDensity'
		},
		children	=	function(tbl)
			local result_table = {}
		
			local tonersave_table	=
				{
					['off']			=	'ns0000:Off',
					['mediumlight']	=	'ns0000:MediumLight',
					['light']		=	'ns0000:Light',
					['manual']		=	'ns0000:Custom',
				}
			local tonersave_val = tonersave_table[tbl['enhancedtonersaving']]
			if(nil == tonersave_val)then
				tonersave_val = 'ns0000:Off'
			end
			
			table.insert(result_table,
				{
					tag			=	'psf:Option',
					attribute	=
					{
						key		=	'name',
						value	=	tonersave_val
					}
				}
			)
		
		-- Phase3
			-- TextTonerSave
			if(nil ~= tbl['text_tonersaving'])then
				local text_tonersave_table	=
					{
						['off']			=	'ns0000:Off',
						['mediumlight']	=	'ns0000:MediumLight',
						['light']		=	'ns0000:Light',
					}
				
				local text_tonersave_val = text_tonersave_table[tbl['text_tonersaving']]
				if(nil == text_tonersave_val)then
					text_tonersave_val = 'ns0000:Off'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CustomTextDensity'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	text_tonersave_val
							}
						}
					}
				)
			end
			
			-- PhotoTonerSave
			if(nil ~= tbl['photo_tonersaving'])then
				local photo_tonersave_table	=
					{
						['off']			=	'ns0000:Off',
						['mediumlight']	=	'ns0000:MediumLight',
						['light']		=	'ns0000:Light',
					}
				local photo_tonersave_val = photo_tonersave_table[tbl['photo_tonersaving']]
				if(nil == photo_tonersave_val)then
					photo_tonersave_val = 'ns0000:Off'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CustomPhotoDensity'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	photo_tonersave_val
							}
						}
					}
				)
			end
			
			-- GraphicsTonerSave
			if(nil ~= tbl['graphics_tonersaving'])then
				local graphics_tonersave_table	=
					{
						['off']			=	'ns0000:Off',
						['mediumlight']	=	'ns0000:MediumLight',
						['light']		=	'ns0000:Light',
					}
				local graphics_tonersave_val = graphics_tonersave_table[tbl['graphics_tonersaving']]
				if(nil == graphics_tonersave_val)then
					graphics_tonersave_val = 'ns0000:Off'
				end
				
				table.insert(result_table,
					{
						tag 		= 	'psf:Feature',
						attribute	=
						{
							key 	=	'name',
							value 	= 	'ns0000:CustomGraphicsDensity'
						},
						children = {
							tag 		=	'psf:Option',
							attribute	=
							{
								key		=	'name',
								value	=	graphics_tonersave_val
							}
						}
					}
				)
			end
		-- Phase4
			if( ( 'ns0000:Custom' == tonersave_val ) and tbl['text_tonersavingnum'] and tbl['photo_tonersavingnum'] and tbl['graphics_tonersavingnum'] )then
				result_table[ #result_table ]['children'] =
				{
					{
						tag 		=	'psf:ScoredProperty',
						attribute	=
						{
							key 	=	'name',
							value 	=	'ns0000:TextTonerSaveValue'
						},
						children	=
						{
							tag 		=	'psf:Value',
							attribute	=
							{
								key 	=	'xsi:type',
								value	=	'xsd:percent'
							},
							text		=	( function()
								local num = tonumber( tbl.text_tonersavingnum )
								if(num)then
									if( (num < 1) or (100 < num) )then
										num = 100
									end
								end
							return tostring( num and num or 100 )
							end )()
						}
					},
					{
						tag 		=	'psf:ScoredProperty',
						attribute	=
						{
							key 	=	'name',
							value 	=	'ns0000:PhotoTonerSaveValue'
						},
						children	=
						{
							tag 		=	'psf:Value',
							attribute	=
							{
								key 	=	'xsi:type',
								value	=	'xsd:percent'
							},
							text		=	( function()
								local num = tonumber( tbl.photo_tonersavingnum )
								if(num)then
									if( (num < 1) or (100 < num) )then
										num = 100
									end
								end
							return tostring( num and num or 100 )
							end )()
						}
					},
					{
						tag 		=	'psf:ScoredProperty',
						attribute	=
						{
							key 	=	'name',
							value 	=	'ns0000:GraphicsTonerSaveValue'
						},
						children	=
						{
							tag 		=	'psf:Value',
							attribute	=
							{
								key 	=	'xsi:type',
								value	=	'xsd:percent'
							},
							text		=	( function()
								local num = tonumber( tbl.graphics_tonersavingnum )
								if(num)then
									if( (num < 1) or (100 < num) )then
										num = 100
									end
								end
							return tostring( num and num or 100 )
							end )()
						}
					}
				}
			end
			return result_table
		end
	},
	-- 18-03 Economy Color Mode
	economycolormode 	=
	{
		tag 		= 	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	= 	'ns0000:JobEconomyColorMode'
		},
		children = {
			tag 		=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					economycolormode	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On',
					}
				}
			}
		}
	},
	-- 19 Separate into CMYK[C]
	separateintocmyk_cyan	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PagePlaneSelectC'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					separateintocmyk_cyan	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:On' }
				}
			}
		}
	},
	-- 19 Separate into CMYK[M]
	separateintocmyk_magenta	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PagePlaneSelectM'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					separateintocmyk_magenta	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:On' }
				}
			}
		}
	},
	-- 19 Separate into CMYK[Y]
	separateintocmyk_yellow	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PagePlaneSelectY'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					separateintocmyk_yellow	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:On' }
				}
			}
		}
	},
	-- 19 Separate into CMYK[K]
	separateintocmyk_black	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PagePlaneSelectK'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					separateintocmyk_black	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:On' }
				}
			}
		}
	},
	-- 20 Adjust Photographs
	adjustphotographs	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobAdjustPhotographs'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					adjustphotographs	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 21 Bold Text
	boldtext	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobBoldText'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					boldtext	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 24 RGB revision
	rgbrevision	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:PageRGBRevision'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					rgbrevision	=
					{
						['off']			=	'ns0000:Off',
						['fine']		=	'ns0000:Fine',
						['superfine']	=	'ns0000:SuperFine'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 25 Image Smoothing
	imagesmoothing	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobImageSmoothing'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					imagesmoothing	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On',
						['auto']	=	'ns0000:Auto',
						['90ppi']	=	'ns0000:LessThan90ppi',
						['150ppi']	=	'ns0000:LessThan150ppi',
						['200ppi']	=	'ns0000:LessThan200ppi',
						['300ppi']	=	'ns0000:LessThan300ppi'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 31 Print density for particular media types
	printdensityforparticularmediatypes	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPlainPrintDensity'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					printdensityforparticularmediatypes	=
					{
						['optimize']	=	'ns0000:Optimize',
						['standard']	=	'ns0000:Standard',
						['light']		=	'ns0000:Light',
						['dark']		=	'ns0000:Dark'
					},
					default	=	{ 'item', 'ns0000:Standard' }
				}
			}
		}
	},
	-- 32 Uni-directional printing
	unidirectionalprinting	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobUniDirectionalPrintingOnly'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					unidirectionalprinting	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 33 Quality Balance Preset
	qualitybalancepreset	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobQualityBalancePreset'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					qualitybalancepreset	=
					{
						['highspeedlinedraw']	=	'ns0000:HighSpeedLineDraw',
						['highspeed']			=	'ns0000:HighSpeed',
						['speedpriority']		=	'ns0000:SpeedPriority',
						['qualitypriority']		=	'ns0000:QualityPriority',
						['highquality']			=	'ns0000:HighQuality',
						['manual']				=	'ns0000:Manual'
					},
					default	=	{ 'item', 'ns0000:SpeedPriority' }
				}
			}
		}
	},
	-- 34 Smooth low resolution images
	smoothlowresolutionimages	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobSmoothLowResolutionImages'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					smoothlowresolutionimages	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 37 Printer Head Position Setting
	printerheadposition	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrinterHeadPosition'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					printerheadposition	=
					{
						['auto']		=	'ns0000:Auto',
						['envelope']	=	'ns0000:Envelope'
					},
					default	=	{ 'item', 'ns0000:Auto' }
				}
			}
		}
	},
	
	-- 40 Print Darker For 2 Sided Print 
	printdarkerfor2sidedprint	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrintDarkerFor2SidedPrint'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					printdarkerfor2sidedprint	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	
	-- 41 Print black using 4 colors (CMYK)
	printblackusing4colors	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrintBlackUsing4Colors'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					printblackusing4colors	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},

	-- 42 Font Thickness Adjustment
	fontthicknessadjustment	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobFontThicknessAdjustment'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					fontthicknessadjustment	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},

	-- 43 Envelope Selector Position
	envelopeselectorposition	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobEnvelopeSelectorPosition'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					envelopeselectorposition	=
					{
						['normal']			=	'ns0000:Normal',
						['envelope']		=	'ns0000:Envelope',
						['printersetting']	=	'ns0000:PrinterSetting'
					},
					default	=	{ 'item', 'ns0000:Normal' }
				}
			}
		}
	},
	
	-- 45 Adjust Line Width
	adjustlinewidth	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobAdjustLineWidth'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					adjustlinewidth	=
					{
						['morethin']	=	'ns0000:MoreThin',
						['thin']		=	'ns0000:Thin',
						['off']			=	'ns0000:Off',
						['thick']		=	'ns0000:Thick',
						['morethick']	=	'ns0000:MoreThick'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},

-- [10 Driver Behavior]
	-- 02 Change Data Processing
	changedataprocessing	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobRPCSChangeDataProcessing'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					changedataprocessing	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 03 EMF Spool
	emfspool	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobSpoolFormat'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					emfspool	=
					{
						['off']	=	'ns0000:Raw',
						['on']	=	'ns0000:EMF'
					},
					default	=	{ 'item', 'ns0000:Raw' }
				}
			}
		}
	},
	-- 04 Job Load Distribution
	jobloaddistribution	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobRPCSLoadDistribution'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					jobloaddistribution	=
					{
						['shiftloadtodriver']	=	'ns0000:ShiftToDriver',
						['shiftloadtoprinter']	=	'ns0000:ShiftToPrinter'
					},
					default	=	{ 'item', 'ns0000:ShiftToDriver' }
				}
			}
		}
	},
	-- 06 Restore Emulation
	restoreemulation	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobEmulationMode'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					restoreemulation	=
					{
						['off']	=	'ns0000:None',
						['on']	=	'ns0000:LastUsed'
					},
					default	=	{ 'item', 'ns0000:None' }
				}
			}
		}
	},
	-- 07 Application Zoom
	applicationzoom	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobApplicationZoom'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					applicationzoom	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 08 Preview
	preview	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPreview'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					preview	=
					{
						['on']	=	'ns0000:On',
						['off']	=	'ns0000:Off'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	
	trackid	=
	{
		tag			=	'psf:ParameterInit',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobTrackID'
		},
		children	= function(tbl)
			return {
				tag			=	'psf:Value',
				attribute	=
				{
					key		=	'xsi:type',
					value	=	'xsd:string'
				},
				text	=	tbl['trackid']
			}
		end
	},
	
	-- 16 Fix dmColor
	fixdmcolor	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobFixdmColor'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					fixdmcolor	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	
	-- Output Compressed Data Except PJL
	outputcompresseddataexceptpjl	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobOutputCompressedDataExceptPJL'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					outputcompresseddataexceptpjl	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	
-- [24 Master Print Option]
	-- 01 Printer-side Operation
	printersideoperation	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobPrinterSideOperation'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					printersideoperation	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 02 Cycle Setting
	cyclesetting	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobCycleSetting'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					cyclesetting	=
					{
						['autocycle']			=	'ns0000:AutoCycle',
						['masterprintcycle']	=	'ns0000:MasterPrintCycle',
						['mastercycle']			=	'ns0000:MasterCycle',
						['originalpagecycle']	=	'ns0000:OriginalPageCycle'
					},
					default	=	{ 'item', 'ns0000:AutoCycle' }
				}
			}
		}
	},
	-- 03 Output Options
	outputoptionsetting	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobOutputOptionSetting'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					outputoptionsetting	=
					{
						['off']				=	'ns0000:Off',
						['jobseparator']	=	'ns0000:JobSeparator',
						['sort']			=	'ns0000:Sort'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 04 Skip Feed 
	skipfeed	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key 	=	'name',
			value 	=	'ns0000:JobSkipFeed'
		},
		children	=
		{
			tag 		=	'psf:Option',
			attribute	=
			{
				key 	=	'name',
				value	=
				{
					skipfeed	=
					{
						['off']		=	'ns0000:Off',
						['on']		=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			},
			children	=	function(tbl)
				if( 'off' == tbl.skipfeed or nil == tbl.skipfeednumber) then
					return nil
				end
					return {
								tag 		=	'psf:ScoredProperty',
								attribute	=
								{
									key 	=	'name',
									value	=	'ns0000:FeedNumber'
								},
								children	=
								{
									tag 		=	'psf:Value',
									attribute	=
									{
										key 	=	'xsi:type',
										value	=	'xsd:integer'
									},
									text		=	tostring(tbl.skipfeednumber)
								}
							}
				end
		}
	},
	-- 05 Economy Mode
	economymode	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobEconomyMode'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					economymode	=
					{
						['off']			=	'ns0000:Off',
						['level1']		=	'ns0000:Level1',
						['level2']		=	'ns0000:Level2'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 06 Speed Select
	speedselect	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobSpeedSelect'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					speedselect	=
					{
						['printspeed1']		=	'ns0000:PrintSpeed1',
						['printspeed2']		=	'ns0000:PrintSpeed2',
						['printspeed3']		=	'ns0000:PrintSpeed3',
						['printspeed4']		=	'ns0000:PrintSpeed4',
						['printspeed5']		=	'ns0000:PrintSpeed5',
						['printspeed6']		=	'ns0000:PrintSpeed6'
					}
				}
			}
		}
	},
	-- 07 Reset Printer Panel
	resetprinterpanel	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobResetPrinterPanel'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					resetprinterpanel	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
	-- 08 Enable Short Master
	enableshortmaster	=
	{
		tag			=	'psf:Feature',
		attribute	=
		{
			key		=	'name',
			value	=	'ns0000:JobEnableShortMaster'
		},
		children	=
		{
			tag			=	'psf:Option',
			attribute	=
			{
				key		=	'name',
				value	=
				{
					enableshortmaster	=
					{
						['off']	=	'ns0000:Off',
						['on']	=	'ns0000:On'
					},
					default	=	{ 'item', 'ns0000:Off' }
				}
			}
		}
	},
}
